  
"
    __________________________________________________
    @Alejandro F. Reimondo 05/12/98
    This proyect sources are property of : Alejandro F. Reimondo
    Its use is NOT legal without written rights.
    Amenabar 3476 Piso: 2 Dto: B.
    Ciudad de Buenos Aires.
    Argentina.
    Tel: (54)-1-703-5586.
    __________________________________________________
"
    (File pathName: 'RenderAX.Pol') fileIn;close.


    ARObject
        checkBound: 'vreg31w.sll'; "Interface to the Registration Database."
        checkBound: 'voleb31w.sll'; "Support for the basic Component Object Model (COM) used in OLE applications."
        checkBound: 'volec31w.sll'; "Support for building OLE container applications."
        checkBound: 'volea31w.sll'; "UNUSED? - Support for OLE automation."
        checkBound: 'vlstc31.sll'; "UNUSED? - Dialogs for making choice from lists in various presentations."
        checkBound: 'volex31w.sll'; "Support for using OLE controls (OCXs) and building OLE control container applications"
        "checkBound: 'volsx31w.sll'; UNUSED - OCX Samples"
        yourself.
!

ARObject subclass: #RenderAXObject
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !

RenderAXObject subclass: #RenderAXColorConverter
  instanceVariableNames: 
    ' source destination map '
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #RenderAXColorConverter) comment: '
    @1998, Alejandro F. Reimondo
    Color Mapping converter for DIBs.'   !

RenderAXColorConverter class instanceVariableNames: ' default '    !

RenderAXObject subclass: #RenderAXMap
  instanceVariableNames: 
    ' contents resources '
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #RenderAXMap) comment: '
    @1998, Alejandro F. Reimondo
    Maps are engine spaces that can be saved/loaded(freezed) with ObjectFiler.
    They can contain vital(standard) information for engine to run a space
    or a more "decorated" resources (non-standard bitmaps,textures,flats...).' !

RenderAXObject subclass: #RenderAXPointer
  instanceVariableNames: 
    ' pointer '
  classVariableNames: ''
  poolDictionaries: ''    !

RenderAXPointer subclass: #RenderAXDIB
  instanceVariableNames: 
    ' bitmapInfo '
  classVariableNames: ''
  poolDictionaries: 
    ' OperatingSystemConstants '    !

RenderAXPointer subclass: #RenderAXLocation
  instanceVariableNames: 
    ' position height angle sector '
  classVariableNames: ''
  poolDictionaries: '' !

RenderAXLocation subclass: #RenderAXPosition
  instanceVariableNames: 
    ' owner '
  classVariableNames: ''
  poolDictionaries: ''   !

RenderAXPointer subclass: #RenderAXModelObject
  instanceVariableNames: 
    ' id '
  classVariableNames: ''
  poolDictionaries: ''    !

RenderAXModelObject subclass: #RenderAXActor
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #RenderAXActor) comment: '
An actor is any object, movable or non-movable, within the engine.
An actor is defined by a series of textures that make up a "type info".
Examples of an actor include a monster, a sword, a barrel, etc.
Each actor has only one X,Y coordinate, and is always rendered flat toward the viewpoint.
An actor type defines which bitmaps are used to show the actor.
Each actor type has a directions and frames property.
The directions is the number of directions that this actor can be viewed from.
The frames is the number of each pose or animation.
The number of textures that must be supplied is (directions x frames).

Actor Properties:

Actor Picture
The picture on the upper left side of the screen displays the actor''s picture.
This picture can be changed by typing the corresponding number of the picture in the box below , or by using the up and down arrows to increment or decrement the number. 

Actor Flags
Self Illuminating : Actor is displayed at full brightness.
Pickup : This allows the actor to be picked up by another actor.
Walkover : This allows the actor to be walked over.
Spooky : This causes the actor to become translucent.
Autouse : User definable.
Usable : User definable.
Consumable : User definable
Auto Inc. : This causes the frame for the actor''s animation to be automatically incremented.
Shootable : This defines whether the actor can be shot.
Active : The actor is in use.
Hanging : The actor hangs from the ceiling rather than resting on the floor.
Ambulatory : This defines whether or not the actor moves.
No Render : The actor is not displayed in the scene.
Missile : Defines the actor as a missile.

Actor Properties
X : This is the X coordinate of the actor''s location.
Y  : This is the Y coordinate of the actor''s location.
Height : This is the height of the actor from floor.  This changes the height of the point of view of the actor.
Adjust :
Angle : This is the direction the actor is facing.  Remember that there are 1024 degrees (directions) in a full circle.
Current Frame : If the actor''s picture is animated, this determines the frame of the animation to display.

The remaining fields listed below are all user definable.
Tag, Do Type, Do Tag, Event, Talk Event, Range, Damage, Damage Base, Hit Points, Max Hit Points, and Perc Attack.  
'   !

RenderAXActor subclass: #DoomActor
  instanceVariableNames: 
    ' validTypes '
  classVariableNames: ''
  poolDictionaries: ''    !

RenderAXModelObject subclass: #RenderAXResource
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !

RenderAXResource subclass: #RenderAXActorType
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''   !

RenderAXResource subclass: #RenderAXBitmap
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''  !

RenderAXResource subclass: #RenderAXFlat
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''    !

RenderAXResource subclass: #RenderAXMetaTexture
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #RenderAXMetaTexture) comment: '
A texture is an image definition used by the engine to determine what pictures are shown on walls, and for actors.
A texture does not contain any actual image data - it is an abstract definition.
A texture is defined by a width and height, and the actual image data is defined by adding a series of bitmaps (referred to as patches).
The simplest type of texture has only one patch.
When a texture is defined with one patch, it renders faster.
The only drawback is that the patch must be exactly the same size of the texture, and start from location 0,0.
It is best to make most of your textures simple textures.
A multi-patch texture is much more flexible - and only a limited number of them can be rendered at a time.
multi-patch textures are cached, so having more than 32 different multi-patch textures in a scene can cause cache thrashing and significantly reduce rendering performance.
An example of a multi patch texture is a wall with a switch on it.
if you have sever wall textures, you can create a texture with a switch on it just by adding a "switch" patch to the texture definition.'    !

RenderAXModelObject subclass: #RenderAXValueObject
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''  !

RenderAXValueObject subclass: #RenderAXAngle
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''    !

RenderAXValueObject subclass: #RenderAXHeight
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''   !

RenderAXValueObject subclass: #RenderAXShear
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''    !

RenderAXValueObject subclass: #RenderAXSpacePart
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''    !

RenderAXSpacePart subclass: #RenderAXLine
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #RenderAXLine) comment: '
Each side of a sector is defined by a linedef (aWall).
A linedef is defined by two vertexes that describe the end points of the line segment.
A linedef has texture properties associated with it so that the renderer knows how to draw upper segments and lower segments.
In it''s simplest form, a linedef describes a wall.
However, it can also be used to initiate actions - such as lowering an elevator, opening a door etc.
A callback function is supplied, so that the programmer can also receive a message, and provide their own user-specific routines.

Wall properties
The wall properties screen contains definitions for the visual aspects of the wall as well as for how the actor can interact with the wall.

Main and Upper Wall Picture Tiles
The pictures on the left side of the screen display the main wall and upper wall textures respectively from top to bottom.  These pictures can be changed by typing the corresponding number of the tile in the box below the picture, or by using the up and down arrows to increment or decrement the number. 

Linedef Data
    From :    This is the vertex from which the wall begins.
    To :    This is the vertex on which the wall ends.
    Sector :    The sector this wall is attached to.
    Facing :    The sector from which the wall is visible.
    DoTag :    User Definable.
    DoType :    User Definable.
    Trip1-4 :    These fields are used for different purposes depending on the trip flag that is set.  For a description of the trip flags themselves refer to Trip Flags below.

    Trip Flags        Trip Values
    Floor u/d    1=Sector to change, 2=New floor height
    Ceiling u/d    3=Sector to change, 4=New ceiling height
    One Time    n/a
    Teleport    1=New X Coord., 2=New Y Coord., 3=New Z Coord., 4=New Angle
    Rotate Sector    1=Sector to Rotate, 2=X Coord. of pivot, 3=Y Coord. of pivot, 4=Degrees 
    Change Sector
    Flip Texture    n/a
    Unrotate sector    n/a
    Send Notification    n/a

General Flags
    Bounded : Denotes the edge of a sector.  This wall cannot be walked through and is visible.
    Trip/Cross : Trips an action when crossed by an actor.
    Trip/Activate : Trips an actions when actor manually activates it.
    Extend Ceiling : Draws ceiling instead of the wall.
    Not on Map : This line will not appear on the overhead map in the render window.
    Seen : The wall can be seen in the render window.
    Skip Ceiling : The Ceiling is not drawn by the renderer.
    Translucent : The wall becomes translucent.
    Impassable : If checked the actor cannot pass through the wall from the selected sector.
    *peg b :
    *peg t :
    Don''t Render : The wall will not be rendered in the render window.
    *user : user definable.

Trip Flags
For information about the values for the Trip 1 - 4 fields refer to Trip 1-4 above.
    Floor u/d : This allows the height of a floor in a sector to be changed when the line is passed. (The floor can be changed at the same time as the ceiling)
    Ceiling u/d : This allows the height of a ceiling in a sector to be changed when the line is passed. (The ceiling can be changed at the same time as the floor)
    One Time : If this is checked, the trip flag will only occur once.
    Teleport : This will cause the actor to be teleported to another coordinate when the line is crossed.
    Rotate Sect : This will rotate a sector when the line is passed.
    Change Sector : 
    Flip Textures : This will cause the textures to switch to their alternates when the line is crossed.
    Unrotate Sector :  A sector which has been rotated can be rotated back to it''s original position.
    Send Notification : This calls a user defined function when the line is crossed.
' !

RenderAXSpacePart subclass: #RenderAXSector
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #RenderAXSector) comment: '
A sector is a two dimensional enclosed area.
Looking at an overhead  map, each sector is a polygon.
Each sector can have different lighting attribute, height, and texture properties associated with it.
The sector is the basic unit of differentiating areas within the engine.
A 4DX Map is made of a series of adjoining sectors.
Each sector is defined by a series of linedefs that completely enclose the sector to which they belong.
Each linedef that defines a sector must always face into the sector that it encloses.
On the outside of a sector, enclosing lines are always clockwise.
If you are unable to determine if a line is facing into the sector, use the RightHand rule.
if you are standing at the origin of the line, facing the direction of the arrow, the right hand side is the "face" of the line.
It should be facing into the sector.

Ceiling and Floor Picture Tiles
The pictures on the left side of the screen display the ceiling and floor tiles respectively from top to bottom. 
These pictures can be changed by typing the corresponding number of the tile in the box below the picture, or by using the up and down arrows to increment or decrement the number.

Heights
Ceiling : The absolute height of the ceiling.  (This is not the height from the floor.)
Floor : The absolute height of the floor.
Under :
Offset : Changes where the actor stands in relation to the floor.
    A negative number will cause the actor stand beneath the floor giving the effect of standing in water.

Flat Adjustments 
Ceiling X, Ceiling Y, Floor X, Floor Y : These values fine tune the position of the ceiling and floor tile images. 

Flat Animation
Ceiling X, Ceiling Y, Floor X, Floor Y : These values determine if the floor or ceiling tiles scroll.
    The numbers correspond to the rate at which the tiles move.

Misc
Tag : This is a user definable field.
Swing : This determines the amount of movement of the actor if "Bob" is checked.
Light : This is the level of light in the sector.
    Zero corresponds to the brightest light while larger numbers correspond to dimmer light.

Line Flags
Self Illumination :
Ceiling is sky : Causes the ceiling animates to simulate the sky.
Snowing : Snow falls when the actor stands in this sector.
Raining : Rain falls when the actor stands in this sector.
*mu :
Bob : The actor moves up and down when walking to give the effect of swimming.
AltShade  : If this is checked, the alternate shading table is used for this sector.

Trip Flags
For a description of the Trip flags refer to those sections in the Wall Properties.
'   !

RenderAXSpacePart subclass: #RenderAXVertex
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #RenderAXVertex) comment: '
A vertex describes a point on the overhead map.
It is used for determining the starting and ending of line segments (& walls).
Moving a vertex automatically moves all linedefs(lines) attached to it.
This can be done programmatically at run time.

struct vertex
   {
   float x;       // Notice: X & Y are actual integers.
   float y;
                  // Following are for system use only...
   float n_x;     // normalized X (x - players x)
   float n_y;     // normalized y (y - players y)
   float r_x;     // after rotating into current view.
   float r_y;     // after rotation into current view.
   float startx;  // Save x - for use when unrotating.
   float starty;  // Save Y - for use when unrotating.
   };
'  !

RenderAXValueObject subclass: #RenderAXSpeed
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''    !

RenderAXPointer subclass: #RenderAXPatch
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''    !

RenderAXPointer subclass: #RenderAXShade
  instanceVariableNames: 
    ' color distance '
  classVariableNames: ''
  poolDictionaries: ''  !

RenderAXPointer subclass: #RenderAXSpace
  instanceVariableNames: 
    ' name directory pane currentActor isTracking trackAlways walkAtenuation runAtenuation strategy actorCache sectorCache lineCache vertexCache bitmapCache textureCache callBackCache '
  classVariableNames: ''
  poolDictionaries: 
    ' OperatingSystemConstants RenderAXConstants ' !

RenderAXSpace class instanceVariableNames: ' current ' !

RenderAXObject subclass: #RenderAXRandom
  instanceVariableNames: 
    ' seed a m q r '
  classVariableNames: ''
  poolDictionaries: ''    !

RenderAXRandom class instanceVariableNames: ' current '    !

RenderAXObject subclass: #RenderAXStrategy
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''  !

RenderAXStrategy subclass: #RenderAXTimedStrategy
  instanceVariableNames: 
    ' interval nextTime '
  classVariableNames: ''
  poolDictionaries: ''  !

RenderAXObject subclass: #WadObject
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #WadObject) comment: '
    @1998, Alejandro F. Reimondo
    WadObjects are objects from Unofficial WAD File Specification.'  !

WadObject subclass: #WadElement
  instanceVariableNames: 
    ' parent '
  classVariableNames: ''
  poolDictionaries: ''   !

WadElement subclass: #Lump
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''  !

Lump subclass: #BlockMap
  instanceVariableNames: 
    ' origin blocks listOffsets blockLists '
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #BlockMap) comment: '
	<BLOCKMAP> :=	<xorigin>            ;<short>
								<yorigin>            ;<short>
								<xblocks>            ;<short>
								<yblocks>            ;<short>
								<listoffsets>
								<blocklists>
	<listoffsets>   := <listoffset> [numofblocks]
	<listoffset>    := <ushort>
	<numofblocks>   := <short>              ;note it equals <xblocks> * <yblocks>
	<blocklists>    := <blocklist> [numofblocks]
	<blocklist>     :=	<short: 0>           ;for dynamic thinglist pointer
								<lines_in_block>
								<short: -1>
	<lines_in_block>:= <linedef_num> [...]  ;the numbers of all the <linedef>s that are in the block
	<linedef_num>   := <short>

    The BLOCKMAP is a pre-calculated structure that the game engine uses to simplify collision-detection between moving things and walls.
	If a level doesnt have a blockmap, it will display fine, but everybody walks through walls, and no one can hurt anyone else.
	The whole level is cut into "blocks", each is a 128 (hex 80) wide square (the grid lines in the automap correspond to these blocks).
	The BLOCKMAP is a collection of lists, one list for each block, which say what LINEDEFS are wholly or partially in that block (i.e. part of the line passes through the block).
	When the game engine needs to check for an object/wall collision (to prevent a player from walking through a wall or to explode a rocket when it hits a wall, etc.), it just looks up the blocklist for the block that the object is in.
	This tells it which linedefs it needs to check for collisions.
	Most blocks will have few if any lines in them, so there will be a substantial savings in processor time if it only checks a couple linedefs per object instead of a thousand or so linedefs per object - it would have to check every single linedef on the level if not for these blocklists.
	The blocks are also used for object/object collisions, but that is not visible in the WAD format. During play, each block is also given a dynamic "thing list", which tells what THINGS are currently in that block.
	Again, this negates the need to check every moving object vs. every other object for collisions - only a few need be tested.
    '    !

Lump subclass: #LumpBasicContainer
  instanceVariableNames: 
    ' contents '
  classVariableNames: ''
  poolDictionaries: ''  !

LumpBasicContainer subclass: #EndDOOM
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''   !

LumpBasicContainer subclass: #LumpContainer
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !

LumpContainer subclass: #ColorMaps
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #ColorMaps) comment: '
    <COLORMAP>      := <color_map> [34]
    <color_map>     := <mapping> [256]
    <mapping>       := <byte>

    This contains 34 sets of 256 bytes, which "map" the colors "down" in brightness.
    Brightness varies from sector to sector. At very low brightness, almost all the colors are mapped to black, the darkest gray, etc.
    At the highest brightness levels, most colors are mapped to their
own values, i.e. they dont change.
    In each set of 256 bytes, byte 0 will have the number of the palette color to which original color 0 gets mapped.
    The colormaps are numbered 0-33. Colormaps 0-31 are for the different brightness levels, 0 being the brightest (light level 248-255), 31 being the darkest (light level 0-7).
    Light level is the fifth field of each SECTOR record.
    Colormap 32 is used for every pixel in the display window (but not
the status bar), regardless of sector brightness, when the player is under the effect of the "Invulnerability" power-up.
    This colormap is all whites and greys.
    Colormap 33 is all black for some reason.
    While the light-amplification goggles power-up is in effect, everything
in the display uses colormap 0, regardless of sector brightness.
    '  !

LumpContainer subclass: #LumpLineDefs
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #LumpLineDefs) comment: '
    Each linedef represents a line from one of the VERTEXES to another'   !

LumpContainer subclass: #LumpNodes
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''  !

LumpContainer subclass: #LumpSectors
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''    !

LumpContainer subclass: #LumpSegs
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #LumpSegs) comment: '
     The SEGS are stored in a sequential order determined by the SSECTORS, which are part of the NODES recursive tree.'   !

LumpContainer subclass: #LumpSideDefs
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #LumpSideDefs) comment: '
    A sidedef is a definition of what wall texture(s) to draw along a LINEDEF, and a group of sidedefs outline the space of a SECTOR.'    !

LumpContainer subclass: #LumpSubSectors
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #LumpSubSectors) comment: '
    SSECTOR stands for sub-sector.
    These divide up all the SECTORS into convex polygons.
    They are then referenced through the NODES resources.
    There will be (number of nodes + 1) ssectors.'  !

LumpContainer subclass: #LumpThings
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #LumpThings) comment: '
    <THINGS>        := <thing> [...]
        <thing>         := <x_position>         ;all are <short>
                                <y_position>
                                <angle>
                                <type>
                                <options>
    "Things" in DOOM are player start positions, monsters, weapons, keys,
barrels, etc. The size of each THINGS lump will be a multiple of ten,
since each thing requires ten bytes to describe it, in five <short>
fields:

(1) X position of thing (at levels inception)
(2) Y position of thing
(3) Angle the thing faces. On the automap, 0 is east, 90 is north, 180
      is west, 270 is south. This value is only used for monsters, player
      starts, deathmatch starts, and teleporter landing spots. Other
      things look the same from all directions. Values are rounded to
      the nearest 45 degree angle, so if the value is 80, it will
      actually face 90 - north.
(4) Type of thing, see next subsection, [4-2-1]
(5) Thing options, see [4-2-3]
'    !

LumpContainer subclass: #LumpVertexes
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #LumpVertexes) comment: '
    These are the beginning and end points for LINEDEFS and SEGS.'    !

LumpBasicContainer subclass: #LumpDemo
  instanceVariableNames: 
    ' number header gametics '
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #LumpDemo) comment: '
    <demo> := <header>
        <gametic_data>
        <byte:128>
    <header> := {<header_12> | <header_16>}  ;different versions
    <header_12> := <skill> <episode>
        <map>
        <player> [4]
    <header_16> := <version>
        <skill>
        <episode>
        <map>
        <mode>
        <respawn>
        <fast>
        <nomonsters>
        <viewpoint>
        <player> [4]
    <skill>         := <byte:0..4>
    <episode>   := {<byte:1..3> | <byte:1>}     ;DOOM 1 or DOOM 2
    <map>         := {<byte:1..9> | <byte:1..32>} ;DOOM 1 or DOOM 2
    <player>      := <byte:0..1>          ;0 means not present, 1 means present
    <version>    := <byte:104..106>      ;versions 1.4, 1.5, 1.6 (also 1.666)
    <mode>       := <byte:0..2}          ;cooperative|deathmatch|altdeath
    <respawn>  := <byte>               ;0 is off, non-zero is on
    <fast>          := <byte>               ;0 is off, non-zero is on
    <nomonsters> := <byte>        ;0 is off, non-zero is on
    <viewpoint> := <byte:0..3>          ;shown from this players view

    <gametic_data>  := <gametic> [...]
    <gametic>       := <player_move> [1..4] ;1-4 is # of players present in demo
    <player_move>   := <forward>            ;<char>
        <strafe>             ;<char>
        <turn>               ;<char>
        <use>                ;<byte>

     If you start DOOM and do nothing, after a few seconds, it automatically shows a demo of play on some level.
    Also, external demos can be recorded and played back by using the command line parameters explained in the README and/or the DOOM FAQ.
    All external demos have a .LMP extension which the DOOM OS attaches; you only type the [demoname] without the .LMP extension.
    The DOOM.WAD lumps DEMO1, DEMO2, and DEMO3 are in exactly the same format as these external .LMP files.'    !

LumpBasicContainer subclass: #LumpDMXGUS
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''    !

LumpBasicContainer subclass: #LumpNamedContainer
  instanceVariableNames: 
    ' name '
  classVariableNames: ''
  poolDictionaries: ''    !

LumpNamedContainer subclass: #LumpPicture
  instanceVariableNames: 
    ' colorTable '
  classVariableNames: ''
  poolDictionaries: '' !

LumpPicture subclass: #LumpFlat
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #LumpFlat) comment: '
	Picture Lumps in WAD Flat Format.
	Each flat is 4096 raw bytes, making a square 64 by 64 pixels.
	This is pasted onto a floor or ceiling with the same orientation as the automap would imply, i.e. the first byte is the color at the NW corner, the 64th byte (byte 63, 0x3f) is the NE corner, etc.
	The blocks in the automap grid are 128 by 128, so four flats will fit in each block.
	Note that there is no way to offset the placement of flats, as can be done with wall textures.
	They are pasted according to grid lines 64 apart, reckoned from the coordinate (0,0).
	This allows flats to flow smoothly even across jagged boundaries between sectors with the same floor or ceiling height.
'  !

LumpPicture subclass: #LumpGraphic
  instanceVariableNames: 
    ' extent offset bits '
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #LumpGraphic) comment: '
	Picture Lumps in WAD Graphic Format.

	<picture>       := <header>
	                   <pointers>           ;offsets to <column> starts
	                   <pixel_data>
	<header>        := <width>              ;all are <short>
    	               <height>
	                   <left_offset>
	                   <top_offset>
	<pointers>      := <pointer> [width]    ;<long>
	<pixel_data>    := <column> [width]
	<column>        := <post> [...]
	   	                <byte:255>           ;255 (0xff) ends the column
	<post>          := <rowstart>           ;<byte>
	                   <num_pixels>         ;<byte>
    	               <unused>             ;<byte>
        	           <pixels>
	                   <unused>             ;<byte>
	<pixels>        := <pixel> [num_pixels] ;<byte>
' !

LumpGraphic subclass: #LumpTexturePatch
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !

LumpPicture subclass: #LumpRawPicture
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #LumpRawPicture) comment: '
	Lumps with pictures in RAW bytes format.'  !

LumpRawPicture subclass: #LumpScreen
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #LumpScreen) comment: '
	Full screen (320 by 200 pixel) pictures.'   !

LumpScreen subclass: #LumpCredit
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''    !

LumpScreen subclass: #LumpHelpScreen
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''    !

LumpScreen subclass: #LumpHintScreen
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''    !

LumpScreen subclass: #LumpTitleScreen
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''   !

LumpScreen subclass: #LumpVictoryScreen
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !

LumpNamedContainer subclass: #LumpSoundEffect
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''   !

LumpSoundEffect subclass: #LumpMusicSoundEffect
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !

LumpSoundEffect subclass: #LumpPCSpeakerSoundEffect
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !

LumpSoundEffect subclass: #LumpSoundCardSoundEffect
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !

LumpNamedContainer subclass: #UnknownLump
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''   !

UnknownLump subclass: #LumpLoadFailure
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''  !

LumpBasicContainer subclass: #LumpNames
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #LumpNames) comment: '
	<PNAMES>        :=	<num_pnames>         ;<long>
									<pnames>
	<pnames>        := <pname> [num_pnames]
	<pname>         := <string8>]           ;match the <name> from the <lumpinfo> of a <picture>
	This is a list of all the names of lumps that are going to be used as wall patches.
	DOOM assigns numbers to these names, in the order that they are listed.
	The numbers are then used in TEXTURE1 and TEXTURE2 entries to refer to wall patch lumps.
	In a texture composition entry, 0 means the first pname, 1 is the second, ...'   !

LumpBasicContainer subclass: #LumpTransparentSky
  instanceVariableNames: 
    ' number '
  classVariableNames: ''
  poolDictionaries: ''  !

LumpBasicContainer subclass: #Reject
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #Reject) comment: '
	<REJECT>        := <bitarray>

    The REJECT lump is used to help speed play on large levels.
	It can also be used for some special effects like monsters in plain sight who CANNOT attack or see players.
	The size of a REJECT in bytes is (number of SECTORS ^ 2) / 8, rounded up.
	It is an array of bits, with each bit controlling whether monsters in a given sector can detect and/or attack players in another sector.

	Make a table of sectors vs. sectors, like this:
			sector that the player is in
					0  1  2  3  4
				  +---------------
sector		0 | 0  1  0  0  0
that			1 | 1  0  1  1  0
the			2 | 0  1  0  1  0
monster	3 | 0  1  1  1  0
is in			4 | 0  0  1  0  0

	A 1 means the monster cannot become activated by seeing a player, nor can it attack the player.
	A 0 means there is no restriction.
	All non-deaf monsters still become activated by weapon sounds that they hear (including the bare fist).
	And activated monsters will still pursue the player, but they will not attack if their current sector vs. sector bit is "1".
	So a REJECT thats set to all 1s gives a bunch of pacifist monsters who will follow the player around and look menacing, but never actually attack.
	How the table turns into the REJECT resource:
	Reading left-to-right, then top-to-bottom, like a page, the first bit in the table becomes bit 0 of byte 0, the 2nd bit is bit 1 of byte 0, the 9th bit is bit 0 of byte 1, etc.
	So if the above table represented a level with only 5 sectors, its REJECT would be 4 bytes:
		10100010 00101001 01000111 xxxxxxx0 (hex A2 29 47 00, decimal 162 41 71 0)
	In other words, the REJECT is a long string of bits which are read from least significant bit to most significant bit, according to the lo-hi storage scheme used in a certain x86 family of CPUs.
	Usually, if a monster in sector A cant detect a player in sector B, then the reverse is true too, thus if sector8/sector5 is set, then sector5/sector8 will be set also.
	Same sector prohibitions, e.g. 0/0,3/3, etc. are only useful for special effects (pacifist monsters), or for tiny sectors that monsters cant get to anyway.

	The REJECT array was designed to speed the monster-detection process.
	If a sector pair is prohibited, the game engine doesnt even bother checking line-of-sight feasibility for the monster to "see" the player and consider attacking.
	When a level has hundreds of monsters and hundreds of sectors, a good REJECT can prevent the drastic slowdowns that might otherwise occur (even fast CPUs can fall victim to this phenomenon).
    '    !

Lump subclass: #LumpGenMIDI
  instanceVariableNames: 
    ' header data instruments '
  classVariableNames: ''
  poolDictionaries: ''  !

Lump subclass: #LumpTexture
  instanceVariableNames: 
    ' number numberOfTextures offsets entries '
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #LumpTexture) comment: '
	<TEXTURE1> :=	<num_textures>       ;<long>
								<tex_offsets>
								<tex_entries>
	<tex_offsets>   := <tex_offset> [num_textures]
	<tex_offset>    := <long>
	<tex_entries>   := <tex_entry> [num_textures]
	<tex_entry>     :=	<tex_name>           ;<string8>
								<short:0>
								<short:0>
								<tex_width>          ;<short>
								<tex_height>         ;<short>
								<short:0>
								<short:0>
								<num_patches>        ;<short>
								<patches>
	<patches>       :=	<patch> [num_patches]
	<patch>         :=	<x_offset>           ;all are <short>
								<y_offset>
								<pname_number>       ;lookup in <PNAMES> for picture
								<short:1>            ;supposedly <stepdir>
								<short:0>            ;supposedly <color_map>

	These are lists of wall texture names used in SIDEDEFS lumps.
	Each wall texture is composed of one or more wall patches, whose names are listed in the PNAMES lump.
	But in a texture, the wall patches are not referred to by name, rather by the index number indicating what position they occupy in the PNAMES lump.
	The TEXTURE2 lump is only present in the registered DOOM.WAD.
	The TEXTURE1 lump is identical in DOOM.WAD and the shareware DOOM1.WAD, and it only refers to pname numbers up to 163, because the shareware wad only has the first 163 wall patches, not all 350.'   !

Lump subclass: #PlayPalettes
  instanceVariableNames: 
    ' palettes '
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #PlayPalettes) comment: '
    <PLAYPAL>    := <palette> [14]
    <palette>        := {<red> <green> <blue>} [256]
    <red>            := <byte>
    <green>        := <byte>
    <blue>            := <byte>

    There are 14 palettes here, each is 768 bytes = 256 rgb triples.
    That is, the first three bytes of a palette are the red, green, and blue portions of color 0.
    And so on. Note that the values use the
full range (0..255), while standard VGA digital-analog converters
use values 0-63.
    The first palette, palette 0, is used for most situations.
    Palettes 10-12 are used (briefly) when an item is picked up, the
more items that are picked up in quick succession, the brighter it gets, palette 12 being the brightest.
    Palette 13 is used while wearing a radiation suit.
    Palettes 3, 2, then 0 again are used after getting berserk strength.
    If the player is hurt, then the palette shifts up to number X, then
comes "down" one every second or so, to palette 2, then palette 0 (normal) again.
    What X is depends on how badly the player got hurt: Over 100% damage (add health loss and armor loss), X=8. 93%, X=7. 81%, X=6. 55%, X=5. 35%, X=4. 16%, X=2. These are just rough estimates
based on a single test session long ago.
    Why bother tracking down
the exact division points?
    Unknown: what palettes 1 and 9 are for.
    ' !

WadElement subclass: #LumpElement
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #LumpElement) comment: '
    Lump elements are parts contained in lumps.'   !

LumpElement subclass: #GameAction
  instanceVariableNames: 
    ' movement turn flags '
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #GameAction) comment: '
    
  The four bytes recording each players actions are:

  (a) Forward/Backward Movement.
  (b) Strafe Right/Left Movement.
  (c) Turn Left/Right.
  (d) other actions - use/activate, fire, change weapons.

  The first three are signed bytes (i.e. of type <char>).

  (a) Ranges from -127 to 127, negative numbers are backward movement,
      positive numbers are forward movement. Without the -turbo option
      above 100, values outside -50..50 cannot be achieved. With a
      keyboard or joystick, these are the regular values:

      Move forward:   25 (0x19)   with Speed on:  50 (0x32)
      Move backward: -25 (0xE7)   with Speed on: -50 (0xCE)

      Fancy mouse use can achieve any number in the range.

  (b) Ranges from -127 to 127, negative numbers are left-strafe movement,
      positive numbers are right-strafe movement. The keyboard values are:

      Strafe right: 24  (0x18)    with Speed on:  50 (0x32)
      Strafe left: -24  (0xE8)    with Speed on: -50 (0xCE)

  (c) Ranges from -127 to 127, negative numbers are right turns, positive
      numbers are left turns. The keyboard values vary from version to
      version, but are all in the range -5..5, and thats with Speed on.

      Using the mouse can achieve much higher numbers here. I doubt if
      the maximums of 127 and -127 can actually be achieved in play,
      though.

  (d) the bits of this byte indicate what actions the player is engaged in:

      bit 0     Fire current weapon
      bit 1     Use (a switch, open a door, etc.)
      bit 2     Change weapon to the one indicated in bits 3-5:

      bits 5-3 = 000 Fist or Chainsaw
                 001 Pistol
                 010 Shotgun
                 011 Chaingun
                 100 Rocket Launcher
                 101 Plasma Rifle
                 110 BFG 9000
                 111 Super Shotgun (DOOM 2 only)

      bit 6     unused
      bit 7     indicates a special action which alters the meanings
                  of the other bits:
           bits 1-0 = 01 pause or unpause
                        = 10 save game in slot # recorded in bits 4 to 2
                                (slot number can thus be 0 to 7 but should NOT be 6 or 7 or else)

    There might be other special actions.
    The save game action happens during replay of the demo, so be careful when playing demos if you have important savegames.
    One or more of them could conceivably get overwritten.
    '   !

LumpElement subclass: #GameTic
  instanceVariableNames: 
    ' actions '
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #GameTic) comment: '
    The player-move data is recorded in 4-byte chunks.
    Every 1/35 of a second is a gametic, and for every gametic, there is one 4-byte chunk per player.
    So the time duration of a demo (in seconds) is approximately equal to its length in bytes divided by (140 * number_of_players).
    '  !

LumpElement subclass: #LumpContent
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''  !

LumpContent subclass: #LumpLineDef
  instanceVariableNames: 
    ' from to flags types trigger numberOfRightSideDef leftSideDef '
  classVariableNames: ''
  poolDictionaries: ''  !

LumpContent subclass: #LumpMusic
  instanceVariableNames: 
    ' header data dataSize dataStart numberOfPrimaryChannels numberOfSecondaryChannels numberOfPatches patchNumbers '
  classVariableNames: ''
  poolDictionaries: ''   !

LumpContent subclass: #LumpNode
  instanceVariableNames: 
    ' lineStart partitionDelta rightBounds leftBounds rightChild leftChild '
  classVariableNames: ''
  poolDictionaries: '' !

LumpContent subclass: #LumpSector
  instanceVariableNames: 
    ' floorHeight ceilingHeight floorName ceilingName lightLevel type tag colorMap '
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #LumpSector) comment: '
    A SECTOR is a horizontal (east-west and north-south) area of the map where a floor height and ceiling height is defined. It can have any shape.'    !

LumpContent subclass: #LumpSeg
  instanceVariableNames: 
    ' start end angle line direction offset '
  classVariableNames: ''
  poolDictionaries: '' !

LumpContent subclass: #LumpSideDef
  instanceVariableNames: 
    ' position upperTexture lowerTexture middleTexture sector '
  classVariableNames: ''
  poolDictionaries: ''   !

LumpContent subclass: #LumpSubSector
  instanceVariableNames: 
    ' count startSector '
  classVariableNames: ''
  poolDictionaries: ''   !

LumpContent subclass: #LumpThing
  instanceVariableNames: 
    ' position angle type options '
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #LumpThing) comment: '
    See LumpThings comment.'   !

LumpContent subclass: #LumpVertex
  instanceVariableNames: 
    ' position '
  classVariableNames: ''
  poolDictionaries: ''   !

LumpElement subclass: #LumpDemoHeader
  instanceVariableNames: 
    ' skill episode mission players '
  classVariableNames: ''
  poolDictionaries: ''.

  (Smalltalk at: #LumpDemoHeader) comment: '
    There are two different kinds of header depending on the version of DOOM used to record the demo.
Versions up to 1.2 use a 7-byte header:
    byte  range   purpose
    0       0-4     skill level. 0=Im too young to die, 4=Nightmare
    1       1-3     episode.
    2       1-9     mission/map.
    3       0-1     player 1 is present if this is 1.
    4       0-1     player 2.
    5       0-1     player 3.
    6       0-1     player 4.
Versions after 1.2 use a 13-byte header:
    byte  range   purpose
    0       104-106 version. 104=1.4 beta, 105=1.5 beta, 106=1.6 beta or 1.666
    1       0-4     skill level. 0=Im too young to die, 4=Nightmare
    2       1-3     episode. In DOOM 2 this is always 1.
    3       1-32    mission/map/level. In DOOM 1, its 1-9. In DOOM 2, its 1-32.
    4       0-2     mode. 0=single or cooperative, 1=deathmatch, 2=altdeath
    5       0-      respawn. 0=no respawn parameter, (any other value)=respawn.
    6       0-      fast. 0=no fast parameter, (any other value)=fast.
    7       0-      nomonsters. 0=monsters exist, (any other value)=nomonsters.
    8       0-3     viewpoint. 0=player 1s status bar, ..., 3=player 4.
    9       0-1     player 1 is present if this is 1.
    10     0-1     player 2.
    11     0-1     player 3.
    12     0-1     player 4.
    '    !

LumpDemoHeader subclass: #NewLumpDemoHeader
  instanceVariableNames: 
    ' version mode respawn fast hasMonsters viewPoint '
  classVariableNames: ''
  poolDictionaries: ''  !

LumpElement subclass: #TextureEntry
  instanceVariableNames: 
    ' name width height numberOfPatches patches '
  classVariableNames: ''
  poolDictionaries: ''    !

LumpElement subclass: #TexturePatch
  instanceVariableNames: 
    ' offset nameID stepDirection colorMap '
  classVariableNames: ''
  poolDictionaries: '' !

WadElement subclass: #WadDirectoryEntry
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !

WadDirectoryEntry subclass: #LumpInfo
  instanceVariableNames: 
    ' offset sizeInBytes name '
  classVariableNames: ''
  poolDictionaries: ''    !

LumpInfo subclass: #WadMarker
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''   !

WadElement subclass: #WadMapLevel
  instanceVariableNames: 
    ' marker things lines sides vertices segments sectors subSectors nodes rejects blockMap '
  classVariableNames: ''
  poolDictionaries: ''  !

WadElement subclass: #WadMonster
  instanceVariableNames: 
    ' name numberOfFrames numberOfRotations frames rotatedFrames '
  classVariableNames: ''
  poolDictionaries: ''  !

WadObject subclass: #WadFile
  instanceVariableNames: 
    ' header lumps directory flats sprites monsters '
  classVariableNames: ''
  poolDictionaries: ''   !

OLEControlSitePane subclass: #RenderAXOCXPane
  instanceVariableNames: 
    ' space '
  classVariableNames: ''
  poolDictionaries: ''  !

GraphPane subclass: #RenderAXPane
  instanceVariableNames: 
    ' space mapMode shear mapZoom dibPitch databits actorDefs bitmapSet flatSet textureSet colorData '
  classVariableNames: ''
  poolDictionaries: '' !

ApplicationCoordinator subclass: #RenderAXTest
  instanceVariableNames: 
    ' notifier '
  classVariableNames: ''
  poolDictionaries: ''  !

RenderAXTest subclass: #RenderAXNativeTest
  instanceVariableNames: 
    ' pane '
  classVariableNames: ''
  poolDictionaries: ''  !

RenderAXTest subclass: #RenderAXOLETest
  instanceVariableNames: 
    ' container activeSite '
  classVariableNames: ''
  poolDictionaries: '' !

Dynalink32 variableByteSubclass: #RenderAXDLL
  classVariableNames: ''
  poolDictionaries: ''    !

OLEStructure subclass: #RenderAXStructure
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''   !

RenderAXStructure subclass: #ExternalRenderAXActor
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''  !

RenderAXStructure subclass: #ExternalRenderAXLineDef
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''    !

RenderAXStructure subclass: #ExternalRenderAXMetaTexture
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: 
    ' RenderAXConstants '   !

RenderAXStructure subclass: #ExternalRenderAXPatch
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: ''  !

RenderAXStructure subclass: #ExternalRenderAXSector
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !

RenderAXStructure subclass: #ExternalRenderAXVertex
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !

RenderAXStructure subclass: #RenderAXSingle
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !


!RenderAXObject methods !

initMenu
    "Private - Initialize the menu.
    This message is needed for menu owner support"

    ^nil!
  
isActor
    "Returns true if the receiver is an actor."

    ^false!
 
isLine
    "Returns true if the receiver is a line."

    ^false!

isModel
    "Returns true if the receiver is a model."

    ^false!
  
isPatch
    "Returns true if the receiver is a patch."

    ^false!
  
isPointer
    "Returns true if the receiver is a pointer."

    ^false!
  
isSector
    "Returns true if the receiver is a sector."

    ^false!

isSpace
    "Returns true if the receiver is aRenderAXSpace."

    ^false!
   
isTexture
    "Returns true if the receiver is a texture."

    ^false!
  
isVertex
    "Returns true if the receiver is a vertex."

    ^false!

space
    "Returns the current (and only) space in the engine."

    ^RenderAXSpace current! !



!RenderAXColorConverter class methods !

default
    "Returns the instance var of the receiver
     for external manipulation"
    ^default!
  
default: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    default := anObject!
 
from: source to: destination
	"Returns an instance of the receiver for mapping color palette from source to destination BitmapInfos."

	^self new
		source: source;
		destination: destination;
		checkBitmapInfos;
		yourself! !



!RenderAXColorConverter methods !
   
bestFitIndexFor: aColor in: aCollection
	" Private - Returns the index in the collection for the bestFit color to aColor in aCollection. "

	| index sorted |
	index := aCollection indexOf: aColor.
	index > 0 ifTrue: [ ^index ].
	sorted := SortedCollection new: aCollection size.
	sorted
		sortBlock: (self colorSortBlockFor: aColor);
		addAll: aCollection.
	^aCollection indexOf: sorted first!
 
checkBitmapInfo: aBitmapInfo
	" Private, Validation - Check if aBitmapInfo is valid for conversion. "

	aBitmapInfo bitCount = 8 "Only paletizzed 256 color images are supported."
	ifFalse: [ ^self error: 'Invalid number of colors' ].!
  
checkBitmapInfos
	" Private, Validation - Check source and destination bitmap infos for validation. "

	source bitCount = destination bitCount
	ifFalse: [ self error: 'BitCounts must match.' ].

	self
		checkBitmapInfo: source;
		checkBitmapInfo: destination;
		yourself.!
   
colorsIn: aBitmapInfo
	" Private - Returns the colors defined in aBitmapInfo colorTable. "

	| result stream red green blue unused |
	result := OrderedCollection new.
	stream := ReadStream on: aBitmapInfo colorTable.
	[stream atEnd] whileFalse: [
		red := stream next.
		green := stream next.
		blue := stream next.
		unused := stream next.
		result addLast: (Color red: red green: green blue: blue)
	].
	^result asArray!
  
colorSortBlockFor: aColor
	" Private - Returns the bestFit color sortBlock to aColor. "

	^[:a :b|
		(self distanceFrom: aColor to: a) < (self distanceFrom: aColor to: b)
	]!
 
convert: bits
	"Converts bits ByteArray from source to destination colors."

	1 to: bits size do: [:i| bits at: i put: (self map at: (bits at: i) + 1) - 1 ].!
   
destination
    "Returns the instance var of the receiver
     for external manipulation"
    ^destination!
  
destination: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    destination := anObject!
 
distanceFrom: aColor to: another
	" Private - Returns the color distance considered from aColor to another. "

	| deltaRed deltaGreen deltaBlue |
	deltaRed := aColor red - another red.
	deltaGreen := aColor green - another green.
	deltaBlue := aColor blue - another blue.
	^deltaRed * deltaRed
	+ (deltaGreen * deltaGreen)
	+ (deltaBlue * deltaBlue)  "we dont care about sqrt"!
  
initializeMap
	" Private - Initializes the receiver's map"

	| sourceColors destinationColors |
	(self isCompatibleWith: self class default)
	ifTrue: [ ^map := self class default map ].

	map := Dictionary new.

	sourceColors := self colorsIn: self source.
	destinationColors := self colorsIn: self destination.

	1 to: sourceColors size do: [:i|
		map at: i put: (self
			bestFitIndexFor: (sourceColors at: i)
			in: destinationColors)
	].

	self class default isNil ifTrue: [
		self class default: self
	].!
   
isCompatibleWith: aColorConverter
	" Private - Returns true when the receiver's map is compatible with aColorConverter map."

	^aColorConverter notNil and: [
		(aColorConverter colorsIn: aColorConverter source)
		= (self colorsIn: self source)
		and: [
			(aColorConverter colorsIn: aColorConverter destination)
			= (self colorsIn: self destination) ] ]!
 
map
    "Returns the instance var of the receiver
     for external manipulation"

	map isNil ifTrue: [ self initializeMap ].
    ^map!

source
    "Returns the instance var of the receiver
     for external manipulation"
    ^source!

source: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    source := anObject! !



!RenderAXMap class methods !
 
current
    "Returns the current 'MAP' settings of the current space, undecorated."

    ^self new
        getContents;
        yourself!
  
currentWithResources
    "Returns the current 'MAP' settings of the current space, decorated with full resources.
    RenderAXMap saveAs: 'Ale.4st' withResources: true.
    RenderAXMap loadFrom: 'Ale.4st'.
    "

    ^self current
        getResources;
        yourself!
  
loadFrom: pathName
    " Load a new map from existent file named pathName and set default space with it.
    Returns true if success."

    | instance |
    instance := self objectFiler loadFromPathName: pathName.
    (instance isKindOf: self) ifTrue: [ instance install. ^true ].
    ^false!
 
objectFiler
    "Returns the system ObjectFiler.
    RenderAXMap objectFiler"

    ^Smalltalk at: #ObjectFiler
        ifAbsent: [
            ARObject checkBound: 'voflr31w'.
            Smalltalk at: #ObjectFiler
        ]!
   
saveAs: pathName
    " Save the receiver's current instance into a new file named pathName. "

    ^self saveAs: pathName withResources: false!
  
saveAs: pathName withResources: aBoolean
    " Save the receiver's current instance into a new file named pathName. "

    | instance |
    instance := aBoolean ifTrue: [ self currentWithResources ] ifFalse: [ self current ].
    ^instance saveAs: pathName! !



!RenderAXMap methods !
  
clearSpace
    " Private, Loading - Remove all the space contents and reset to default settings. "

    self space clear.!
   
contents
    "Returns the instance var of the receiver
     for external manipulation"

    contents isNil ifTrue: [ self initializeContents ].
    ^contents!
 
contents: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    contents := anObject!
   
createActor: anActor type: aType at: aPoint height: height
    " Private, Loading - Build new a actor in current space. "

    self space dll newActor: anActor id type: aType at: aPoint height: height.!
   
createActorTypesFrom: bytes
    " Private - Set current resource from streamed bytes. "

	self space resetActorTypes.
    ^self setResourcesOf: RenderAXActorType using: bytes!
 
createBitmapsFrom: bytes
    " Private - Set current resource from streamed bytes. "

    ^self setResourcesOf: RenderAXBitmap using: bytes!
 
createFlatsFrom: bytes
    " Private - Set current resource from streamed bytes. "

    ^self setResourcesOf: RenderAXFlat using: bytes!
 
createLine: aLine withVertices: vertices in: aSector
    " Private, Loading - Build new a line in aSector. "

    | pointer |
    pointer := aLine dll
        newLine: aSector id
        from: vertices first id
        to: vertices last id.
    aLine validateWith: pointer.!
  
createSectors: aCollection
    " Private, Loading - Build new sectors in current space from aCollection. "

    | space |
    space := self space.
    aCollection do: [:aSector| space setSector: aSector id with: aSector ].!

createTexturesFrom: bytes
    " Private - Set current resource from streamed bytes. "

    ^self setResourcesOf: RenderAXMetaTexture using: bytes!
   
createVertices: aCollection
    " Private, Loading - Build new vertices in current space from aCollection. "

    | space |
    space := self space.
    aCollection do: [:aVertex| space setVertex: aVertex id with: aVertex ].!
  
fixupAll
    " Private, Loading - Fixup all space settings. "

    self space fixupAll.!
 
flushActors: aCollection
    " Private, Loading - Validate the actors in aCollection. "

    self space flushActorsCache.
    aCollection do: [:anActor| anActor validate ].!
   
flushLines: aCollection in: aSector
    " Private, Loading - Connect lines in aSector. "

    aSector validate.

"not needed... lines creation set the sector.
    aCollection isEmpty ifTrue: [ ^self ].
    aCollection last nextLine: nil.
    1 to: aCollection size - 1 do: [:i|
        (aCollection at: i) nextLine: (aCollection at: i + 1)
    ].

    aSector
        firstLine: aCollection first;
        lastLine: aCollection last;
        yourself.
"!
  
flushTextureCache
    " Private, Loading - Force flush of the texture chache. "

    self space flushTextureCache.!
  
flushVertices: aCollection
    " Private, Loading - Validate the vertices in aCollection. "

    aCollection do: [:aVertex| aVertex validate ].!
 
getContents
    "Obtain the receiver's contents from current space."

    | theSpace sectors topSector lines vertices actors |
    theSpace := self space.
    sectors := theSpace sectors asArray.
    vertices := theSpace vertices.
    self contents
        add: (Message
            receiver: self
            selector: #createSectors:
            arguments: (Array with: sectors));
        add: (Message
            receiver: self
            selector: #createVertices:
            arguments: (Array with: vertices));
        add: (Message
            receiver: self
            selector: #flushVertices:
            arguments: (Array with: vertices));
        yourself.
    sectors do: [:aSector|
        lines := aSector lines.
        lines do: [:aLine|
            self contents
                add: (Message
                    receiver: self
                    selector: #createLine:withVertices:in:
                    arguments: (Array
                        with: aLine
                        with: aLine vertices
                        with: aLine sector))
        ].
        self contents
            add: (Message
                receiver: self
                selector: #flushLines:in:
                arguments: (Array with: lines with: aSector))
    ].
    self contents
        add: (Message
            receiver: self
            selector: #flushTextureCache);
        add: (Message
            receiver: self
            selector: #fixupAll);
        yourself.
    actors := self space actors.
    actors do: [:anActor|
        self contents
            add: (Message
                receiver: self
                selector: #createActor:type:at:height:
                arguments: (Array
                    with: anActor
                    with: anActor type
                    with: anActor location asPoint
                    with: anActor height));
            yourself
    ].
    self contents
        add: (Message
            receiver: self
            selector: #flushActors:
            arguments: (Array with: actors));
        yourself!
  
getResources
    "Obtain the receiver's resources from current space."

    | theSpace flats |
    theSpace := self space.
    self resources
        add: (Message
            receiver: self
            selector: #createFlatsFrom:
            arguments: (Array with: self streamedFlats));
        add: (Message
            receiver: self
            selector: #createTexturesFrom:
            arguments: (Array with: self streamedTextures));
        add: (Message
            receiver: self
            selector: #createBitmapsFrom:
            arguments: (Array with: self streamedBitmaps));
        add: (Message
            receiver: self
            selector: #createActorTypesFrom:
            arguments: (Array with: self streamedActorTypes));
        add: (Message
            receiver: self
            selector: #flushTextureCache);
        yourself!

initializeContents
    " Private - Initializes the receiver's contents"

    contents := OrderedCollection new.!
 
initializeResources
    " Private - Initializes the receiver's resources"

    resources := OrderedCollection new.!
  
install
    " Private - Set the current space with the receiver's instances. "

    self
        clearSpace;
        installResources;
        installContents;
        yourself.!
   
installContents
    " Private - Set the current space resources with the receiver's contents. "

    contents size = 0 ifTrue: [ ^self ]. "no contents (use current contents)."
    self contents do: [:aMessage| aMessage evaluate ].!
 
installResources
    " Private - Set the current space resources with the receiver's resources. "

    resources size = 0 ifTrue: [ ^self ]. "no resources (only use standard resources)."
    self resources do: [:aMessage| aMessage evaluate ].!
 
mapResources
    "Must return all the non standard resources in the receiver to be saved into the map."

    | result |
    self notImplementedYet.
    result := Set new.
    result
        addAll: self bitmaps;
        addAll: self flats;
        addAll: self textures;
        addAll: self actorTypes;
        yourself.
    ^result!
  
resources
    "Returns the instance var of the receiver
     for external manipulation"

    resources isNil ifTrue: [ self initializeResources ].
    ^resources!
 
resources: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    resources := anObject!
 
saveAs: pathName
    " Save the receiver into a new file named pathName.
    The saving process is trivial because all RenderAXObjects knows how to store itself. "

    ^self class objectFiler dump: self newFile: pathName!
  
setResourcesOf: aClass using: bytes
    " Private - Set current resource from streamed bytes. "

    | stream result |
    result := OrderedCollection new.
    stream := ReadWriteStream on: bytes.
    stream reset.
    [stream atEnd] whileFalse: [
        result add: (aClass new loadFromStream: stream)
    ].
    ^result!
   
streamedActorTypes
    " Private - Returns a streamed version of current actor types. "

    ^self streamResourcesIn: self space actorTypes!
 
streamedBitmaps
    " Private - Returns a streamed version of current bitmaps. "

    ^self streamResourcesIn: self space bitmaps!
   
streamedFlats
    " Private - Returns a streamed version of current flats. "

    ^self streamResourcesIn: self space flats!
 
streamedTextures
    " Private - Returns a streamed version of current textures. "

    ^self streamResourcesIn: self space textures!

streamResourcesIn: aCollection
    " Private - Returns a streamed version of resources in aCollection. "

    | stream |
    stream := ReadWriteStream on: String new.
    aCollection do: [:each| each saveToStream: stream ].
    ^stream copyFrom: 1 to: stream position! !



!RenderAXPointer methods !
  
dll
    " Private - Returns the current library in use.
    We can't use #library as the name of this message because #library express SLL support.
    "

    ^RenderAXDLL library!
   
fileOutSurrogate: anObjectFiler
        " Answer surrogate for object filing after performing any
        dump preprocessing.
        To notify user of non-fatal problem send:
                anObjectFiler recordInfoMessage: 'info message'
                anObjectFiler recordWarningMessage: 'warning message'
        "

    ^self copy
        pointer: (self pointer notNil
            ifTrue: [ self storeInformationFrom: self pointer ]);
        yourself!

getBitmapDIB: aBitmapID
    "Get the DIB structure for bitmap with ID aBitmapID."

    | width height |
    width := self dll getBitmapWidth: aBitmapID.
    width > 0 ifFalse: [ ^nil ].
    height := self dll getBitmapHeight: aBitmapID.
    height > 0 ifFalse: [ ^nil ].
    ^self getBitmapDIB: aBitmapID extent: width @ height!

getBitmapDIB: aBitmapID extent: extent
    "Get the DIB structure for bitmap with ID aBitmapID."

    ^RenderAXDIB new
        bitmapInfo: (self getBitmapInfo: extent);
        pointer: (self dll getBitmap: aBitmapID) asExternalAddress;
        yourself!

getBitmapInfo: extent
    "Get the WinBitmapInfo structure for a bitmap of extent extent."

    | bitmapInfo |
    bitmapInfo := self space pane getBitmapInfo.
    bitmapInfo
        width: extent x; height: extent y;
        sizeImage: (((bitmapInfo width * bitmapInfo bitCount) + 31) // 32 * 4) * bitmapInfo height;
        yourself.
    ^bitmapInfo!
   
initializePointer
    " Private - Initializes the receiver's pointer if appropiate.
    This method must be refined by subclasses that are supported by low level library structures."

    self pointer: nil.!
 
isAtAddress: anAddress
    "Returns true if the receiver is placed at address anAddress.
    anAddress can be anExternalAddress or an Integer."

    self pointer isNil ifTrue: [ ^anAddress isNil or: [anAddress asInteger = 0] ].
    ^pointer contents asInteger = anAddress asInteger!
 
isPointer
    "Returns true if the receiver is a pointer."

    ^true!
   
isValid
    "Returns true when the receiver's pointer is not nil."

    ^self pointer notNil "valid pointer."
        and: [ pointer isCollection not ] "not a storeMap."!
  
pointer
    "Returns the instance var of the receiver
     for external manipulation"

    pointer isNil ifTrue: [ self initializePointer ].
    ^pointer!
 
pointer: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    pointer := anObject!
 
reset
    " Private - Reset the receiver's resources."

    self pointer: nil!
   
storeInformationFrom: aRenderAXStructure
    " Private, fileOut - Returns a cache to be used for storing receiver's information and capable to be restored when loading the receiver.
    By default we will return the structure store map.
    This method can be refined by subclasses."

    ^aRenderAXStructure storeMap!
 
validate
    " Loading - Restore pointer information from stored map. "

    ^self validateWith: nil!

validateWith: aPointer
    " Loading - Restore pointer information from stored map. "

    | storeMap |
    (storeMap := self pointer) isCollection ifFalse: [ ^self ].

    self pointer: aPointer. "force pointer reload from space if aPointer=nil."
    storeMap do: [:tuple|
        self pointer perform: tuple first with: tuple last
    ].! !



!RenderAXDIB methods !
   
asBitmap
        "Convert from DIB bitmap to DDB bitmap."

    | bitmap bmiCopy |
    bitmap := Bitmap new.
    bmiCopy := self bitmapInfo copy.
    bmiCopy
        contents: bmiCopy contents copy;
        width: bmiCopy width;
        height: bmiCopy height;
        yourself.
    bitmap
        bitmapInfo: bmiCopy;
        createBitmap: self bits;
        deviceContext: Bitmap memoryContext;
        graphicsTool: (Pen forDC: Bitmap memoryContext medium: bitmap);
        yourself.
    ^bitmap!
 
asDIB
    "Copy the receiver to a real DIB."

    | dib bmiCopy |
    dib := DIB new.
    bmiCopy := self bitmapInfo copy.
    bmiCopy
        contents: bmiCopy contents copy;
        width: bmiCopy width;
        height: bmiCopy height;
        yourself.
    dib
        bitmapInfo: bmiCopy;
        bits: self bits;
        yourself.
    ^dib!

bitCount
    "Answer the bitCount field of bitmapInfo structure."

    ^self bitmapInfo bitCount!

bitmapInfo
    "Returns the instance var of the receiver
     for external manipulation"
    ^bitmapInfo!

bitmapInfo: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    bitmapInfo := anObject!
   
bits
    "Answer the current bits."

    | result bits width height |
    bits := self pointer copyFrom: 1 to: self sizeImage.
    result := ByteArray new: bits size.
    width := self width.
    height := self height.
    0 to: width - 1 do: [:x|
        0 to: height - 1 do: [:y|
            result
                at: (height - y - 1) * width + x + 1
                put: ( bits at: x * height + y + 1)
        ].
    ].
    ^result!
 
bits: aByteArray
    "Sets the current bits."

    | result bits width height count |
    count := self sizeImage min: aByteArray size.
    bits := ByteArray new: count.
    width := self width.
    height := self height.
    0 to: width - 1 do: [:x|
        0 to: height - 1 do: [:y|
            bits
                at: y * width + (width - x - 1) + 1
                put: (aByteArray at: x * height + y + 1)
        ].
    ].
    self pointer replace: count with: bits!
 
boundingBox
        "Answer a rectangle which bounds the receiver."
    ^(Rectangle leftTopUnit extent: self extent)!
 
colorTable
        "Private - Answer the receiver color table"
    ^self bitmapInfo colorTable!
   
createDIBPalette
        "Private - Create a GDI palette from the color table of
        bitmapInfo; answer the palette handle."
    | logPalette hPalette |
    self bitCount = 24 ifTrue: [^0].
    logPalette := WinLogPalette fromRgbColor: self bitmapInfo colorTable.
    ( hPalette := GDILibrary createPalette: logPalette asParameter ) = 0
        ifTrue: [ ^self osError ].
    ^hPalette!
  
displayAt: aPoint with: destPen
        "Display the receiver at aPoint."
    self
        displayWith: destPen
        from: self boundingBox
        to: ( aPoint extent: self extent )
        rule: Srccopy!
  
displayWith: destPen from: sRectangle
        "Copy sRectangle from the receiver in the destPen medium
        using aRopConstant.  Data will be compressed or stretched if
        the two rectangles are not the same extent."
    self
        displayWith: destPen
        from: sRectangle
        to: sRectangle
        rule: Srccopy!
   
displayWith: destPen from: sRectangle to: dRectangle
        "Copy sRectangle from the receiver to dRectangle in
        the destPen medium using aRopConstant.  Data will be
        compressed or stretched if the two rectangles are not
        the same extent."
    self
        displayWith: destPen
        from: sRectangle
        to: dRectangle
        rule: Srccopy!
 
displayWith: destPen from: sRectangle to: dRectangle rule: aRopConstant
        "Copy sRectangle from the receiver to dRectangle in
        the destPen medium using aRopConstant.  Data will be
        compressed or stretched if the two rectangles are not the
        same extent."
    | destinationDC hPrevious isMemDC hPalette hPPalette drawn |
    destinationDC := destPen handle.
    ( isMemDC := ( destPen graphicsMedium isBitmap and: [
        destPen graphicsMedium deviceContext = Bitmap memoryContext ] ) )
        ifTrue: [
            destinationDC := Bitmap auxiliaryDC.
            hPrevious := destPen graphicsMedium selectToAuxDC ].

    ( hPalette := self createDIBPalette ) ~= 0
        ifTrue: [
            ( hPPalette := GDILibrary selectPalette: destinationDC
                with: hPalette
                forceBackground: false ) = 0
                    ifTrue: [ ^self osError ].
            ( GDILibrary realizePalette: destinationDC ) = 16rFFFFFFFF
                ifTrue: [ ^self osError ] ].

    drawn := GDILibrary
        stretchDIBits: destinationDC
        xDest: dRectangle left
        yDest: dRectangle "top"bottom - 1
        cxDest: dRectangle width
        cyDest: dRectangle height negated
        xSrc: sRectangle left
        ySrc: sRectangle top
        cxSrc: sRectangle width
        cySrc: sRectangle height
        bitsPtr: self pointer asParameter
        bmi: bitmapInfo asParameter
        colorUse: DibRgbColors
        rop: aRopConstant.
    drawn = dRectangle height
    ifFalse: [ ^self osError"
        Transcript cr;show: 'Only ', drawn asString,' lines has been drawn.'.
        "    ].

    hPalette ~= 0
        ifTrue: [
            ( GDILibrary selectPalette: destinationDC
                with: hPPalette
                forceBackground: false ) = 0
                    ifTrue: [ ^self osError ].
            ( GDILibrary deleteObject: hPalette ) ifFalse: [ ^self osError ] ].

    isMemDC
        ifTrue: [ destPen graphicsMedium deselectFromAuxDC: hPrevious ]!
   
extent
        "Answer a Point which is the extent of the receiver."
    ^self width @ self height!
   
height
        "Answer receiver's height."
    ^bitmapInfo height!

inspect
        "Open a GraphicBrowser on the receiver."
    GraphicInspector new openOn: self!
   
isDIB
        "Answer true if receiver is an instance of class
         DIB or one of its subclasses, else answer false."
    ^true!
 
numberOfColors
        "Answer the number of colors in the bitmap."
    self bitCount = 24
        ifTrue: [^0]         "A 24 bitCount bitmap has no color table."
        ifFalse: [^(1 bitShift: self bitCount)]!
 
palette
    "Returns the receiver's palette..."

    | logPalette |
    #addedByOStyle.
    self bitCount > 8 ifTrue: [ ^nil ].
    logPalette := WinLogicalPalette fromWinLogPalette: (
        WinLogPalette fromRgbColor: bitmapInfo colorTable).
    ^logPalette!
   
sizeImage
    "Answer the bits size in bytes."

    ^self bitmapInfo sizeImage = 0
        ifTrue: [ self width * self bitCount + 31 // 32 * 4 * self height ]
        ifFalse: [ self bitmapInfo sizeImage ]!
 
width
        "Answer receiver's width."
    ^bitmapInfo width!
   
withBitmapDo: aBlock
    "Evaluates a one parameter block aBlock with current bitmap.
    Changes to the bitmap will re saved into receiver's bits.
    Returns the value of evaluating aBlock.
    The bitmap will be released upon termination."

    ^self withBitmapDo: aBlock saveChanges: true!
 
withBitmapDo: aBlock saveChanges: aBoolean
    "Evaluates a one parameter block aBlock with current bitmap.
    If aBoolean is true, store bitmap changes to the receiver's bits.
    Retursn the value of evaluating aBlock.
    The bitmap will be released upon termination."

    | bitmap result |
    bitmap := self asBitmap.
    [    result := aBlock value: bitmap.
        aBoolean ifTrue: [ self bits: bitmap getDIBits ].
    ] ensure: [ bitmap release ].
    ^result! !



!RenderAXLocation class methods !

random
	"Returns a random instance of the receiver."

	| aSector space |
	space := RenderAXSpace current.
	aSector := space anySector.
	^self new
		position: aSector anyPlace;
		sector: aSector;
		height: space currentActor height;
		angle: RenderAXAngle random;
		yourself! !



!RenderAXLocation methods !
  
angle
    "Returns the instance var of the receiver
     for external manipulation"

    angle isNil ifTrue: [ self initializeAngle ].
    ^angle!
 
angle: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    angle := anObject!
 
asPoint
    "Returns the receievr as a point."

    ^self position!
  
height
    "Returns the instance var of the receiver
     for external manipulation"

    height isNil ifTrue: [ self initializeHeight ].
    ^height!
 
height: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    height := anObject!
   
initializeAngle
    " Private - Initializes the receiver's angle"

    angle := 0.!
  
initializeHeight
    " Private - Initializes the receiver's height"

    height := 0.!
   
initializePosition
    " Private - Initializes the receiver's position"

    position := 0@0.!
   
initializeSector
    " Private - Initializes the receiver's sector"

    sector := 0. "default sector"!
  
offset
    "Returns the receiver's planar coordinate."

    ^self position!
  
position
    "Returns the instance var of the receiver
     for external manipulation"

    position isNil ifTrue: [ self initializePosition ].
    ^position!
 
position: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    position := anObject!
   
sector
    "Returns the instance var of the receiver
     for external manipulation"

    sector isNil ifTrue: [ self initializeSector ].
    ^sector!
 
sector: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    sector := anObject!
   
x
    "Returns the x position"

    ^self position x!

x: aDistance
    "Sets the x position"

    ^self position x: aDistance!
 
y
    "Returns the y position"

    ^self position y!

y: aDistance
    "Sets they position"

    ^self position y: aDistance!
  
z
    "Returns the height"

    ^self height!

z: aDistance
    "Sets the height"

    ^self height: aDistance! !



!RenderAXPosition class methods !
  
for: aModel
    "Returns an instance of the receievr working on aModel"

    ^self new
        owner: aModel;
        yourself! !



!RenderAXPosition methods !
   
change
    "Change the owner position to current contents."

    self owner position: self!
  
owner
    "Returns the instance var of the receiver
     for external manipulation"
    ^owner!
  
owner: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    owner := anObject!
 
update
    "Get the receiver's position from owner."

    self owner getPosition: self! !



!RenderAXModelObject class methods !

flagNames
    " Returns the flag names aplicables to the receiver's instances.
    WARNING: the flags must be in proper bits order.
    The default action is to return an empty flag names collection.
    This method must be refined by subclasses.
    WARNING: flags accesors methods must be implemented."

    ^Array new!

id: anID
    "Returns a new instance with id anID."

    ^self new
        id: anID;
        yourself!
 
tripFlagNames
    " Returns the tripFlag names aplicables to the receiver's instances.
    WARNING: the tripFlag must be in proper bits order.
    The default action is to return an empty tripFlag names collection.
    This method must be refined by subclasses.
    WARNING: tripFlag accesors methods must be implemented."

    ^Array new! !



!RenderAXModelObject methods !
  
<= aModelObject
    "This objects can be sorted by ID."

    ^self id = aModelObject id!
 
= aModelObject
    "True when the receiver and aModelObject has similar ids."

    ^super = aModelObject
    or: [
        self species = aModelObject species
        and: [ self id = aModelObject id ]
    ]!
 
asParameter
    "Returns the receivers id."

    ^self id asParameter!
   
currentFlagNames
    "Returns the current activated flag names"

    ^self flagNames select: [:each| self testFlag: each ]!
  
flagIndex: aSymbol
    " Private - Returns the index for flag named aSymbol.
    Generates an error if name is invalid."

    ^self flagNames
        indexOf: aSymbol
        ifAbsent: [ self error: 'Invalid flag name: #',aSymbol ]!
  
flagNames
    " Returns the flag names aplicables to the receiver. "

    ^self class flagNames!
 
id
    "Returns the instance var of the receiver
     for external manipulation"

    id isNil ifTrue: [ self initializeId ].
    ^id!
 
id: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    id := anObject!
   
initializeId
    " Private - Initializes the receiver's id.
    This method can be refined by subclasses.
    Default action is to setUp to zero."

    id := 0.!
  
is: aSymbol
    "True if the receiver has the flag aSymbol activated."

    ^self testFlag: aSymbol!
 
isModel
    "Returns true if the receiver is a model."

    ^true!
   
isTrip: aSymbol
    "True if the receiver has the tripFlag aSymbol activated."

    ^self testTripFlag: aSymbol!
 
knownFlagNames
    " Returns the flag names aplicables to the receiver that are known. "

    ^self knownFrom: self currentFlagNames!

knownFrom: anArray
    " Private - Returns the names in anArray that are known. "

    | unKnown |
    unKnown := 'unKnown'.
    ^anArray select: [:each| (each indexOfString: unKnown) = 0 ]!
 
knownTripFlagNames
    " Returns the trip flag names aplicables to the receiver that are known. "

    ^self knownFrom: self tripFlagNames!
  
lineAt: aPointer
    " Private - Returns the line pointed by aPointer
    The receiver MUST respond to #space. "

    ^aPointer notNil ifTrue: [
        self space lineAt: aPointer
    ]!
   
metaTexture: anID
    " Private - Returns the metaTexture with ID anID or nil.
    The receiver MUST respond to #space. "

    ^anID notNil ifTrue: [
        self space metaTexture: anID
    ]!
 
printOn: aStream
    "Append the ASCII representation of the receiver to aStream."

    | aName flags |
    id isNil ifTrue: [^super printOn: aStream].
    aName := self class name.
    ((aName size > 8) and: [ (aName copyFrom: 1 to: 8) = 'RenderAX'])
    ifTrue: [ aName := aName copyFrom: 9 to: aName size ].
    aStream nextPutAll: aName,'[',id asString,']'.
	self isValid not ifTrue: [ aStream nextPutAll: '*invalid*'.^self ].

    flags := self knownFlagNames.
    flags size > 0 ifTrue: [ aStream space;nextPutAll: flags asString].
    flags := self knownTripFlagNames.
    flags size > 0 ifTrue: [ aStream space;nextPutAll: flags asString].!
  
resetFlag: aSymbol
    "Reset the receiver's flag named aSymbol."

    | bits |
    bits := (1 bitShift: (self flagIndex: aSymbol) - 1).
    self flags: (self flags - bits).!
 
resetTripFlag: aSymbol
    "Reset the receiver's tripFlag named aSymbol."

    | bits |
    bits := (1 bitShift: (self tripFlagIndex: aSymbol) - 1).
    self tripFlags: (self tripFlags - bits).!
 
sendNotification
    "Set the receiver to send notification events (if applicable)."

    (self flagNames includes: #sendNotification)
    ifTrue: [ ^self setFlag: #sendNotification ].

    (self tripFlagNames includes: #sendNotification)
    ifTrue: [ ^self setTripFlag: #sendNotification ].!

setFlag: aSymbol
    "Set the receiver's flag named aSymbol."

    | bits |
    bits := 1 bitShift: (self flagIndex: aSymbol) - 1.
    self flags: self flags | bits.!
 
setTripFlag: aSymbol
    "Set the receiver's tripFlag named aSymbol."

    | bits |
    bits := 1 bitShift: (self tripFlagIndex: aSymbol) - 1.
    self tripFlags: self tripFlags | bits.!
 
testFlag: aSymbol
    "Test the flag bit named aSymbol.
    Returns aBoolean."

    | bits |
    bits := 1 bitShift: (self flagIndex: aSymbol) - 1.
    ^(self flags bitAnd: bits) ~= 0!
  
testTripFlag: aSymbol
    "Test the tripFlag bit named aSymbol.
    Returns aBoolean."

    | bits |
    bits := 1 bitShift: (self tripFlagIndex: aSymbol) - 1.
    ^(self tripFlags bitAnd: bits) ~= 0!
  
tripFlagIndex: aSymbol
    " Private - Returns the index for tripFlag named aSymbol.
    Generates an error if name is invalid."

    ^self tripFlagNames
        indexOf: aSymbol
        ifAbsent: [ self error: 'Invalid flag name: #',aSymbol ]!
  
tripFlagNames
    " Returns the tripFlags names aplicables to the receiver. "

    ^self class tripFlagNames! !



!RenderAXActor class methods !

flagNames
    " Returns the flag names aplicables to the receiver's instances.
    WARNING: the flags must be in proper bits order."

    ^#(
        selfIluminating
        pickup
        walkover
        spooky
        autouse
        usable
        consumable
        autoInc
        shootable
        flicker
        active
        hanging
        ambulatory
        noRender
        sendNotification
        missile
    "remaining bits are unused...yet"
    )! !



!RenderAXActor methods !
   
adjust
    "Returns the receiver's adjust."

    ^self pointer adjust!
   
adjust: aNumber
    "Sets the receiver's adjust."

    ^self pointer adjust: aNumber asFloat!

angle
    "Returns the receiver's angle."

    ^RenderAXAngle value: self pointer angle!
 
angle: angle
    "Sets the receiver's angle."

    ^self pointer angle: angle asParameter!
   
check
    "Check the receiver.
    This method must be called for all moving actors, so that gravity can work upon them."

    self space check: self!
  
currentFrame
    "Returns the receiver's currentFrame."

    ^self pointer currentFrame!
 
currentFrame: aNumber
    "Sets the receiver's currentFrame."

    ^self pointer currentFrame: aNumber asParameter!
  
currentHp
    "Returns the receiver's currentHp."

    ^self pointer currentHp!
  
currentHp: aNumber
    "Sets the receiver's currentHp."

    ^self pointer currentHp: aNumber asParameter!
   
curveFrom: p1 to: p3 towards: p2
    "Draw a curve from point p1 to p3 which is curved towards p2."

    | range p1x p1y p2x p2y p3x p3y pOld xNew yNew
     r3 a b1x b1y b2x b2y dx dy dxOld dyOld |
    p1x := p1 x.
    p1y := p1 y.
    p2x := p2 x - p1 x.
    p2y := p2 y - p1 y.
    p3x := p3 x - p1 x.
    p3y := p3 y - p1 y.
    p3x >= p3y
    ifTrue: [ range := p3x abs ]
    ifFalse: [ range := p3y abs ].
    a := 3.
    b2x := a * range * p2x.
    b1x := b2x * range.
    b2y := a * range * p2y.
    b1y := b2y * range.
    r3 := range * range * range.
    self place: p1; goto: p1.
    pOld := p1.
    dxOld := dyOld := 0.
    1 to: range do: [:i |
        xNew := (dx := b1x - ((b2x - (i * p3x)) * i)) * i // r3 + p1x.
        yNew := (dy := b1y - ((b2y - (i * p3y)) * i)) * i // r3 + p1y.
        ((dx - dxOld) abs >= (dy - dyOld) abs)
            ifTrue: [
                pOld x = xNew ifFalse: [
                    self goto: pOld.  "so reverse will work"
                    pOld := xNew @ yNew.
                    self goto: pOld]]
            ifFalse: [
                pOld y = yNew ifFalse: [
                    self goto: pOld.  "so reverse will work"
                    pOld := xNew @ yNew.
                    self goto: pOld]].
        dxOld := dx.
        dyOld := dy]
!

damage
    "Returns the receiver's damage."

    ^self pointer damage!
   
damage: aNumber
    "Sets the receiver's damage."

    ^self pointer damage: aNumber asParameter!

damageBase
    "Returns the receiver's damageBase."

    ^self pointer damageBase!
   
damageBase: aNumber
    "Sets the receiver's damageBase."

    ^self pointer damageBase: aNumber asParameter!

default
    "Make the receiver the default actor."

    self id: 0;pointer.!
 
direction
    "Returns the receiver's direction."

    ^self angle degrees!
  
direction: degrees
    "Sets the receiver's direction to an angle in degrees."

    ^self angle: (self angle degrees: degrees)!
  
doTag
    "Returns the receiver's doTag."

    ^self pointer doTag!
  
doTag: aNumber
    "Sets the receiver's doTag."

    ^self pointer doTag: aNumber asParameter!
   
doType
    "Returns the receiver's doType."

    ^self pointer doType!
   
doType: aNumber
    "Sets the receiver's doType."

    ^self pointer doType: aNumber asParameter!

east
    "Set the direction of the receiver to east."

    self direction:  0!
   
event
    "Returns the receiver's event."

    ^self pointer event!
  
event: aNumber
    "Sets the receiver's event."

    ^self pointer event: aNumber asParameter!
   
eyeHeight
    "Returns the receiver's eyeHeight."

    ^self pointer eyeHeight!
  
eyeHeight: aNumber
    "Sets the receiver's eyeHeight."

    ^self pointer eyeHeight: aNumber asFloat!
   
facingLine
    "Get the line in front of the receiver."

    ^self facingLine: 128!
  
facingLine: aDistance
    "Get the line in front of the receiver at distance aDistance."

    ^self lineAt: (self dll
        facingLine: self asParameter
        distance: aDistance)!
   
fixup
    "FixUp the receiver."

    self dll fixActor: self pointer asParameter!

flags
    "Returns the receiver's flags."

    ^self pointer flags!
  
flags: aNumber
    "Sets the receiver's flags."

    ^self pointer flags: aNumber asParameter!
   
frames
    "Returns the receiver's frames."

    ^self pointer frames!
   
frames: aNumber
    "Sets the receiver's frames."

    ^self pointer frames: aNumber asParameter!

getPosition: aPosition
    " Private - Fill aPosition with the receiver's position. "

    ^aPosition
        x: self x;
        y: self y;
        angle: self angle;
        sector: self sector;
        yourself!
   
go: aDistance
    "Move the receiver by aDistance."

    ^self space moveActor: self distance: aDistance!

goto: aPoint
    "Move the receiver to aPoint, and render it."

    self position: aPoint;render!

halfwit
    "Returns the receiver's halfwit."

    ^self pointer halfwit!

halfwit: aNumber
    "Sets the receiver's halfwit."

    ^self pointer halfwit: aNumber asFloat!
 
height
    "Returns the receiver's height."

    ^self pointer height!
   
height: aNumber
    "Sets the receiver's height."

    ^self pointer height: aNumber asFloat!

initializePointer
    " Private - Initializes the receiver's pointer with current actor setting."

    self pointer: (self dll actor: self asParameter).!

isActor
    "Returns true if the receiver is an actor."

    ^true!
  
isValid
    "True if the receiver is valid."

    ^id notNil and: [ self pointer notNil and: [self used] ]!
  
jump
    "The receiver try to jump."

    | jumpStream |
    self verticalForce: (self verticalForce - 6 "max: (self height / 2) negated")
"
    jumpStream := self propertyAt: #jumpStream ifAbsent: [].
    (jumpStream isNil or: [ jumpStream atEnd ])
    ifTrue: [
        jumpStream := ReadStream on: ((self height / 2) negated to: 0 by: 10).
        self propertyAt: #jumpStream put: jumpStream.
    ]
    ifFalse: [ ].

    self verticalForce: jumpStream next.
"!

latMov
    "Returns the receiver's latMov."

    ^self pointer latMov!
   
latMov: aNumber
    "Sets the receiver's latMov."

    ^self pointer latMov: aNumber asParameter!

location
    " Returns the receiver's position as a Point. "

    ^self position asPoint!

location: aPoint
    " Sets the receiver's position with a Point. "

    ^self position: aPoint!
 
makeCurrent
    "Make the receiver the current actor in its space."

    self space currentActor: self.!
 
mapNumber
    "Returns the receiver's mapNumber."

    ^self pointer mapNumber!
  
mapNumber: aNumber
    "Sets the receiver's mapNumber."

    ^self pointer mapNumber: aNumber asParameter!
   
maxHp
    "Returns the receiver's maxHp."

    ^self pointer maxHp!
  
maxHp: aNumber
    "Sets the receiver's maxHp."

    ^self pointer maxHp: aNumber asParameter!
   
mood
    "Returns the receiver's mood."

    ^self pointer mood!
 
mood: aNumber
    "Sets the receiver's mood."

    ^self pointer mood: aNumber asParameter!
  
move: aDistance
    "Move the receiver by aDistance."

    ^self space moveActor: self distance: aDistance!
  
moveBy: aDistance
    "Move the receiver by aDistance."

    ^self move: aDistance!
  
north
    "Set the direction of the receiver to north"

    self direction: 90!
  
number
    "Returns the receiver's number."

    ^self pointer number!
   
number: aNumber
    "Sets the receiver's number."

    ^self pointer number: aNumber asParameter!

numberOfDirections
    "Returns the receiver's numberOfDirections."

    ^self type numberOfDirections!
  
numberOfFrames
    "Returns the receiver's numberOfFrames."

    ^self type numberOfFrames!
  
percAttack
    "Returns the receiver's percAttack."

    ^self pointer percAttack!
   
percAttack: aNumber
    "Sets the receiver's percAttack."

    ^self pointer percAttack: aNumber asParameter!

physht
    "Returns the receiver's physht."

    ^self pointer physht!
   
physht: aNumber
    "Sets the receiver's physht."

    ^self pointer physht: aNumber asFloat!

place: aPoint
    "Place the receiver at aPoint and render it."

    self position: aPoint; render!
  
position
    " Returns the receiver's position. "

    ^self getPosition: (RenderAXPosition for: self)!
  
position: aPosition
    "Sets the receiver's position to aPosition.
    Returns the resulting position.
    aPosition can be:
        nil for default position
        aNumber for height
        aPoint for x,y location
        aRenderAXLocation for more presise information.
    "

    aPosition isNil ifTrue: [
        ^self position: self position
    ].
    aPosition isNumber ifTrue: [
        ^self position: (self position height: aPosition; yourself)
    ].
    aPosition isPoint ifTrue: [
        ^self position: (self position x: aPosition x; y: aPosition y ;yourself)
    ].

    self space position: self at: aPosition.
    ^self getPosition: aPosition!

range
    "Returns the receiver's range."

    ^self pointer range!
  
range: aNumber
    "Sets the receiver's range."

    ^self pointer range: aNumber asFloat!
   
render
    "Render the receiver if appropiate."

    self space render: self!

sector
    "Returns the receiver's sector."

    ^self space sector: self sectorID!
  
sectorID
    "Returns the receiver's sector ID."

    ^self pointer sector!
  
sendNotification
    "Set the receiver to send notification events."

    self setFlag: #sendNotification.!
  
setFrom: aWadMonster
	" Private - Build the receiver in current space from a DOOM monster."

	"Currently do nothing..."
	!
  
south
    "Set the direction of the receiver to south"

    self direction: 270!
 
spin: anAngle
    "Spins the receiver by anAngle."

    ^self space
        spin: self
        to: anAngle!

tag
    "Returns the receiver's tag."

    ^self pointer tag!

tag: aNumber
    "Sets the receiver's tag."

    ^self pointer tag: aNumber asParameter!
 
talkEvent
    "Returns the receiver's talkEvent."

    ^self pointer talkEvent!
  
talkEvent: aNumber
    "Sets the receiver's talkEvent."

    ^self pointer talkEvent: aNumber asParameter!
   
target
    "Returns the receiver's target."

    ^self pointer target!
   
target: aNumber
    "Sets the receiver's target."

    ^self pointer target: aNumber asParameter!

teleport
    "Teleports the receiver to a random sector and position."

    ^self
        teleportTo: nil "random sector"
        in: nil "random location"!
   
teleportTo: aPoint in: aSector
    "Teleports the receiver to a aSector at position determined by aPoint."

    | sector location height angle |
    sector := aSector isNil
        ifTrue: [ self space anySector ]
        ifFalse: [ aSector ].
    sector isNil ifTrue: [ ^self ].
    location := aPoint isNil
        ifTrue: [ sector anyPlace ]
        ifFalse: [ aPoint asPoint ].
    height := (aPoint respondsTo: #height)
        ifTrue: [ aPoint height ]
        ifFalse: [ sector floorHeight + self height ].
    angle := (aPoint respondsTo: #angle)
        ifTrue: [ aPoint angle ]
        ifFalse: [ RenderAXRandom between: 0 and: RenderAXAngle interval y ].

    self position:
        (RenderAXLocation new
            position: location;
            sector: sector;
            height: height;
            angle: angle;
            yourself).
    self fixup.!
  
turn: anAngle
    "Turn the receiver anAngle in slow motion manner."

    ^self turn: anAngle by: 10 * anAngle sign!
 
turn: anAngle by: step
    "Turn the receiver anAngle by step intervals."

    | start stop |
    start := self angle value.
    stop := start asParameter + anAngle asParameter.
    start to: stop by: step do: [:i| self angle: i;render ].!
   
turnAround
    "Turns the receiver completely around"

    ^self spin: RenderAXAngle new around!
 
type
    "Returns the receiver's type."

    ^self space actorType: self pointer actorType!
  
type: aType
    "Sets the receiver's type."

    ^self pointer actorType: aType asParameter!
 
used
    "Returns the receiver's used."

    ^self pointer used asBoolean!
   
used: aBoolean
    "Sets the receiver's used."

    ^self pointer used: aBoolean asParameter!

validTypes
    "Returns the receiver's valid types."

	^Array with: self type!
   
velocity
    "Returns the receiver's velocity."

    ^self pointer velocity!
 
velocity: aNumber
    "Sets the receiver's velocity."

    ^self pointer velocity: aNumber asFloat!
  
verticalForce
    "Returns the receiver's verticalForce."

    ^self pointer verticalForce!
  
verticalForce: aNumber
    "Sets the receiver's verticalForce."

    ^self pointer verticalForce: aNumber asFloat!
   
walk: aDistance
    "Move the receiver by aDistance and change to the next frame."

    self go: aDistance.
	self currentFrame: self currentFrame + 1 \\ (self numberOfFrames max: 1).!
 
west
    "Set the direction of the receiver to west"

    self direction: 180!
   
width
    "Returns the receiver's width."

    ^self halfwit * 2!

x
    "Returns the receiver's x."

    ^self pointer x!
  
x: aNumber
    "Sets the receiver's x."

    ^self pointer x: aNumber asFloat!
   
y
    "Returns the receiver's y."

    ^self pointer y!
  
y: aNumber
    "Sets the receiver's y."

    ^self pointer y: aNumber asFloat! !



!DoomActor class methods !
   
fromDirectory: aDirectory named: aName frames: frames directions: directions
	"Create a new instance of the receiver from files in aDirectory with prologue aName and frames&directions.
	For example if you evaluate:
		DoomActor
			fromDirectory: (Directory pathName: 'Maps\Example\Actors\Avatars\')
			named: 'Hero'
			frames: ($a to: $d)
			directions: (0 to: 7)
	the directory will be scanned to find bitmap files for an actor named 'Avtr0'
	with file names ranging from Avtr0a0.bmp to Avtr0a7.bmp
	a new actor will be returned with type defined by a..d (4) frames and 0..7 (8) directions
	"

	^self
		fromDirectory: aDirectory
		named: aName
		frames: frames
		directions: directions
		at: nil!
  
fromDirectory: aDirectory named: aName frames: frames directions: directions at: location
	"Create a new instance of the receiver from files in aDirectory with prologue aName and frames&directions.
	The actor will be placed at location.
	See method #fromDirectory:named:frames:directions:
	"

	^self
		type: (RenderAXActorType
			fromDirectory: aDirectory
			named: aName
			frames: frames directions: directions
			in: self space)
		at: location!
 
fromMonster: aWadMonster
	"Create a new instance of the receiver in current space from a DOOM monster."

	^self
		fromMonster: aWadMonster
		at: nil!
  
fromMonster: aWadMonster at: position
	"Create a new instance of the receiver in current space from a DOOM monster at position.
	If position is nil; teleport it to some point in the current space."

	^self new
		fromMonster: aWadMonster
		at: position!
  
load: interval framesFrom: aDirectory name: aName
	"Create a new instance of the receiver from count files in aDirectory with prologue aName.
	For example if you evaluate:
		DoomActor
			load: (0 to: 24)
			framesFrom: (Directory pathName: 'Maps\Example\Actors\')
			name: 'Baby'
	the directory will be scanned to find bitmap files for an actor named '2Gun'
	with file names ranging from 2Gun0000.bmp to 2Gun0024.bmp
	a new actor will be returned with type defined by them.
	"

	^self load: interval framesFrom: aDirectory name: aName at: nil!
 
load: interval framesFrom: aDirectory name: aName at: location
	"Create a new instance of the receiver from count files in aDirectory with prologue aName."

	| aType |
	aType := RenderAXActorType
		for: interval framesFrom: aDirectory
		name: aName.
	^self type: aType at: location!
   
type: aType at: location
	"Create a new instance of the receiver with type aType and add it to current space."

	| result |
	result := self new.
	result validTypes: (Array with: aType).
	RenderAXSpace current add: result type: aType at: location.
	location isNil ifTrue: [ result teleport ].
	^result! !



!DoomActor methods !
 
actorTypesFrom: aWadMonster
	" Private - Returns the valid types contructing them from aWadMonster. "

	validTypes := aWadMonster validTypes.
	validTypes size > 0 ifTrue: [ ^validTypes ].
	validTypes := OrderedCollection new.
	self registerActorTypesFrom: aWadMonster.
	aWadMonster validTypes: validTypes.!
   
fromMonster: aWadMonster at: position
	" Private - Create the receiver in current space from a DOOM monster."

	| aType |
	self actorTypesFrom: aWadMonster.
	aType := self validTypes first.
	self space add: self type: aType at: position.
	position isNil ifTrue: [ self teleport ].
	self setFrom: aWadMonster.!
   
initializeValidTypes
	" Private - Initializes the receiver's validTypes"

	validTypes := OrderedCollection with: self type.!
 
registerActorTypesFrom: aWadMonster
	" Private - Register the valid types contructing them from aWadMonster. "

	"OLD implementation>-> self space newActorType fromMonster: aWadMonster"
	| matrix last |
	matrix := aWadMonster frames.
	last := 1.
	[last < matrix size and: [(matrix at: last + 1) isArray]]
	whileTrue: [last := last  + 1].

	last < 2 ifTrue: [
		validTypes add:
		  (self space newActorType
			fromMonster: aWadMonster
			frames: (1 to: matrix size)
			name: aWadMonster name,'#1').
		^self
	].

	last = 2 ifTrue: [
		validTypes add:
		  (self space newActorType
			fromMonster: aWadMonster
			frames: (1 to: 1)
			name: aWadMonster name,'#1').
		validTypes add:
		  (self space newActorType
			fromMonster: aWadMonster
			frames: (2 to: 2)
			name: aWadMonster name,'#2').
		matrix size > last ifTrue: [
			validTypes add: (self space newActorType
				fromMonster: aWadMonster
				frames: (last + 1 to: matrix size)
				name: aWadMonster name,'#3')
		].
		^self
	].

	validTypes add: (self space newActorType
		fromMonster: aWadMonster
		frames: (1 to: (matrix size min: 4))
		name: aWadMonster name,'#1').

	matrix size > 4 ifTrue: [
		last := 5.
		[last < matrix size and: [(matrix at: last + 1) isArray]]
		whileTrue: [last := last  + 1].
		validTypes add: (self space newActorType
			fromMonster: aWadMonster
			frames: (5 to: last)
			name: aWadMonster name,'#2').

		matrix size > last ifTrue: [
			validTypes add: (self space newActorType
				fromMonster: aWadMonster
				frames: (last + 1 to: matrix size)
				name: aWadMonster name,'#3')
		].
	].!
 
useNextValidType
	"Set the receiver's type to next valid type."

	| types current |
	types := self validTypes.
	current := self type.
	current := types detect: [:one| one id = current id ] ifNone: [ ^self ].
	self
		type: (types last == current
			ifTrue: [ types first ]
			ifFalse: [ types at: (types indexOf: current) + 1 ]);
		currentFrame: 1;
		yourself!
 
validTypes
    "Returns the instance var of the receiver
     for external manipulation"

	validTypes isNil ifTrue: [ self initializeValidTypes ].
    ^validTypes!

validTypes: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    validTypes := anObject! !



!RenderAXResource class methods !

loadFrom: pathName
    "Try to load a collection of instances of the receiver form file named pathName.
    Returns the collection of instances loaded or nil if can't open file."

    | result file each |
    [ file := File pathNameReadOnly: pathName. ] on: Error do: [ ^nil ].
    result := OrderedCollection new.
    [
        [ file atEnd ] whileFalse: [
            each := self new loadFromStream: file.
            each notNil ifTrue: [ result add: each ].
        ].
    ] ensure: [ file close ].
    ^result !
  
save: aCollection to: pathName
    "Self a collection of instances of the receiver to file named pathName."

    | file |
    file := File newFile: pathName.
    [    aCollection do: [:each| each saveToStream: file ]
    ] ensure: [ file close ].! !



!RenderAXResource methods !
  
loadFromStream: aStream
    "The receiver must try to load itself from aStream.
    Can return nil if failed, else MUST return the receiver.
    This method must be implemented by subclasses."

    ^self implementedBySubclass!
 
saveToStream: aStream
    "The receiver must try to save itself to aStream.
    This method must be implemented by subclasses."

    ^self implementedBySubclass! !



!RenderAXActorType class methods !
   
for: interval framesFrom: aDirectory name: aName
	"Create a new instance of the receiver from interval files in aDirectory with prologue aName."

	^self for: interval framesFrom: aDirectory name: aName in: nil!
   
for: interval framesFrom: aDirectory name: aName in: aSpace
	"Create a new instance of the receiver from interval files in aDirectory with prologue aName."

	aSpace isNil ifTrue: [
		^self 
			for: interval framesFrom: aDirectory
			name: aName
			in: RenderAXSpace current
	].

	^aSpace unusedActorType
		for: interval framesFrom: aDirectory
		name: aName
		in: aSpace!
 
fromDirectory: aDirectory
	named: aName
	frames: frames directions: directions
	in: aSpace
	" Returns a new instance of the receiver built on files encountered in aDirectory. "

	aSpace isNil ifTrue: [
		^self 
			fromDirectory: aDirectory
			named: aName
			frames: frames directions: directions
			in: RenderAXSpace current
	].

	^aSpace unusedActorType
		fromDirectory: aDirectory
		named: aName
		frames: frames directions: directions
		in: aSpace! !



!RenderAXActorType methods !

bitmapBits
    " Private - Returns the bits mask for bitmaps. "

    ^self rotationBits - 1!
 
bitmapIDs
	"Returns the bitmapIDs matrix."

	| mask |
	mask := self bitmapBits.
	^self data
		collect: [:each|
			each isArray
			ifTrue: [ each collect: [:one| one bitAnd: mask ] ]
			ifFalse: [ each bitAnd: mask ]
		]!
  
data
	"Returns the data matrix."

	| matrix row |
	matrix := Array new: self directions.
    1 to: self directions do: [:y|
		row := Array new: self frames.
        1 to: self frames do: [:x|
           row at: x put: (self dataAt: x @ y - 1)
        ].
		matrix at: y put: row.
    ].
	^matrix!
 
dataAt: aPoint
    "Returns the data pointer of data at aPoint (or nil)."

    ^self dll
        getTypeData: self asParameter
        frame: aPoint x
        dir: aPoint y!
 
dataValues
	" Private - Returns the values in an array. "

	| result matrix tuple |
	result := OrderedCollection new.
	matrix  := self data.
	1 to: matrix size do: [:i|
		tuple := matrix at: i.
		tuple isArray
		ifTrue: [ result addAll: tuple ]
		ifFalse: [ result add: tuple ]
	].
	^result asArray!
 
directions
    " Returns the receiver's number of directions."

    ^self dll getTypeDirs: self asParameter.!

display
	"Display the receiver's dibs (in tile mode) at aPoint with aPen."

	^self displayDIBs!
  
displayDIBs
	"Display the receiver's dibs on display."

	^self displayDIBsAt: 0@0 with: Display pen!
 
displayDIBsAt: aPoint with: aPen
	"Display the receiver's dibs at aPOint with aPen."

	^self displayDIBsAt: aPoint with: aPen gap: 0@0!
  
displayDIBsAt: aPoint with: aPen gap: distance
    "Display the receiver's dibs (in tile mode) at aPoint with aPen."

    | matrix offset extent x y displayDIB aDIB |
    distance isPoint ifFalse: [
        ^self displayDIBsAt: aPoint with: aPen gap: distance @ distance
    ].
    displayDIB := [:aBitmapID|
        aDIB := self getBitmapDIB: aBitmapID.
        aDIB notNil ifTrue: [
            aDIB := aDIB asDIB.
            extent := extent max: aDIB extent.
            aDIB displayAt: offset with: aPen.
            (self isReversed: x@y)
            ifTrue: [ aPen reverse: (offset extent: extent) ].
        ]
        ifFalse: [ aPen fill: (offset extent: extent) color: Color white ].
    ].
    extent := 0@0.
    matrix := self bitmapIDs.
    offset := aPoint.
    y := 1.
    matrix do: [:line|
        x := 1.
        line isArray
        ifTrue: [
            line do: [:each|
                displayDIB value: each.
                offset := offset + (distance x + extent x @ 0).
                x := x + 1.
            ].
        ]
        ifFalse: [ displayDIB value: line ].
        offset := aPoint x @ (offset y + extent y + distance y).
        y := y + 1.
    ]!

for: interval framesFrom: aDirectory name: aName in: aSpace
	"Load the receiver from interval files in aDirectory with prologue aName."

    | matrix array reversed frames texture |
	array := RenderAXMetaTexture
		for: interval
		framesFrom: aDirectory
		name: aName
		in: aSpace.
	matrix := array first.
	reversed := array last.
    "Warning: the receiver must have a valid id"
    self dll
        setType: self asParameter
        name: aName
        extent: matrix first size @ matrix size.
    1 to: matrix size do: [:i|
		frames := matrix at: i.
        1 to: frames size do: [:j|
			texture := frames at: j.
            self dll
                setType: self asParameter
                at: i @ j - 1
                with: texture
				reversed: ((reversed at: i) at:j)
        ].
    ].
    ^self!
 
frames
    " Returns the receiver's number of frames."

    ^self dll getTypeFrames: self asParameter.!
  
fromDirectory: aDirectory
    named: aName
    frames: frames directions: directions
    in: aSpace
    " Loads the receiver from files encountered in aDirectory. "

    | texture textureName |
    "Warning: the receiver must have a valid id"
    self dll
        setType: self asParameter
        name: aName
        extent: frames size @ directions size.
    directions do: [:y|
        frames do: [:x|
            textureName :=
                    aName,
                    (x isCharacter ifTrue: [String with: x] ifFalse: [x asString]),
                    (y isCharacter ifTrue: [String with: y] ifFalse: [y asString]).
            texture := aSpace unusedTexture
                initialize: textureName
                fromDIB: (DIB fromFile:(
                    aDirectory drivePathName,'\',
                    textureName,'.bmp'))
                transparent: true.
            self dll
                setType: self asParameter
                at: (directions indexOf: y) @ (frames indexOf: x) - 1
                with: texture reversed: false
        ].
    ].
    ^self!
 
fromMonster: aWadMonster frames: interval name: aName
    " Private - Create the receiver in current space from a DOOM monster's dibs matrix."

    | frames directions cache texture extent rotated direction directionMap |
    directions := (aWadMonster frames at: interval first) size max: 1.
    frames := interval size.
	directions = 1
	ifTrue: [ directionMap := #(1) ]
	ifFalse: [
		directionMap := #( "transformation for direction maps"
			"1" 5		"2" 6		"3" 3		"4" 8
			"5" 1		"6" 2		"7" 7		"8" 4
			).
	].
    self dll
        setType: self asParameter
        name: aName asParameter
        extent: frames @ directions.
	extent := aWadMonster extentFrom: interval first to: interval last.
    cache := Dictionary new.
    1 to: directions do: [:x| "1|8"
		direction := directionMap at: x.
        interval first to: interval last do: [:y|
            texture := self
                textureFromMonster: aWadMonster
                at: x@y using: cache extent: extent.
			rotated := aWadMonster isRotated: x@y.
			"rotated ifTrue: [ self halt ]."
            self dll
                setType: self asParameter
                at: direction - 1 @ (y - interval first)
                with: texture asParameter
                reversed: rotated.
        ].
    ].
    ^self!
   
isReversed: aPoint
    "Returns true if the bitmap at aPoint will be shown flipped."

    ^((self dataAt: aPoint - 1) bitAnd: self rotationBits) ~= 0!
   
isValid
	"Returns true if there are at least one valid data."

	id isNil ifTrue: [ ^false ].
	id = 0 ifTrue: [ ^true ]. "default"
	(self directions < 0 or: [self frames < 0]) ifTrue: [ ^false ].
	(self directions = 0 and: [self frames = 0]) ifTrue: [ ^false ].
    self dataValues detect: [:one| one ~= 0 ] ifNone: [ ^false ].
	^true!
  
loadFromStream: aStream
    "The receiver must try to load itself from aStream.
    Can return nil if failed, else MUST return the receiver.

    RenderAXActorType loadFrom: 'maps\default.typ'
    "

    | frames directions name bytes data |
    self id: aStream nextULong.
    directions := aStream nextULong.
    frames := aStream nextULong.
    name := (aStream next: 8) trimBlanks.
    self dll
        setType: self asParameter
        name: name
        extent: directions @ frames - 1.
    0 to: directions - 1 do: [:y|
        0 to: frames - 1 do: [:x|
			data := aStream nextULong.
            self dll
                setType: self asParameter
                at: x @ y
                with: (data bitAnd: self bitmapBits) "textureID"
                reversed: (data bitAnd: self rotationBits) ~= 0 "isRotated?"
        ].
    ].
    ^self
"
    | file bytes |
    file := File pathNameReadOnly: 'ale.typ'.
    bytes := file contents asByteArray.
    file close.
    ^bytes inspect
"!
 
name
    " Returns the receiver's name"

    ^self dll getTypeNameString: self asParameter.!
 
numberOfDirections
    "Returns the receiver's number of directions."

    ^self directions!
 
numberOfFrames
    "Returns the receiver's number of frames."

    ^self frames!
 
printOn: aStream
    "Append the ASCII representation of the receiver to aStream."

    super printOn: aStream.
    self isValid not ifTrue: [^self].
	aStream space.
	self data printOn: aStream!

reset
    "Reset the receiver."

    self dll
        setType: self asParameter
        name: String new asParameter
        extent: 0@0.
	self pointer: nil.!
   
rotationBits
    " Private - Returns the bits mask for rotations. "

    ^2r10000000000!
 
rotationFlags
	" Private - Returns the rotation matrix. "

	| rotation |
	rotation := [:bitmapID|
		(bitmapID bitAnd: self rotationBits) ~= 0
	].
	^self data
	collect: [:each|
		each isArray
		ifTrue: [ each collect: [:one| rotation value: one ] ]
		ifFalse: [ rotation value: each ]
	]!
 
saveToStream: aStream
    "The receiver must try to save itself to aStream."

    | address bytes aName |
	aName := self name.
    aStream
        nextULongPut: self id;
        nextULongPut: self directions;
        nextULongPut: self frames;
        nextPutAll: aName;
        next: 8 - aName size put: 0 asCharacter;
        yourself.
    0 to: self directions - 1 do: [:y|
        0 to: self frames - 1 do: [:x|
            aStream nextFourBytesPut: (self dataAt: x @ y)
        ].
    ].
    ^self!

textureFromMonster: aWadMonster at: aPoint using: cache extent: extent
	" Private - Returns the textureID for sprite at aPoint in aWadTexture using cache."

    | sprite texture |
	sprite := aWadMonster spriteAt: aPoint.
	sprite isNil ifTrue: [ ^self space emptyTexture ].
	(cache includesKey: sprite) ifTrue: [ ^cache at: sprite ].
	texture := sprite textureIn: self space extent: extent.
	cache at: sprite put: texture.
	^texture! !



!RenderAXBitmap class methods !
  
fromDIB: aDIB name: aName
    "Returns a new instance of the receiver from aDIB."

	^self new fromDIB: aDIB name: aName! !



!RenderAXBitmap methods !
  
adapt: extent bits: bits from: aBitmapInfo
	" Private - Adapt pixels in bits to fliped format of RenderAX and adapt palette colors."

	| result renderAXBitmapInfo scanLineSize scanLine start start2 |
	result := bits copy.
	scanLineSize := self scanLineSize: extent x.
	scanLine := ByteArray new: scanLineSize.
	0 to: extent y // 2 do: [:y|
		start := y * scanLineSize + 1.
		start2 := scanLineSize * (extent y - y - 1) + 1.
		scanLine
			replaceFrom: 1 to: scanLineSize
		    with: result startingAt: start.
		result
			replaceFrom: start to: start + scanLineSize - 1
		    with: result startingAt: start2;
			replaceFrom: start2 to: start2 + scanLineSize - 1
		    with: scanLine startingAt: 1.
	].

	renderAXBitmapInfo := self getBitmapInfo: extent.
	(RenderAXColorConverter
		from: aBitmapInfo
		to: renderAXBitmapInfo)
		convert: result.

	^result!
  
adaptExtent: extent bits: bits to: realExtent
	" Private - Adapt arguments to create a new (correctly sized) bitmap."

	| x y correct input output scanLine scanLineSize newScanLineSize newBits |
	correct := [:value|
		self validBitmapSizes
			detect: [:one| one >= value]
			ifNone: [ self error: 'Value too long to create a bitmap.' ]
	].
	x := correct value: "e"realExtent x.
	y := correct value: "e"realExtent y.
	scanLineSize := self scanLineSize: extent x.
	newScanLineSize := self scanLineSize: x.

	input := ReadStream on: bits.
	output := WriteStream on: (newBits := bits species new: newScanLineSize * y).
	output next: y - extent y * newScanLineSize put: 0.
	[input atEnd] whileFalse: [
		[ scanLine := input next: scanLineSize. ] on: Error
			do: [ scanLine := Array new. input upTo: nil ].
		output
			nextPutAll: scanLine;
			next: newScanLineSize - scanLine size put: 0;
			yourself
	].
	^Array with: x@y with: newBits!
  
asDIB
	"Returns the receiver as a DIB."

	^(self getBitmapDIB: self id) asDIB!
   
chechTransparentDIB: aDIB
    "Check aDIB for proper transparecy settings."

    | bits colorTable usedEntries tuple veryDark |
	veryDark := self veryDarkColor.
    bits := aDIB bits.
    colorTable := aDIB bitmapInfo colorTable.
    usedEntries := bits asSet.
    usedEntries remove: 0 ifAbsent: [].
    1 to: 255 do: [:i|
        ( (colorTable at: i*4) = 0
          and: [ (colorTable at: i*4 + 1) = 0
          and: [ (colorTable at: i*4 + 2) = 0 ]]) "black"
        ifTrue: [ "must be replaced to a dark color because black is transparent"
            colorTable at: i*4 put: (veryDark at: 1).
            colorTable at: i*4+1 put: (veryDark at: 2).
            colorTable at: i*4+2 put: (veryDark at: 3).
        ].
    ].
    colorTable at: 1 put: 0; at: 2 put: 0; at: 3 put: 0; yourself.
    aDIB bitmapInfo colorTable: colorTable.
    ^true!
 
dumpBytesFrom: source
    " Private - Returns the bytes to dump from source pointer. "

    | width height destination start dest |
    width := self width.
    height := self height.
    destination := ByteArray new: width * height.
    0 to: width - 1 do: [:x|
        start := x * height + 1.
        0 to: height - 1 do: [:y|
            dest := y * width + x + 1.
            destination
                replaceFrom: dest to: dest
                with: source startingAt: start.
            start := start + 1
        ].
    ].
    ^destination!
 
extent
    "Returns the receiver extent."

    ^self width @ self height!

fromDIB: aDIB name: aName transparent: transparent
    "The receiver must try to build itself from aDIB."

    | extent bits array |
    transparent ifTrue: [
        self chechTransparentDIB: aDIB
    ].
    extent := aDIB extent.
    bits := self
        adapt: extent
        bits: aDIB bits
        from: aDIB bitmapInfo.
    (self isValidBitmapExtent: extent) not
    ifTrue: [
        array := self adaptExtent: extent bits: bits to: extent.
        extent := array first.
        bits := array last.
    ].
    self dll
        newBitmap: self asParameter
        extent: extent bytes: bits
        name: aName.
    self pointer: nil. "force pointer rebuild"
    ^self!
 
fromPicture: aLumpPicture
    "The receiver must try to build itself from aLumpPicture."

    ^self fromPicture: aLumpPicture extent: aLumpPicture extent!
   
fromPicture: aLumpPicture extent: realExtent
    "The receiver must try to build itself from aLumpPicture."

    | extent name array bits aDIB |
    extent := aLumpPicture extent.
    name := aLumpPicture name.
	aDIB := aLumpPicture asDIB.
	bits := self
		adapt: extent
		bits: aDIB bits
		from: aDIB bitmapInfo.

	((self isValidBitmapExtent: extent) not
	or: [ extent ~= realExtent ])
	ifTrue: [
		array := self adaptExtent: extent bits: bits to: realExtent.
		extent := array first.
		bits := array last.
	].
    self dll
        newBitmap: self asParameter
        extent: extent bytes: bits
        name: name.
    self pointer: nil. "force pointer rebuild"
    ^self!

height
    "Returns the receiver's height."

    ^self dll getBitmapHeight: self asParameter!

initializePointer
    " Private - Initializes the receiver's pointer from dll."

    self pointer: (self dll getBitmapPointer: self asParameter).!
   
isValid
    "The receiver is valid if width > 0."

    ^self width > 0 and: [ super isValid ]!
   
isValidBitmapExtent: extent
    "Returns true if the extent is valid for creating a RenderAXBitmap."

    ^(self validBitmapSizes includes: extent x)
    and: [self validBitmapSizes includes: extent y]!
  
loadFromStream: aStream
    "The receiver must try to load itself from aStream.
    Can return nil if failed, else MUST return the receiver."

    | width height name bytes |
    self id: aStream nextULong.
    width := aStream nextULong.
    height := aStream nextULong.
    name := (aStream next: 32) trimBlanks.
    aStream next: 256. "zero hole"
    bytes := aStream next: width * height.
    self dll
        newBitmap: self asParameter
        extent: width @ height
        bytes: bytes
        name: name.
    self pointer: nil. "force pointer rebuild"
    ^self!

name
    " Returns the receiver's name"

    ^self dll getBitmapNameString: self asParameter.!
   
saveToStream: aStream
    "The receiver must try to save itself to aStream."

    aStream
        nextULongPut: self id;
        nextULongPut: self width;
        nextULongPut: self height;
        nextPutAll: self name;
        next: 32 - self name size put: 0 asCharacter;
        next: 256 put: 0 asCharacter; "zero hole"
        nextPutAll: (self dumpBytesFrom: self pointer) asString;
        yourself.
    ^self!
  
scanLineSize: width
	" Private - Returns the scan line size for image of width in pixels."

	^width * 8 + 31 // 32 * 4!
  
validBitmapSizes
	"Private - Returns the valid extents for creating a RenderAXBitmap.
	Width and Height must be times two power."

	^#(8 16 32 64 128 256)!
 
veryDarkColor
	" Private - Returns the tuple to be used as a veryDarlk color.
	The color will be extracted from valid color info."

	| bitmapInfo colorTable tuple intensity x y z current value threshold |
	tuple := #(0 32 64).
	bitmapInfo := self getBitmapInfo: 1@1.
	intensity := [:xyz|
		x := xyz at: 1. y := xyz at: 2. z := xyz at: 3.
		x + y + z
	].
	threshold := intensity value: #(0  0  64). "dark blue"
	colorTable := bitmapInfo colorTable.
	1 to: 255 do: [:i|
		current := colorTable copyFrom: i*4 to: i*4 + 3.
		value := intensity value: current.
		(value >= threshold and: [value < (intensity value: tuple)])
		ifTrue: [ tuple := current ].
	].
	^tuple!
  
width
    "Returns the receiver's width."

    ^self dll getBitmapWidth: self asParameter! !



!RenderAXFlat methods !
  
dumpBytesFrom: source
    " Private - Returns the bytes to dump from source pointer. "

    | flatSize destination dest start |
    flatSize := self width.
    destination := ByteArray new: flatSize * flatSize.
    dest := 1.
    start := 1.
    0 to: flatSize - 1 do: [:j|
        destination
            replaceFrom: dest to: dest + flatSize - 1
            with: source
            startingAt: start.
        start := start + 256.
        dest := dest + flatSize.
    ].
    ^destination!
 
initializePointer
    " Private - Initializes the receiver's pointer from dll."

    self pointer: (self dll getFlatPointer: self asParameter).!
 
isValid
    "The receiver is valid if width > 0."

    ^self width > 0 and: [ super isValid ]!
   
loadFromStream: aStream
    "The receiver must try to load itself from aStream.
    Can return nil if failed, else MUST return the receiver."

    | size name bytes |
    self id: aStream nextULong.
    size := aStream nextULong.
    name := (aStream next: 32) trimBlanks.
    aStream next: 256. "zero hole"
    bytes := aStream next: size * size.
    self
        name: name
        width: size
        bytes: bytes.
    self pointer: nil. "force pointer rebuild."
    ^self!
 
name
    " Returns the receiver's name"

    ^self dll getFlatNameString: self asParameter.!
 
name: aName width: width bytes: aByteArray
    "Sets the receiver with aName, width and bytes."

    self dll
        newFlat: self asParameter
        width: width
        address: aByteArray
        name: aName asParameter.
    self pointer: nil. "force pointer rebuilt"!
   
saveToStream: aStream
    "The receiver must try to save itself to aStream."

    aStream
        nextULongPut: self id;
        nextULongPut: self width;
        nextPutAll: self name;
        next: 32 - self name size put: 0 asCharacter;
        next: 256 put: 0 asCharacter; "zero hole"
        nextPutAll: (self dumpBytesFrom: self pointer) asString;
        yourself.
    ^self!
  
width
    "Returns the receiver's width."

    ^self dll getFlatWidth: self asParameter! !



!RenderAXMetaTexture class methods !
   
for: interval framesFrom: aDirectory name: aName in: aSpace
	"Returns the matrices with new textures and inversions for count images of an actor type."

	| matrix inversions textures textureName |
	matrix := self layoutFor: interval.
	inversions := matrix collect: [:tuple| tuple collect: [:each| each > 0 ]].
	textures := matrix collect: [:row|
		row collect: [:number|
			textureName := number abs asString.
			[textureName size < 4] whileTrue: [ textureName := '0',textureName ].
			textureName := aName,textureName.
			aSpace unusedTexture
                initialize: textureName
                fromDIB: (DIB fromFile:(
                    aDirectory drivePathName,'\',
                    textureName,'.bmp'))
                transparent: true
		]
	].
	^Array
		with: textures
		with: inversions!
 
layoutFor: interval
	"Private - Returns the matrix for indices of bitmaps."

	interval = (1 to: 25) ifTrue: [ "directions=8 frames=5 start=1"
		^#(
			(1 2 3 4 5)
			(6 7 8 9 10)
			(11 12 13 14 15)
			(16 17 18 19 20)
			(21 22 23 24 25)
			(-16 -17 -18 -19 -20)
			(-11 -12 -13 -14 -15)
			(-6 -7 -8 -9 -10)
		)
	].

	interval = (0 to: 24) ifTrue: [ "directions=8 frames=5 start=0"
		^#(
			(0 1 2 3 4)
			(5 6 7 8 9)
			(10 11 12 13 14)
			(15 16 17 18 19)
			(20 21 22 23 24)
			(-15 -16 -17 -18 -19)
			(-10 -11 -12 -13 -14)
			(-5 -6 -7 -8 -9)
		)
	].

	interval = (0 to: 9) ifTrue: [ "directions=8 frames=2 start=0"
		^#( (0 1) (2 3) (4 5) (6 7) (8 9) (-6 -7) (-4 -5) (-2 -3) )
	].

	interval = (1 to: 10) ifTrue: [ "directions=8 frames=2 start=1"
		^#( (1 2) (3 4) (5 6) (7 8) (9 10) (-7 -8) (-5 -6) (-3 -4) )
	].

	interval = (0 to: 7) ifTrue: [ "directions=8 frames=1 start=0"
		^#( (0) (1) (2) (3) (4) (5) (6) (7) )
	].

	interval = (1 to: 8) ifTrue: [ "directions=8 frames=1 start=1"
		^#( (1) (2) (3) (4) (5) (6) (7) (8) )
	].

	interval = (0 to: 4) ifTrue: [ "directions=8 frames=1 start=0"
		^#( (0) (1) (2) (3) (4) (-3) (-2) (-1) )
	].

	interval = (1 to: 5) ifTrue: [ "directions=8 frames=1 start=1"
		^#( (1) (2) (3) (4) (5) (-4) (-3) (-2) )
	].

	self error: 'Invalid interval.'! !



!RenderAXMetaTexture methods !
 
display
	" Display the receiver's patches tiled on display. "

	^self displayAt: 0@0 with: Display pen!
  
displayAt: aPoint
	" Display the receiver's patches tiled on display. "

	^self displayAt: aPoint with: Display pen!
 
displayAt: aPoint with: aPen
	" Display the receiver's patches tiled at aPoint with aPen. "

	| extent location |
	extent := self extent.
	location := aPoint.
	self patches do: [:each|
		aPen place: location;box: location + extent.
		each displayAt: location with: aPen.
		location := location + (0 @ extent y)
	].!
   
empty
	" Set the receiver as an empty texture (used for invisible characters). "

    self dll
        newTexture: self id
        extent: 0@0
        name: #empty asParameter.
    self pointer: nil. "force pointer rebuild"
    ^self!
  
extent
    "Returns the receiver's extent."

    ^self width @ self height!
  
extent: aPoint
    "Sets the receiver's extent."

    self
        width: aPoint x;
        height: aPoint y;
        yourself!
   
fromPicture: aLumpPicture
    "The receiver must try to build itself from aLumpPicture."

    ^self fromPicture: aLumpPicture extent: aLumpPicture extent!
   
fromPicture: aLumpPicture extent: extent
    "The receiver must try to build itself from aLumpPicture."

    | number width height numPatches aName x y bitmap |
    number := self id.
    width := aLumpPicture width.
    height := aLumpPicture height.
    numPatches := 1.
    aName := aLumpPicture name.
	bitmap := self space newBitmap
		fromPicture: aLumpPicture extent: extent.
    self dll
        newTexture: number
        extent: bitmap extent
        name: aName asParameter.
    self id: number;pointer: nil. "force pointer rebuild"
    self dll
		newPatch: number
		bitmap: bitmap asParameter
		at: 0@0.
    ^self "display"!
  
height
    "Returns the height"

    ^self pointer height!
   
height: anInteger
    "Sets the height with anInteger"

    self pointer
        height: anInteger;
        hf: anInteger asFloat;
        yourself!
  
hMask
    "Returns the hMask"

    ^self pointer hMask!
  
hMask: anInteger
    "Sets the hMask with anInteger"

    ^self pointer hMask: anInteger!

initialize: aName fromDIB: aDIB patches: patches
    "The receiver must try to initialize itself from aDIB."

	| x y extent aBitmap |
	extent := aDIB extent.
	patches do: [:each|
		aBitmap := each at: 3.
		extent x: (extent x max: aBitmap extent x).
		extent y: (extent y max: aBitmap extent y).
	].

    self dll
        newTexture: self id
        extent: extent
        name: aName.
    self pointer: nil. "force pointer rebuild"
    patches do: [:patch|
        x := patch at: 1.
        y := patch at: 2.
        self dll
            newPatch: self id
            bitmap: (patch at: 3) asParameter
            at: x @ y
    ].
    ^self!
  
initialize: aName fromDIB: aDIB transparent: aBoolean
    "The receiver must try to initialize itself from aDIB."

    ^self initialize: aName fromDIB: aDIB
        patches: (self patchSpec: aName fromDIB: aDIB transparent: aBoolean)!
  
initializeId
    " Private - Initializes the receiver's id."

    self isValid ifFalse: [ ^super initializeId ].
    self id: self number.!
 
initializePointer
    " Private - Initializes the receiver's pointer with current sector setting."

    self pointer: (self dll metaTexture: self asParameter).!
 
isTexture
    "Returns true if the receiver is a texture."

    ^true!
   
isValid
    " Private - True if the receiver is valid."

    super isValid ifFalse: [ ^false ].
	^self width > 0 | (self height > 0)
		or: [ self numPatches > 0]!
 
loadFromStream: aStream
    "The receiver must try to load itself from aStream.
    Can return nil if failed, else MUST return the receiver."

    | number width height numPatches aName x y bitmapID |
    number := aStream nextULong.
    width := aStream nextULong.
    height := aStream nextULong.
    numPatches := aStream nextULong.
    aName := (aStream next: 8) trimBlanks.
    self dll
        newTexture: number
        extent: width @ height
        name: aName.
    self id: number;pointer: nil. "force pointer rebuild"
    1 to: numPatches do: [:i|
        x := aStream nextULong.
        y := aStream nextULong.
        bitmapID := aStream nextULong.
        number := aStream nextULong.
        self dll
            newPatch: number
            bitmap: bitmapID
            at: x @ y
    ].
    ^self!
  
mask
    "Returns the mask point"

    ^self wMask @ self hMask!
 
mask: aPoint
    "Sets the mask point"

    self
        wMask: aPoint x;
        hMask: aPoint y!
 
name
    " Returns the receiver's name"

    ^self dll getTextureNameString: self asParameter.!
  
number
    "Returns the receiver's number"

    ^self pointer number!

number: aNumber
    "Sets the receiver's number"

    self pointer number: aNumber.
    self id: aNumber!
   
numPatches
    "Returns the numPatches"

    ^self pointer numPatches!
   
numPatches: aNumber
    "Sets the receiver's numPatches"

    self pointer numPatches: aNumber asInteger!

patchAt: anIndex
    "Returns the patch at anIndex."

    ^RenderAXPatch new
        pointer: (self pointer patchAt: anIndex)!
  
patches
    "Returns the patches array."

    ^(1 to: self numPatches)
    collect: [:index| self patchAt: index ].!

patchSpec: aName fromDIB: aDIB transparent: aBoolean
    "Returns a collection of patch specification arrays to show from aDIB."

    | patchSpec |
    patchSpec := Array new: 3.
    patchSpec
        at: 1 put: 0"x offset";
        at: 2 put: 0"y offset";
        at: 3 put: (self space newBitmap fromDIB: aDIB name: aName transparent: aBoolean);
        yourself.
    ^Array with: patchSpec!
 
saveToStream: aStream
    "The receiver must try to save itself to aStream."

    | size name |
    name := self name.
    name isNil ifTrue: [ name := String new ].

    self isValid ifFalse: [ "write an empty entry"
        aStream
            nextULongPut: self id;
            nextULongPut: 0; "width"
            nextULongPut: 0; "height"
            nextULongPut: 0; "numPatches"
            nextPutAll: name;
            next: 8 - name size put: 0;
            yourself.
        ^self
    ].

    aStream
        nextULongPut: self id;
        nextULongPut: self width;
        nextULongPut: self height;
        nextULongPut: self numPatches;
        nextPutAll: name;
        next: 8 - name size put: 0 asCharacter;
        yourself.
    self patches do: [:patch|
        aStream
            nextULongPut: patch width;
            nextULongPut: patch height;
            nextULongPut: patch bitmapID;
            nextULongPut: self id;
            yourself.
    ].
    ^self!
 
width
    "Returns the width"

    ^self pointer width!
  
width: anInteger
    "Sets the width with anInteger"

    self pointer
        width: anInteger;
        wf: anInteger asFloat;
        yourself!
 
wMask
    "Returns the wMask"

    ^self pointer wMask!
  
wMask: anInteger
    "Sets the wMask with anInteger"

    ^self pointer wMask: anInteger! !



!RenderAXValueObject class methods !
  
interval
    "Must returns the valid interval values for the receiver if applicable (or nil).
    WARNING: intervals MUST be aPoint..."

    ^nil "by default we use free values"!
  
value: aValue
    "Returns an instance of the receiver with value aValue."

    ^self new
        value: aValue;
        yourself! !



!RenderAXValueObject methods !
 
asFloat
    "Returns the receiver's value as a float."

    ^self value asFloat!
 
interval
    "Must returns the valid interval values for the receiver if applicable (or nil)."

    ^self class interval!

negated
    "Returns an instance to rotate un reverse angle."

    ^self species new
        value: self value negated;
        yourself!
  
sign
    "Returns the sign of the receiver."

    ^self value sign!
  
value
    "Returns the receiver's id as value."

    | interval result modulus |
    result := self id.
    (interval := self interval) isNil ifTrue: [ ^result ].
    modulus := interval y - interval x + 1.
    [result between: interval x and: interval y]
    whileFalse: [
        result := result < interval x
            ifTrue: [ result + modulus ]
            ifFalse: [ result - modulus ]
    ].
    ^result!
 
value: aValue
    "Sets the receiver's id as value."

    ^self id: aValue! !



!RenderAXAngle class methods !
  
getAngle: aPoint
    "Returns the angle from aPoint."

    ^self new
        getAngle: aPoint;
        value!
  
interval
    "Must returns the valid interval values for the receiver."

    ^0 @ 1023!
  
random
	"Returns a random instance of the receiver."

	^self new
		value: (RenderAXRandom
			between: self interval x
			and: self interval y) truncated;
		yourself! !



!RenderAXAngle methods !
  
around
    "Sets the receiver to completelly turn around action."

    self value: 512!
  
degrees
    "Returns the receiver's value in degrees.
    In 4DX terms, there are 1024 internal degrees in a circle."

    ^self value \\ 1024 * 360 / 1024 asFloat!

degrees: anInteger
    "Sets the receiver to anInteger degrees.
    In 4DX terms, there are 1024 internal degrees in a circle."

    | degrees |
    degrees := anInteger \\ 360 * 1024 / 360.
    self value: degrees truncated!
 
fixup
    "FixUp the receiver."

    self dll fixAngle: self asParameter!

getAngle: aPoint
    "Set the receiver's value from aPoint."

    ^self value: (self dll getAngle: aPoint)! !



!RenderAXLine class methods !
   
flagNames
    " Returns the flag names aplicables to the receiver's instances.
    WARNING: the flags must be in proper bits order."

    ^#(
        bounded
        tripCross
        tripActivate
        extendCeiling
        notOnMap
        seen
        skipCeiling
        translucent
        impassable
        pegB
        pegT
        dontRender
    "remaining bits are unused...yet"
    )!
 
tripFlagNames
    " Returns the tripFlag names aplicables to the receiver's instances.
    WARNING: the tripFlags must be in proper bits order."

    ^#(
        floor
        ceiling
        unKnown2
        unKnown3
        oneTime
        teleport
        rotateSect
        changeSector
        flipTextures
        unrotateSector
        sendNotification
    "remaining bits are unused...yet"
    )! !



!RenderAXLine methods !
  
corner
    "Returns the destination"

    ^self destination!
 
cos
    "Returns the receiver's cos"

    ^self pointer cos!
 
cos: aNumber
    "Sets the receiver's cos"

    ^self pointer cos: aNumber asFloat!
  
destination
    "Returns the destination"

    ^self x2 @ self y2!
   
distance
    "Returns the receiver's distance"

    ^self pointer distance!
  
distance: aNumber
    "Sets the receiver's distance"

    ^self pointer distance: aNumber asFloat!
   
doTag
    "Returns the receiver's doTag"

    ^self pointer doTag!
   
doTag: aNumber
    "Sets the receiver's doTag"

    ^self pointer doTag: aNumber asParameter!

doType
    "Returns the receiver's doType"

    ^self pointer doType!

doType: aNumber
    "Sets the receiver's doType"

    ^self pointer doType: aNumber asParameter!
 
dx
    "Returns the receiver's dx"

    ^self pointer dx!

dx: aNumber
    "Sets the receiver's dx"

    ^self pointer dx: aNumber asFloat!
 
dy
    "Returns the receiver's dy"

    ^self pointer dy!

dy: aNumber
    "Sets the receiver's dy"

    ^self pointer dy: aNumber asFloat!
 
facing
    "Returns the receiver's facing"

    ^self pointer facing!

facing: aNumber
    "Sets the receiver's facing"

    ^self pointer facing: aNumber asParameter!
 
facingSector
    "Returns the receiver's facing sector"

    ^self space sector: self facing!

fixup
    "FixUp the receiver."

    self dll fixLine: self pointer asParameter!
 
flags
    "Returns the receiver's flags"

    ^self pointer flags!
   
flags: aNumber
    "Sets the receiver's flags"

    ^self pointer flags: aNumber asParameter!

from
    "Returns the receiver's from Vertex"

    ^self space vertex: self fromVert!

fromVert
    "Returns the receiver's fromVert"

    ^self pointer fromVert!
  
fromVert: aNumber
    "Sets the receiver's fromVert"

    ^self pointer fromVert: aNumber asParameter!
   
getID
    " Private - Get the receiver's id from its pointer. "

    ^self id: self lineNumber!
  
isBounded
    "True if the receiver is bounded."

    ^self currentFlagNames includes: #bounded!
 
isClosed
    "Returns true if the line is a sector cross boundary and has the seen flag off."

    ^self isDoor and: [ self facingSector height = 0 ]!
   
isDoor
    "Returns true if the line is a sector cross boundary."

    ^self sectorID ~= self facing!

isLine
    "Returns true if the receiver is a line."

    ^true!
 
isOpen
    "Returns true if the line is a sector cross boundary and has the seen flag on."

    ^self isDoor and: [ self isClosed not ]!
 
isSeen
    "True if the receiver is seen."

    ^self currentFlagNames includes: #seen!
  
isWall
    "True if the receiver is bounded wall."

    ^self isBounded!
 
length
    "Returns the receiver's length"

    ^self pointer length!

length: aNumber
    "Sets the receiver's length"

    ^self pointer length: aNumber asFloat!
 
lineNumber
    "Returns the receiver's lineNumber"

    ^self pointer lineNumber!

lineNumber: aNumber
    "Sets the receiver's lineNumber"

    ^self pointer lineNumber: aNumber asParameter!
 
ltype
    "Returns the receiver's ltype"

    ^self pointer ltype!
   
ltype: aNumber
    "Sets the receiver's ltype"

    ^self pointer ltype: aNumber asParameter!

nextLine
    "Returns the receiver's nextLine"

    ^self lineAt: self pointer nextLine!
 
nextLine: aLine
    "Sets the receiver's nextLine"

    ^self pointer nextLine: (aLine notNil ifTrue: [ aLine pointer ])!

origin
    "Returns the origin"

    ^self x1 @ self y1!
 
printOn: aStream
    "Append the ASCII representation of the receiver to aStream."

    super printOn: aStream.
    (id isNil or: [self isValid not]) ifTrue: [ ^self ].

    aStream nextPutAll: ' from (',self origin asString,') to (',self destination asString,')'.

    (self isDoor and: [self facingSector isValid])
    ifTrue: [
        aStream cr;
            nextPutAll: ' Door from Sector[',self sectorID asString
                ,'] to Sector[',self facing asString
                ,'] open: ',self isOpen asString
    ]!
   
rx1
    "Returns the receiver's rx1"

    ^self pointer rx1!
 
rx1: aNumber
    "Sets the receiver's rx1"

    ^self pointer rx1: aNumber asFloat!
  
rx2
    "Returns the receiver's rx2"

    ^self pointer rx2!
 
rx2: aNumber
    "Sets the receiver's rx2"

    ^self pointer rx2: aNumber asFloat!
  
ry1
    "Returns the receiver's ry1"

    ^self pointer ry1!
 
ry1: aNumber
    "Sets the receiver's ry1"

    ^self pointer ry1: aNumber asFloat!
  
ry2
    "Returns the receiver's ry2"

    ^self pointer ry2!
 
ry2: aNumber
    "Sets the receiver's ry2"

    ^self pointer ry2: aNumber asFloat!
  
sector
    "Returns the receiver's sector"

    ^self space sector: self sectorID!
   
sectorID
    "Returns the sector id of the receiver's parent sector."

    ^self pointer sector!
 
sectorID: aNumber
    "Setss the sector id of the receiver's parent sector."

    ^self pointer sector: aNumber!
 
setTrip: aNumber to: integer
    "Sets the receiver's trip number aNumber"

    ^self pointer
        perform: ('trip',aNumber asString,':') asSymbol
        with: integer asParameter!
   
sine
    "Returns the receiver's sine"

    ^self pointer sine!
  
sine: aNumber
    "Sets the receiver's sine"

    ^self pointer sine: aNumber asFloat!
   
startCollumn
    "Returns the receiver's startCollumn"

    ^self pointer startCollumn!
  
startCollumn: aNumber
    "Sets the receiver's startCollumn"

    ^self pointer startCollumn: aNumber asParameter!
   
stopCollumn
    "Returns the receiver's stopCollumn"

    ^self pointer stopCollumn!
 
stopCollumn: aNumber
    "Sets the receiver's stopCollumn"

    ^self pointer stopCollumn: aNumber asParameter!
  
texture
    "Returns the texture (as a MetaTexture)"

    ^self metaTexture: self textureID!
 
texture2
    "Returns the texture2 (as a MetaTexture)"

    ^self metaTexture: self texture2ID!
  
texture2ID
    "Returns the texture2 id of the receiver's parent texture2."

    ^self pointer texture2!
 
texture2ID: aNumber
    "Setss the texture2 id of the receiver's parent texture2."

    ^self pointer texture2: aNumber!
 
textureID
    "Returns the texture id of the receiver's parent texture."

    ^self pointer texture!
 
textureID: aNumber
    "Setss the texture id of the receiver's parent texture."

    ^self pointer texture: aNumber!
 
to
    "Returns the receiver's to Vertex"

    ^self space vertex: self toVert!
  
topTexture
    "Returns the topTexture (as a MetaTexture)"

    ^self metaTexture: self topTextureID!

topTexture2
    "Returns the topTexture2 (as a MetaTexture)"

    ^self metaTexture: self topTexture2ID!
 
topTexture2ID
    "Returns the topTexture2 id of the receiver's parent topTexture2."

    ^self pointer topTexture2!
 
topTexture2ID: aNumber
    "Setss the topTexture2 id of the receiver's parent topTexture2."

    ^self pointer topTexture2: aNumber!
 
topTextureID
    "Returns the topTexture id of the receiver's parent topTexture."

    ^self pointer topTexture!
 
topTextureID: aNumber
    "Setss the topTexture id of the receiver's parent topTexture."

    ^self pointer topTexture: aNumber!
 
toVert
    "Returns the receiver's toVert"

    ^self pointer toVert!

toVert: aNumber
    "Sets the receiver's toVert"

    ^self pointer toVert: aNumber asParameter!
 
trip: aNumber
    "Returns the receiver's trip number aNumber"

    ^self pointer perform: ('trip',aNumber asString) asSymbol!
   
trip: aNumber is: integer
    "Sets the receiver's trip number aNumber"

    ^self pointer
        perform: ('trip',aNumber asString,':') asSymbol
        with: integer asParameter!
  
tripFlags
    "Returns the receiver's tripFlags"

    ^self pointer tripFlags!
   
tripFlags: aNumber
    "Sets the receiver's tripFlags"

    ^self pointer tripFlags: aNumber asParameter!

validateWith: aPointer
    " Loading - Restore pointer information from stored map.
    Warning: Lines can change line numbers when validated. "

    | result |
    result := super validateWith: aPointer.
    self id: self lineNumber.
    ^result!
  
vertices
    "Returns the array with vertexes."

    ^Array with: self from with: self to!
   
x1
    "Returns the receiver's x1"

    ^self pointer x1!

x1: aNumber
    "Sets the receiver's x1"

    ^self pointer x1: aNumber asFloat!
 
x2
    "Returns the receiver's x2"

    ^self pointer x2!

x2: aNumber
    "Sets the receiver's x2"

    ^self pointer x2: aNumber asFloat!
 
y1
    "Returns the receiver's y1"

    ^self pointer y1!

y1: aNumber
    "Sets the receiver's y1"

    ^self pointer y1: aNumber asFloat!
 
y2
    "Returns the receiver's y2"

    ^self pointer y2!

y2: aNumber
    "Sets the receiver's y2"

    ^self pointer y2: aNumber asFloat! !



!RenderAXSector class methods !

flagNames
    " Returns the flag names aplicables to the receiver's instances.
    WARNING: the flags must be in proper bits order."

    ^#(
        selfIluminating
        ceilingIsSky
        snowing
        raining
        mu
        bob
        altShade
    "remaining bits are unused...yet"
    )!

tripFlagNames
    " Returns the tripFlag names aplicables to the receiver's instances.
    WARNING: the tripFlags must be in proper bits order."

    ^#(
        unKnown0
        unKnown1
        unKnown2
        unKnown3
        unKnown4
        unKnown5
        unKnown6
        unKnown7
        unKnown8
        unKnown9
        sendNotification
    "remaining bits are unused...yet"
    )! !



!RenderAXSector methods !
   
anyLocation
    "Returns a location inside the receiver."

    ^RenderAXLocation random
		position: self anyPlace;
		sector: self;
		height: self space currentActor height;
		angle: RenderAXAngle random;
		yourself!
 
anyPlace
    "Returns a point inside the receiver."

    | boundingBox check x y |
    check := [:aPoint|
        (self space sectorAt: aPoint) = self ifTrue: [ ^aPoint ].
    ].
    boundingBox := self boundingBox.
    boundingBox isNil ifTrue: [ ^0@0 ].
    500 timesRepeat: [ "maximum of 100 retries"
        x := RenderAXRandom between: boundingBox left and: boundingBox right.
        y := RenderAXRandom between: boundingBox top and: boundingBox bottom.
        check value: x @ y
    ].
    ^boundingBox center    

"Old code...
    boundingBox := self boundingBox insetBy: 5.
    check
        value: boundingBox center;
        value: boundingBox leftTop;
        value: boundingBox rightTop;
        value: boundingBox leftBottom;
        value: boundingBox rightBottom;
        value: boundingBox leftCenter;
        value: boundingBox rightCenter;
        yourself.
    boundingBox left to: boundingBox right by: (boundingBox width // 10 max: 1) do: [:x|
        boundingBox top to: boundingBox bottom by: (boundingBox height // 10 max: 1) do: [:y|
            check value: x @ y
        ]
    ].
    ^boundingBox center
"!

boundingBox
    "Returns the receiver's boundingBox or nil if undefined."

    | left right top bottom lines |
    self lines do: [:aLine|
        left isNil ifTrue: [
            left := right := aLine x1.
            top := bottom := aLine y1.
        ].
        left := left min: aLine x1.
        right := right max: aLine x1.
        top := top min: aLine y1.
        bottom := bottom max: aLine y1.
        left := left min: aLine x2.
        right := right max: aLine x2.
        top := top min: aLine y2.
        bottom := bottom max: aLine y2.
    ].
    left isNil ifTrue: [ ^nil ].
    ^left @ top rightBottom: right @ bottom!

bx
    "Returns the receiver's bx."

    ^self pointer bx!
   
bx: aNumber
    "Sets the receiver's bx."

    ^self pointer bx: aNumber!

by
    "Returns the receiver's by."

    ^self pointer by!
   
by: aNumber
    "Sets the receiver's by."

    ^self pointer by: aNumber!

ceilingHeight
    "Returns the ceilingHeight"

    ^self pointer ceilht!
 
ceilingHeight: aNumber
    "Sets the ceilingHeight"

    ^self pointer ceilht: aNumber asFloat!
  
ceilingTexture
    "Returns the ceilTexture (as a MetaTexture)"

    ^self metaTexture: self ceilingTextureID!
   
ceilingTexture: aMetaTexture
    "Sets the ceilTexture (as a MetaTexture)"

    self ceilingTextureID: aMetaTexture id!
  
ceilingTextureID
    "Returns the ceilTexture ID"

    ^self pointer ceilTX!
 
ceilingTextureID: aNumber
    "Returns the ceilTexture ID"

    ^self pointer ceilTX: aNumber asParameter!
   
delete
    "Delete the receiver from current space."

    self dll deleteSector: self asParameter.
    self space reset.!
   
doors
    "Returns the doors (lines) in the receiver"

    ^self lines select: [:each| each isDoor ]!

firstLine
    "Returns the firstLine"

    ^self lineAt: self pointer firstl!

firstLine: aLine
    "Sets the firstLine"

    ^self pointer firstl: (aLine notNil ifTrue: [ aLine pointer ])!
   
fixup
    "FixUp the receiver."

    self dll fixupSector: self asParameter!
 
flags
    "Returns the flags"

    ^self pointer flags!
  
flags: aNumber
    "Sets the flags"

    ^self pointer flags: aNumber asParameter!
   
floorHeight
    "Returns the floorHeight"

    ^self pointer floorht!

floorHeight: aNumber
    "Sets the floorHeight"

    ^self pointer floorht: aNumber asFloat!
 
floorTexture
    "Returns the floorTexture (as a MetaTexture)"

    ^self metaTexture: self floorTextureID!
  
floorTexture: aMetaTexture
    "Sets the floorTexture with aMetaTexture."

    self floorTextureID: aMetaTexture id!
 
floorTextureID
    "Returns the floorTexture ID"

    ^self pointer floorTX!
 
floorTextureID: aNumber
    "Returns the floorTexture ID"

    ^self pointer floorTX: aNumber asParameter!
   
height
    "Returns the difference between ceiling and floor"

    ^self ceilingHeight - self floorHeight!
   
htOffset
    "Returns the htOffset"

    ^self pointer htOffset!
 
htOffset: aNumber
    "Sets the htOffset"

    ^self pointer htOffset: aNumber asFloat!
  
initializeId
    " Private - Initializes the receiver's id"

    id := 1.!
   
initializePointer
    " Private - Initializes the receiver's pointer with current sector setting."

    self pointer: (self dll sector: self asParameter).!
  
isSector
    "Returns true if the receiver is a sector."

    ^true!
 
lastLine
    "Returns the lastLine"

    ^self lineAt: self pointer lastl!
   
lastLine: aLine
    "Sets the lastLine"

    ^self pointer lastl: (aLine notNil ifTrue: [ aLine pointer ])!
  
lightLevel
    "Returns the receiver's lightlevel."

    ^self pointer lightlevel!
   
lightLevel: aNumber
    "Sets the receiver's lightlevel."

    ^self pointer lightlevel: aNumber!

lines
    "Returns the colection of lines in the receiver."

    | lines line |
    lines := OrderedCollection new: 4.
    line := self firstLine.
    [line notNil] whileTrue: [
        lines add: line.
        line := line nextLine.
    ].
    ^lines asArray!
  
number
    "Returns the receiver's number."

    ^self pointer number!
   
number: aNumber
    "Sets the receiver's number."

    ^self pointer number: aNumber asParameter!

swing
    "Returns the swing"

    ^self pointer swing!
  
swing: aNumber
    "Sets the receiver's swing."

    ^self pointer swing: aNumber asParameter!
   
tag
    "Returns the receiver's tag."

    ^self pointer tag!

tag: aNumber
    "Sets the receiver's tag."

    ^self pointer tag: aNumber asParameter!
 
textureCeilingAdjust
    "Resturns the receiver's texture ceiling adjust as a point."

    ^self tx @ self ty!
   
textureCeilingAdjust: aPoint
    "Sets the receiver's texture ceiling adjust with a point."

    self
        tx: aPoint x;
        ty: aPoint y!
  
tripFlags
    "Returns the tripFlags"

    ^self pointer tripFlags!
  
tripFlags: aNumber
    "Sets the receiver's tripFlags."

    ^self pointer tripFlags: aNumber asParameter!
   
tx
    "Returns the receiver's texture ceiling adjust x."

    ^self pointer tx!
 
tx: aNumber
    "Sets the receiver's texture ceiling adjust x."

    ^self pointer tx: aNumber!
  
ty
    "Returns the receiver's texture ceiling adjust ty."

    ^self pointer ty!

ty: aNumber
    "Sets the receiver's texture ceiling adjust y."

    ^self pointer ty: aNumber!
  
underHeight
    "Returns the underHeight"

    ^self pointer underht!

underHeight: aNumber
    "Sets the underHeight"

    ^self pointer underht: aNumber asFloat!
 
underTexture
    "Returns the underTexture (as a MetaTexture)"

    ^self metaTexture: self underTextureID!
  
underTexture: aMetaTexture
    "Sets the underTexture with aMetaTexture."

    self underTextureID: aMetaTexture id!
 
underTextureID
    "Returns the underTexture ID"

    ^self pointer underTX!
 
underTextureID: anID
    "Sets the underTexture ID"

    ^self pointer underTX: anID asParameter!

vertices
    "Returns the colection of vertices in the receiver."

    | vertices line |
    vertices := Set new.
    line := self firstLine.
    [line notNil] whileTrue: [
        vertices addAll: line vertices.
        line := line nextLine.
    ].
    ^vertices!
 
xaCeiling
    "Returns the xaCeil"

    ^self pointer xaCeil!

xaCeiling: aNumber
    "Sets the xaCeil"

    ^self pointer xaCeil: aNumber asParameter!
 
xaFloor
    "Returns the xaFloor"

    ^self pointer xaFloor!

xaFloor: aNumber
    "Sets the xaFloor"

    ^self pointer xaFloor: aNumber asParameter!
 
yaCeiling
    "Returns the yaCeil"

    ^self pointer yaCeil!

yaCeiling: aNumber
    "Sets the yaCeil"

    ^self pointer yaCeil: aNumber asParameter!
 
yaFloor
    "Returns the yaFloor"

    ^self pointer yaFloor!

yaFloor: aNumber
    "Sets the yaFloor"

    ^self pointer yaFloor: aNumber asParameter! !



!RenderAXVertex methods !
  
asPoint
    "Return the receiver as aPoint"

    ^self x @ self y!
   
initializePointer
    " Private - Initializes the receiver's pointer with current sector setting."

    self pointer: (self dll vertex: self asParameter).!
  
isVertex
    "Returns true if the receiver is a vertex."

    ^true!
 
location
    "Return the receiver as aPoint"

    ^self asPoint!
 
offset
    "Return the receiver as aPoint"

    ^self asPoint!
   
x
    "Return the receiver's x offset"

    ^self pointer x!
 
x: aNumber
    "Sets the receiver's x offset"

    ^self pointer x: aNumber asFloat.!

y
    "Return the receiver's y offset"

    ^self pointer y!
 
y: aNumber
    "Sets the receiver's y offset"

    ^self pointer y: aNumber asFloat.! !



!RenderAXPatch methods !
  
asDIB
    "Returns the receiver's bitmap as a DIB"

    ^self getBitmapDIB!
  
bitmapID
    "Returns the bitmap ID"

    ^self pointer bitmapNo!

bitmapID: anID
    "Sets the bitmap ID"

    self pointer bitmapNo: anID!

bottom
    "Returns the bottom"

    ^self top + self height!

boundingBox
    "Returns the boundingBox"

    ^self leftTop extent: self extent!

boundingBox: aRectangle
    "Sets the boundingBox to aRectangle"

    self
        left: aRectangle left;
        top: aRectangle top;
        width: aRectangle width;
        height: aRectangle height;
        yourself!

displayAt: aPoint with: aPen
	" Display the receiver's patches tiled at aPoint with aPen. "

	| box dib |
	dib := self asDIB.
	box := self boundingBox.
	dib
		displayWith: aPen
		from: dib boundingBox
		to: (box translateBy: aPoint)!
  
extent
    "Returns the extent"

    ^self width @ self height!
  
getBitmapDIB
    "Get the DIB structure for current bitmap."

    ^self getBitmapDIB: self bitmapID extent: self extent!
 
height
    "Returns the height"

    ^self pointer h!

height: anInteger
    "Sets the height"

    ^self pointer h: anInteger!
 
isPatch
    "Returns true if the receiver is a patch."

    ^true!
   
left
    "Returns the left"

    ^self pointer x!

left: anInteger
    "Sets the left"

    ^self pointer x: anInteger!
 
leftTop
    "Returns the origin"

    ^self left @ self top!
 
right
    "Returns the right"

    ^self left + self width!
  
rightBottom
    "Returns the corner"

    ^self right @ self bottom!
 
top
    "Returns the top"

    ^self pointer y!
  
top: anInteger
    "Sets the top"

    ^self pointer y: anInteger!
   
width
    "Returns the width"

    ^self pointer w!
  
width: anInteger
    "Sets the width"

    self pointer w: anInteger! !



!RenderAXShade methods !
  
bloodRed
    "Shade to a bloody red color."

    self
        red: 128 green: 0 blue: 0;
        distance: 1024;
        yourself!

blue
    "Returns the color component."

    ^self color blue!
   
color
    "Returns the instance var of the receiver
     for external manipulation"

    color isNil ifTrue: [ self initializeColor ].
    ^color!
 
color: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    color := anObject!
 
distance
    "Returns the instance var of the receiver
     for external manipulation"

    distance isNil ifTrue: [ self initializeDistance ].
    ^distance!
 
distance: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    distance := anObject!
   
fog
    "Shade to a light gray."

    self
        gray: 192; "light gray"
        distance: 1024; "like a fog"
        yourself!
 
gray: intensity
    "Sets the receiver's colors to gray scale."

    self red: intensity green: intensity blue: intensity!
   
green
    "Returns the color component."

    ^self color green!
 
initializeColor
    " Private - Initializes the receiver's color"

    color := Color red: 0 green: 0 blue: 0. "shade to black"!
 
initializeDistance
    " Private - Initializes the receiver's distance"

    distance := 2000.!
  
light
    "Shade to normal."

    self
        color: nil; "black"
        distance: 4000; "Doesn't get dark too quickly"
        yourself!
   
normal
    "Shade to normal."

    self
        color: nil; "black"
        distance: 2000; "medium distance"
        yourself!
   
red
    "Returns the color component."

    ^self color red!
 
red: red green: green blue: blue
    "Sets the receiver's colors."

    self color
        red: red;
        green: green;
        blue: blue!

veryDark
    "Shade to very dark."

    self
        color: nil; "black"
        distance: 512; "short distance"
        yourself! !



!RenderAXSpace class methods !

constructEventsTriggered
    "Private - Construct the set of events triggered by instances of the receiver."

    ^super constructEventsTriggered
        addAll: #( actorHit:with: lineHit:with: sectorCross:with: missile:at:);
        yourself!

current
    "Returns the instance var of the receiver
     for external manipulation"

    current isNil ifTrue: [ self initializeCurrent ].
    ^current!
 
current: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    current := anObject!
 
in: aPane
    "Returns an instance of the receiver for working inside aPane."

    ^self current
        pane: aPane;
        yourself!

initializeCurrent
    " Private - Initializes the receiver's current"

    current := super new.!

new
    " The receiver can have only an instance. "

    ^self invalidMessage! !



!RenderAXSpace methods !
 
actor
    "Returns the current actor"

    ^self currentActor!
   
actor: actorID
    "Returns the actor with ID actorID (or nil)."

    ^self actors
        detect: [:one| one id = actorID ]
        ifNone: []!
   
actorAtAddress: anAddress
    " Private - Returns the actor at anAddress (or nil)."

    ^self actors
        detect: [:one| one isAtAddress: anAddress ]
        ifNone: []!
  
actors
    "Returns the instance var of the receiver
     for external manipulation"

    actorCache isNil ifTrue: [ self initializeActorCache ].
    ^actorCache!
 
actorType: anID
    " Private - Returns the actor type number anID or nil."

    ^self isValid ifTrue: [ RenderAXActorType id: anID ]!
   
actorTypes
    "Returns the collection of current actor types."

    | result aType |
    result := OrderedCollection new.
    0 to: MaxActorType - 1 do: [:i|
        aType := self actorType: i.
        (aType notNil and: [aType isValid])
		ifTrue: [ result add: aType ].
    ].
    ^result!
   
add: anActor
    "Add a new actor to the receiver, returns the actor."

    ^self add: anActor at: nil!
  
add: anActor at: aRenderAXLocation
    "Add a new actor to the receiver, returns the actor or nil if fails."

   ^self add: anActor type: anActor type at: aRenderAXLocation!

add: anActor type: aType
    "Add a new actor to the receiver, returns the actor."

    ^self add: anActor type: aType at: nil!
  
add: anActor type: aType at: aRenderAXLocation
    "Add a new actor to the receiver, returns the actor or nil if fails."

    aRenderAXLocation isNil ifTrue: [
        ^self
			add: anActor
			type: aType
			at: (self currentActor position" sector anyLocation"
					height: self currentActor height;
					yourself)
    ].
    self isValid ifFalse: [ ^nil ].
    anActor
		id: self actors size;
		pointer: nil;
		yourself.
    self pane
        addActor: anActor asParameter
        actorType: aType asParameter
        at: aRenderAXLocation position
        height: aRenderAXLocation height asParameter
        sector: aRenderAXLocation sector asParameter.
    self actors add: anActor.
	anActor
		type: aType;
		used: true;
		yourself.
    ^anActor!
   
anyPosition
    " Returns a valid position in the receiver (or nil). "

    ^self anySector anyPlace!

anySector
    " Returns a valid sector in the receiver (or nil). "

    | sector location anyValue size |
    size := self sectors size.
    size <= 1 ifTrue: [ ^self sector: 0 ].
    [ anyValue := RenderAXRandom between: 1 and: size.
      sector := self sector: anyValue truncated.
      sector isNil ifTrue: [ ^nil ]. "don't change"
      sector height > 0 ] whileFalse: [].
    ^sector!

anyType
    " Returns a valid type in the receiver(or nil). "

    | types |
    types := self actorTypes.
    types size < 1 ifTrue: [ ^nil ].
    types size = 1 ifTrue: [ ^types first ].
    ^types at: (RenderAXRandom between: 1 and: types size)!
 
atenuation
    " Private - Returns an atenuation point for spin & movement."

    | tranquility |
    tranquility := Notifier isShiftKeyDown
        ifTrue: [self runAtenuation]
        ifFalse: [self walkAtenuation].
    ^1 @ 2 * tranquility!
  
bestType
    " Returns the type in the receiver with more directions(or nil). "

    | types |
    types := SortedCollection sortBlock: [:a :b| a directions >= b directions ].
    types addAll: self actorTypes.
    ^types notEmpty ifTrue:[ types first ]!

bitmap: anID
    " Private - Returns the bitmap with ID anID or nil."

    self isValid ifFalse: [ ^nil ].
    ^self bitmapCache
        at: anID
        ifAbsent: [ self privateBitmap: anID ].!

bitmapCache
    "Returns the instance var of the receiver
     for external manipulation"

    bitmapCache isNil ifTrue: [ self initializeBitmapCache ].
    ^bitmapCache!
 
bitmapCache: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    bitmapCache := anObject!
 
bitmaps
    "Returns the collection of current bitmaps."

    | result aBitmap |
    result := OrderedCollection new.
    0 to: MaxBitmaps - 1 do: [:i|
        aBitmap := self bitmap: i.
        aBitmap notNil ifTrue: [ result add: aBitmap ].
    ].
    ^result!
 
bloodRed
    "Sets the receiver's ambient to bloodRed."

    self shadeTo: RenderAXShade new bloodRed!
   
boundingBox
    "Returns the receiver's boundingBox or nil if undefined."

    | left right top bottom box |
    self sectorsDo: [:aSector|
        box := aSector boundingBox.
        box notNil
        ifTrue: [
            left isNil ifTrue: [
                left := box left. right := box right.
                top := box top. bottom := box bottom.
            ].
            left := left min: box left.
            right := right max: box right.
            top := top min: box top.
            bottom := bottom max: box bottom.
        ].
    ].
    left isNil ifTrue: [ ^nil ].
    ^left @ top rightBottom: right @ bottom!
   
callBackActorNotification: pActor hitActor: pHitActor
    " Private - A notification callback event has been received, process it. "

    | thisActor hitActor |
    thisActor := self actorAtAddress: pActor.
    hitActor := self actorAtAddress: pHitActor.
    " Transcript cr;show: 'Notification #actor ',thisActor asString,' hitActor:',hitActor asString. "
    self
        triggerEvent: #actorHit:with:
        with: thisActor
        with: hitActor
!
 
callBackCache
    "Returns the instance var of the receiver
     for external manipulation"

    callBackCache isNil ifTrue: [ self initializeCallBackCache ].
    ^callBackCache!
 
callBackLineNotification: pActor line: pLine
    " Private - A notification callback event has been received, process it. "

    | thisActor thisLine |
    thisActor := self actorAtAddress: pActor.
    thisLine := self lineAtAddress: pLine.
    " Transcript cr;show: 'Notification #line ',thisActor asString,' pLine:',thisLine asString. "
    self
        triggerEvent: #lineHit:with:
        with: thisActor
        with: thisLine!
  
callBackMissileNotification: pActor x: x y: y
    " Private - A notification callback event has been received, process it. "

    | thisActor |
    thisActor := self actorAtAddress: pActor.
    "Transcript cr;show: 'Notification #missile ',thisActor asString,' x:',x asString,' y:',y asString."
    self
        triggerEvent: #missile:at:
        with: thisActor
        with: x @ y!

callBackSectorNotification: pActor sector: pSector
    " Private - A notification callback event has been received, process it. "

    | thisActor thisSector |
    thisActor := self actorAtAddress: pActor.
    thisSector := self sectorAtAddress: pSector.
    "Transcript cr;show: 'Notification #sector ',thisActor asString,' sector:',thisSector asString."
    self
        triggerEvent: #sectorCross:with:
        with: thisActor
        with: thisSector!
   
cammera
    "Returns the current actor"

    ^self currentActor!
 
check: anActor
    " Private - Checks anActor.
    This method must be called for all moving actors, so that gravity can work upon them."

    self isValid ifFalse: [ ^false ].
    (anActor notNil and: [ anActor isValid ]) ifFalse: [ ^false ].
    self pane checkActor: anActor asParameter.
    ^true!

checkActors
    " Private - Checks all actors.
    This method must be called for all moving actors, so that gravity can work upon them."

    self strategy startChecking: self.
    self actors do: [:each| self check: each ].
    self strategy endChecking: self.!
   
clear
    "Remove all the space contents and reset to default settings."

    self dll clearLevel.
    self reset.!
 
currentActor
    "Returns the instance var of the receiver
     for external manipulation"

    currentActor isNil ifTrue: [ self initializeCurrentActor ].
    ^currentActor!
 
currentActor: anActor
    "Sets the current actor in the receiver."

    currentActor := anActor.
    (anActor notNil and: [self isValid]) ifTrue: [
        self pane pointOfViewActor: anActor asParameter
    ].
    !

currentSector
    "Returns the sector of current actor."

    ^self currentActor sector!
 
defaultActor
    "Returns the default actor."

    ^self actors first!
   
deleteSector: aSector
    "Delete the sector in the receiver."

    aSector delete.!
 
dib
    " Get an ExternalDIB as an interface to the receiver's rendering system."

    ^self pane getDataDIB!

directory
    "Returns the instance var of the receiver
     for external manipulation"

    directory isNil ifTrue: [ self initializeDirectory ].
    ^directory!
 
directory: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    directory := anObject!
 
doTracking
    " Private -  Do real tracking process. "

    | rectangle point force camera |

    self mustTrack ifFalse: [ ^self ].
    [ rectangle := self pane frameRectangle ] on: Error do: [^self].
    point := Cursor sense.
    "Is mouse inside the pane ?"
    (rectangle containsPoint: point) ifFalse: [ ^self ].

    camera := self currentActor.
    (Notifier isKeyDown: MkLbutton) "move the camera"
    ifTrue: [
        force := point - rectangle center / (rectangle extent // 2) * 100.
        self move: camera by: force.
    ].

    (Notifier isKeyDown: MkRbutton) "Jump the camera"
    ifTrue: [
        camera jump.
    ].

    Notifier isControlKeyDown "move eye up-down"
    ifTrue: [
        Notifier isShiftKeyDown
        ifTrue: [ force := 0@0 ]
        ifFalse: [ 
            force := point - rectangle center / (rectangle extent // 2) * 100
        ].
        self move: camera by: force x @ 0.
        self pane shear: force y truncated negated * 2.
    ].

    self update. "an actor can be moving/falling down" !
   
emptyTexture
	" Returns the empty texture (used for invisible characters). "

	^self propertyAt: #emptyTexture ifAbsentPut: [ self newTexture empty ]!
   
findActorDisplayedAt: aPoint
    " Returns the actor displayed at aPoint or nil.
    aPoint is a point win window coordinates."

    | actorID |
    actorID := self dll findActor: aPoint.
    ^actorID notNil ifTrue: [ self actor: actorID ].!
 
fixupActors
    "FixUp all the actors definitions."

    self dll fixupActors!
   
fixupAll
    "FixUp all the definitions."

    self
        fixupLines;
        fixupSectors;
        fixupActors;
        yourself.!

fixupLines
    "FixUp all the lines definitions."

    self dll fixupLines!
  
fixupSectors
    "FixUp all the sectors definitions."

    self sectorsDo: [:each| each fixup ].!

flatNumber: aNumber
    "Returns the flat with id aNumber (or nil if invalid)."

    | flat |
    flat := RenderAXFlat id: aNumber.
    ^flat isValid ifTrue: [ flat ]!

flats
    "Returns the collection of current flats."

    | result aFlat |
    result := OrderedCollection new.
    0 to: MaxFlats - 1 do: [:i|
        aFlat := self flatNumber: i.
        aFlat notNil ifTrue: [ result add: aFlat ].
    ].
    ^result!
   
flushActorsCache
    " Private - Flush the internal actors cache. "

    actorCache := nil.!
 
flushTextureCache
    "Update texture caches."

    textureCache := nil.
    self dll flushTextureCache.!
   
fog
    "Sets the receiver's ambient to fog."

    self shadeTo: RenderAXShade new fog!
  
getAllBitmapDIBs
    "Get all the bitmap DIBs currently defined."

    | result aDIB |
    result := Dictionary new.
    1 to: MaxBitmaps do: [:i|
        aDIB := self getBitmapDIB: i.
        aDIB notNil ifTrue: [ result at: i put: aDIB ].
    ].
    ^result!
   
ifValid: aBlock
    " Private - Evaluates aBlock only if the receiver is valid. "

    [ self isValid ifTrue: [ aBlock evaluate ] ] evaluateWithoutInterrupts!
   
initializeActorCache
    " Private - Initializes the receiver's actors"

    | actor base place |
    actorCache := OrderedCollection new.
    [    actor := RenderAXActor new.
        actor id: self actors size.
        actor isValid
    ] whileTrue: [ self actors add: actor. ].
    self actors isEmpty ifTrue: [
        base := self sector: 0.
        base isNil ifTrue: [ self error: 'No sectors defined in map.' ].
        " (MessageBox confirm: 'No actor defined in map file. Continue ?')
        ifFalse: [ self error: 'No actors defined in map'. ]. "
        place := base anyPlace.
        self pane
            addActor: 0 actorType: 0
            at: place height: 80
            sector: base asParameter.
        self actors add: actor
    ].!
  
initializeBitmapCache
    " Private - Initializes the receiver's bitmapCache"

    bitmapCache := IdentityDictionary new.!
   
initializeCallBackCache
    " Private - Initializes the receiver's callBackCache"

    callBackCache := Dictionary new.!
 
initializeCurrentActor
    " Private - Initializes the receiver's currentActor"

    currentActor := self defaultActor.!
 
initializeDirectory
    " Private - Initializes the receiver's directory"

    directory := Disk.!
   
initializeIsTracking
    " Private - Initializes the receiver's isTracking"

    isTracking := false.!
   
initializeLineCache
    " Private - Initializes the receiver's lineCache"

    lineCache := IdentityDictionary new.!
 
initializeName
    " Private - Initializes the receiver's name"

    name := 'default'.!
 
initializeRunAtenuation
    " Private - Initializes the receiver's runAtenuation"

    runAtenuation := 2.!
  
initializeSectorCache
    " Private - Initializes the receiver's sectorCache"

    sectorCache := IdentityDictionary new.!
   
initializeStrategy
    " Private - Initializes the receiver's strategy to a new empty starategy. "

    strategy := RenderAXStrategy new.!
   
initializeTextureCache
    " Private - Initializes the receiver's textureCache"

    textureCache := IdentityDictionary new.!

initializeTrackAlways
    " Private - Initializes the receiver's trackAlways"

    trackAlways := false.!

initializeVertexCache
    " Private - Initializes the receiver's vertexCache"

    vertexCache := IdentityDictionary new.!
   
initializeWalkAtenuation
    " Private - Initializes the receiver's walkAtenuation"

    walkAtenuation := 4.!
   
isSpace
    "Returns true if the receiver is aRenderAXSpace."

    ^true!

isTracking
    "Returns the instance var of the receiver
     for external manipulation"

    isTracking isNil ifTrue: [ self initializeIsTracking ].
    ^isTracking!
 
isValid
    "True when the receiver is valid."

    ^self pane notNil and: [self pane isValid]!
  
knownVertices
    "Returns all the used vertices (reached from lines)."

    | result |
    result := Set new.
    self sectorsDo: [:sector| result addAll: sector vertices ].
    ^result asArray!
   
light
    "Sets the receiver's ambient to light."

    self shadeTo: RenderAXShade new light!

lineAt: aPointer
    " Returns the line pointed by aPointer. "

    | aLine |
    aLine := RenderAXLine new.
    aLine pointer: aPointer; getID; yourself.
    ^self lineCache
        at: aLine id
        ifAbsentPut: [ aLine ]!
 
lineAtAddress: anAddress
    " Private - Returns the line at anAddress (or nil)."

    | result aSector |
    "first of all we will see in the current sector lines"
    aSector := self currentSector.
    aSector notNil ifTrue: [
        result := self lineAtAddress: anAddress in: aSector lines.
        result notNil ifTrue: [ ^result ].
    ].

    "then we will see in all the sectors"
    self sectorsDo: [:sector|
        result := self lineAtAddress: anAddress in: sector lines.
        result notNil ifTrue: [ ^result ].
    ].

    ^nil "not found"!
  
lineAtAddress: anAddress in: aCollection
    " Private - Returns the line at anAddress present in aCollection (or nil)."

    ^aCollection
        detect: [:one| one isAtAddress: anAddress ]
        ifNone: []!
 
lineCache
    "Returns the instance var of the receiver
     for external manipulation"

    lineCache isNil ifTrue: [ self initializeLineCache ].
    ^lineCache!
 
lineCache: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    lineCache := anObject!
 
lines
    "Returns all the lines"

    | lines |
    lines := Set new.
    self sectorsDo: [:sector| lines addAll: sector lines ].
    ^lines!

load
    "Load receiver's settings from current directory using receiver's name."

    ^self
        reset;
        loadFlatSet;
        loadBitmapSet;
        loadActorDefs;
        loadTextureSet;
        loadLevel!
  
load: selector from: aPathName
    " Private - Try to load property determined by selector from file pathName if it does not exist try to load from default file in the same directory."

    | pathName |
    pathName := aPathName.
    (File exists: pathName)
    ifTrue: [ ^self pane perform: selector with: pathName ].
    pathName := aPathName fileNamePath,'\default.',aPathName fileExtension.
    (File exists: pathName)
    ifTrue: [ ^self pane perform: selector with: pathName ].
    ^nil!
 
loadActorDefs
    "Load receiver's actorDefs from current directory using receiver's name."

    ^self loadActorDefs: self name from: self directory!

loadActorDefs: pathName
    "Load receiver's actorDefs from file at pathName."

	pathName isNil ifTrue: [ ^self ].
    ^self
        loadActorDefs: pathName fileName
		from: (Directory pathName: pathName fileNamePath)!

loadActorDefs: aName from: aDirectory
    "Load receiver's actorDefs from aDirectory using receiver's name."

    ^self
        load: #actorDefs:
        from: aDirectory fullDirName,
            (File fileName: aName extension: 'typ')!
  
loadBitmapSet
    "Load receiver's bitmapSet from current directory using receiver's name."

    ^self loadBitmapSet: self name from: self directory!

loadBitmapSet: aName from: aDirectory
    "Load receiver's bitmapSet from aDirectory using receiver's name."

    ^self
        load: #bitmapSet:
        from: aDirectory fullDirName,
            (File fileName: aName extension: 'bst')!
  
loadFlatSet
    "Load receiver's flatSet from current directory using receiver's name."

    ^self loadFlatSet: self name from: self directory!
  
loadFlatSet: aName from: aDirectory
    "Load receiver's flatSet from aDirectory using receiver's name."

    ^self
        load: #flatSet:
        from: aDirectory fullDirName,
            (File fileName: aName extension: 'flt')!

loadLevel
    "Load receiver's Level from current directory using receiver's name."

    ^self loadLevel: self name from: self directory!

loadLevel: aName from: aDirectory
    "Load receiver's Level from aDirectory using aName."

    ^self
        load: #level:
        from: aDirectory fullDirName,
            (File fileName: aName extension: '4dx')!

loadTextureSet
    "Load receiver's textureSet from current directory using receiver's name."

    ^self loadTextureSet: self name from: self directory!
 
loadTextureSet: aName from: aDirectory
    "Load receiver's TextureSet from aDirectory using receiver's name."

    ^self
        load: #textureSet:
        from: aDirectory fullDirName,
            (File fileName: aName extension: 'tdf')!
   
metaTexture: anID
    " Private - Returns the metaTexture with ID anID or nil."

    self isValid ifFalse: [ ^nil ].
    ^self textureCache
        at: anID
        ifAbsent: [ self privateMetaTexture: anID ].!

metaTextures
    "Returns the collection of current textures."

    | result aTexture |
    result := OrderedCollection new.
    0 to: MaxTextures - 1 do: [:i|
        aTexture := self metaTexture: i.
        (aTexture notNil and: [aTexture isValid])
		ifTrue: [ result add: aTexture ].
    ].
    ^result!

move: anActor by: aPoint
    "Move anActor by the GUI distance specified by aPoint (force)."

    | modulus atenuation force |
    atenuation := self atenuation.
    force := aPoint truncated.
    modulus := (force dotProduct: force) sqrt "
        force x abs + force y abs // 2 ".
    self ifValid: [
        self
            spin: anActor to: force x // atenuation x;
            moveActor: anActor distance: modulus // atenuation y * force y sign negated.
    ].
    ^true!
  
moveActor: anActor distance: aDistance
    "Move anActor by aDistance."

    self isValid ifFalse: [ ^false ].
    self pane
        moveActor: anActor asParameter
        distance: aDistance asFloat asParameter.
    ^true!
  
mustTrack
    "True when the receiver is valid and view focused."

    ^self isValid
    and: [
        self trackAlways
        or: [ self pane isActive ] ]!

name
    "Returns the instance var of the receiver
     for external manipulation"

    name isNil ifTrue: [ self initializeName ].
    ^name!
 
name: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    name := anObject!
   
newActor
    "Returns a new actor in the receiver."

	^self
		add: RenderAXActor new
		type: self bestType
		at: self anySector anyLocation!
  
newActorType
    "Returns a new actor type or  generates an error if overflow."

	| aType |
	"0 is not used because is the default actor type."
    1 to: MaxActorType - 1 do: [:i|
        aType := self actorType: i.
        (aType notNil and: [aType isValid not])
		ifTrue: [ ^aType ].
    ].
    self error: 'Actor type overflow.'!
  
newBitmap
    "Create a new bitmap in the receiver's context."

    | aBitmap |
	self bitmaps last id + 1 to: MaxBitmaps - 1 do: [:i|
        aBitmap := self bitmap: i.
        aBitmap isNil ifTrue: [ ^self privateBitmap: i create: true ].
    ].
    ^self error: 'Bitmap overflow'!
  
newTexture
    "Returns a new texture or generates an error if out of textures."

    | aTexture |
	"Skip used textures (considering holes)..."
    self textures last id + 1 to: MaxTextures - 1 do: [:i|
        aTexture := self metaTexture: i.
        (aTexture notNil and: [aTexture isValid not])
		ifTrue: [ ^aTexture ].
    ].
    ^self error: 'Textures overflow'!
   
normal
    "Sets the receiver's ambient to normal."

    self shadeTo: RenderAXShade new normal!
 
pane
    "Returns the instance var of the receiver
     for external manipulation"
    ^pane!

pane: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    pane := anObject!
   
position: anActor at: aPosition
    "Sets anActor at aPosition."

    | x y z angle |
    self isValid ifFalse: [ ^false ].
    x := aPosition x isNil ifFalse: [ aPosition x ] ifTrue: [ anActor x ].
    y := aPosition y isNil ifFalse: [ aPosition y ] ifTrue: [ anActor y ].
    z := aPosition z isNil
        ifFalse: [ aPosition z ]
        ifTrue: [ anActor sector floorHeight ].
    angle := aPosition angle isNil
        ifFalse: [ aPosition angle ]
        ifTrue: [ anActor angle ].
    self pane
        positionActor: anActor asParameter
        x: x asParameter
        y: y asParameter
        z: z asParameter
        angle: angle asParameter.
    ^true!

privateBitmap: anID
    " Private - Returns the bitmap number anID (or nil)."

    ^self privateBitmap: anID create: false!
  
privateBitmap: anID create: aBoolean
    " Private - Returns the bitmap number anID (or nil)."

    | result |
    result := RenderAXBitmap id: anID.
    (result pointer isNil and: [aBoolean not]) ifTrue: [ ^nil ].
    self bitmapCache at: anID put: result.
    ^result!
   
privateMetaTexture: anID
    " Private - Returns the metaTexture number anID (or nil)."

    | result |
    result := RenderAXMetaTexture id: anID.
    result pointer isNil ifTrue: [ ^nil ].
    self textureCache at: anID put: result.
    ^result!
  
privateSector: sectorID
    " Private - Returns the sector number sectorID (or nil)."

    | result |
    result := RenderAXSector id: sectorID.
    result pointer isNil ifTrue: [ ^nil ].
    self sectorCache at: sectorID put: result.
    ^result!
  
privateVertex: vertexID
    " Private - Returns the vertex number vertexID (or nil)."

    | result |
    result := RenderAXVertex id: vertexID.
    result pointer isNil ifTrue: [ ^nil ].
    self vertexCache at: vertexID put: result.
    ^result!
  
raiseCeilingOf: aSector to: aHeight
    "This method changes the height of the ceiling in a sector at speed 3."

    ^self raiseCeilingOf: aSector to: aHeight at: 3!

raiseCeilingOf: aSector to: aHeight at: aSpeed
    "This method changes the height of the ceiling in a sector at a speed."

    self isValid ifFalse: [ ^false ].
    self pane
        raiseSectorCeiling: aSector asParameter
        height: aHeight asParameter
        speed: aSpeed asParameter.
    ^true!
   
raiseFloorOf: aSector to: aHeight
    "This method changes the height of the floor in a sector at speed 3."

    ^self raiseFloorOf: aSector to: aHeight at: 3!
  
raiseFloorOf: aSector to: aHeight at: aSpeed
    "This method changes the height of the floor in a sector at a speed."

    self isValid ifFalse: [ ^false ].
    self pane
        raiseSectorFloor: aSector asParameter
        height: aHeight asParameter
        speed: aSpeed asParameter.
    ^true!
 
realizePalette
    " Private - realizes the receiver's palette."

    self isValid ifFalse: [ ^false ].
    self pane realizePalette.
    ^true!
   
render
    "Render the receiver's pane."

    self isValid ifFalse: [ ^false ].
    self strategy startRendering: self.
    self pane render.
    self strategy endRendering: self.
    ^true!
   
render: anActor
    " Render anActor if current actor. "

    self isValid ifFalse: [ ^false ].
    anActor = self currentActor ifTrue: [ self render ].!
   
reset
    " Private - Reset the receiver's resources. "

    currentActor :=
    actorCache  :=
    lineCache :=
    sectorCache :=
    vertexCache :=
    bitmapCache :=
    textureCache := nil.!

resetActorTypes
	"Reset all teh actor types."

	self actorTypes do: [:each| each reset ].!
   
runAtenuation
    "Returns the instance var of the receiver
     for external manipulation"

    runAtenuation isNil ifTrue: [ self initializeRunAtenuation ].
    ^runAtenuation!
 
runAtenuation: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    runAtenuation := anObject!
 
runFaster
    " Set the receiver to run faster if posible. "

    self runAtenuation: (self runAtenuation - 1 max: 1)!
   
runReset
    " Set the receiver to run at default rates. "

    self runAtenuation: nil!
 
runSlower
    " Set the receiver to run at lower rates. "

    self runAtenuation: self runAtenuation + 1!
   
saveLevel
    "Save receiver's Level to current directory using receiver's name."

    ^self saveLevel: self name to: self directory!

saveLevel: aName to: aDirectory
    "Save receiver's Level to aDirectory using aName."

    ^self saveLevelAs: aDirectory fullDirName,
        (File fileName: aName extension: '4dx')!
 
saveLevelAs: pathName
    "Save receiver's Level to file pathName."

    ^0 ~= (self dll saveLevel: pathName)!
   
sector: sectorID
    "Returns the sector number sectorID (or nil)."

    self isValid ifFalse: [ ^nil ].
    ^self sectorCache
        at: sectorID
        ifAbsent: [ self privateSector: sectorID ].!
  
sectorAt: aPoint
    "Returns the sector at aPoint."

    | sectorID |
    self isValid ifFalse: [ ^nil ].
    sectorID := self dll"pane" findSector: aPoint.
    sectorID isNil ifTrue: [ ^nil ].
    ^self sector: sectorID!
   
sectorAtAddress: anAddress
    " Private - Returns the sector at anAddress (or nil)."

    | aSector |
    aSector := self currentSector.
    (aSector notNil and: [aSector isAtAddress: anAddress]) ifTrue: [ ^aSector ].
    
    self sectorsDo: [:one|
        (one isAtAddress: anAddress) ifTrue: [ ^one ]
    ]!

sectorCache
    "Returns the instance var of the receiver
     for external manipulation"

    sectorCache isNil ifTrue: [ self initializeSectorCache ].
    ^sectorCache!
 
sectors
    "Returns the sectors in the receiver."

    | result |
    result := OrderedCollection new.
    self sectorsDo: [:each| result add: each ].
    ^result asArray

"obsolete sectorIDs can be non-contioguous
    | sectorID result current |
    sectorID := 0.
    result := OrderedCollection new.
    [    current := self sector: sectorID.
        current notNil ] whileTrue: [
        result add: current.
        sectorID := sectorID + 1.
    ].
    ^result asArray
"!
 
sectorsDo: aBlock
    "Evaluates aBlock with all the sectors in the receiver."

    | sector |
    0 to: MaxSectors do: [:i|
        sector := self sector: i.
        sector notNil ifTrue: [ aBlock value: sector ].
    ].!
   
sectorsIn: rectangle by: step
    "Returns aMatrix with found sectors in the rectangle by step intervals."

    | matrix row sectors id sector |
    rectangle isNumber ifTrue: [ ^self sectorsIn: rectangle @ rectangle by: step ].
    rectangle isPoint ifTrue: [ ^self sectorsIn: (0@0 extent: rectangle) by: step ].

    step isNil ifTrue: [ ^self sectorsIn: rectangle by: (rectangle extent // 100 max: 10) ].
    step isNumber ifTrue: [ ^self sectorsIn: rectangle by: step @ step ].

    "now rectangle is aRectangle and step is aPoint..."
    sectors := Dictionary new.
    matrix := OrderedCollection new.
    rectangle top to: rectangle bottom by: step y do: [:y|
        row := OrderedCollection new.
        rectangle left to: rectangle right by: step x do: [:x|
            id := self pane findSector: x @ y.
            sector := id notNil
                ifTrue: [ sectors at: id ifAbsentPut: [ self sectorAt: x@y ] ].
            row add: sector.
        ].
        matrix add: row asArray.
    ].
    ^matrix asArray!
   
setNotificationCallBack: aCallBackName to: aSelector
    " Private - The receiver MUST set the notification callback mechanism. "

    | old new |
    old := self callBackCache at: aCallBackName ifAbsent: [].
    new := self dll on: aCallBackName send: aSelector to: self.
    new notNil
    ifTrue: [
        self callBackCache at: aCallBackName put: new.
        old release.
    ].
    ^new notNil!

setSector: sectorID with:    aSector
    " Force aSector to be created in the receiver with id sectorID."

    (self dll newSector: sectorID) isNil
    ifTrue: [ ^self error: 'Can''t create sector #',sectorID asString ].
    ^self sectorCache at: sectorID put: aSector!
  
setVertex: vertexID with:    aVertex
    " Force aVertex to be created in the receiver with id vertexID."

    ^self vertexCache at: vertexID put: aVertex!
  
shadeTo: aShade
    "Sets the receiver's ambient aspect."

    self isValid ifFalse: [ ^false ].
    self pane
        shadeTo: aShade red asParameter
        green: aShade green asParameter
        blue: aShade blue asParameter
        distance: aShade distance asParameter.
    ^true!
 
shear
    "Returns the current shear.
    A Positive value signal to point up, looking toward the ceiling."

    self isValid ifFalse: [ ^nil ].
    ^RenderAXShear value: self pane shear!

shear: aShear
    "Sets the current shear.
    Skews the view up or down by the shear value.
    Setting this to a negative value will cause the next rendering to point down toward the floor.
    A Positive value will cause it to point up, looking toward the ceiling."

    self isValid ifFalse: [ ^false ].
    self pane shear: aShear asParameter.
    ^true!
 
shownActors
    "Returns the currently shown actors."

	^self dll shownActorsIDs collect: [:id| self actor: id ]!

spin: anActor to: anAngle
    "Spins an actor by anAngle."

    self isValid ifFalse: [ ^false ].
    self pane
        spinActor: anActor asParameter
        angle: anAngle asFloat asParameter.
    ^true!

startTracking
    " Start tracking process. "

    self isTracking ifTrue: [ ^true ].
    self isValid ifFalse: [ ^false ].
    [
        isTracking := true.
        [
        [ self isTracking and: [self isValid] ]
        whileTrue: [ self doTracking ].
        ] ensure: [ isTracking := false. ].
    ] forkAt: 3.
    ^true!
 
stopTracking
    " Stop tracking process. "

    isTracking := false.!
   
strategy
    "Returns the instance var of the receiver
     for external manipulation"

    strategy isNil ifTrue: [ self initializeStrategy ].
    ^strategy!
 
strategy: aStrategy
    "Sets the receiver's strategy and release the old."

    | old |
    old := strategy.
    strategy := aStrategy.
    old release.!

textureCache
    "Returns the instance var of the receiver
     for external manipulation"

    textureCache isNil ifTrue: [ self initializeTextureCache ].
    ^textureCache!
 
textureCache: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    textureCache := anObject!
   
textures
    "Returns the collection of current textures."

    ^self metaTextures!
  
trackAlways
    "Returns the instance var of the receiver
     for external manipulation"

    trackAlways isNil ifTrue: [ self initializeTrackAlways ].
    ^trackAlways!
 
trackAlways: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    trackAlways := anObject!
 
trackingAlways
    "Set the receiver to always track movement."

    self trackAlways: true!
 
trackingWhenActive
    "Set the receiver to track movement when pane is active."

    self trackAlways: false!
   
unusedActorType
    "Returns an unused(invalid) actor type."

    | aType |
	"we do not touch id=0(default) actor type"
    1 to: MaxActorType - 1 do: [:i|
        aType := self actorType: i.
        (aType notNil and: [aType isValid not])
		ifTrue: [ ^aType ].
    ].
    ^self error: 'Actor types overflow.'!

unusedTexture
    "Returns an unused(invalid) texture."

	| aTexture |
	"we do not consider the default texture (id=0)"
    1 to: MaxTextures - 1 do: [:i|
        aTexture := self metaTexture: i.
        (aTexture notNil and: [aTexture isValid not])
		ifTrue: [ ^aTexture ].
    ].
    ^self error: 'Texture overflow.'!
   
update
    " Update receiver's properties and visual cues."

    self ifValid: [
        self
            checkActors;
            realizePalette;
            render.
    ].!
  
vertex: vertexID
    "Returns the vertex number vertexID (or nil)."

    self isValid ifFalse: [ ^nil ].
    ^self vertexCache
        at: vertexID
        ifAbsent: [ self privateVertex: vertexID ].!
  
vertexCache
    "Returns the instance var of the receiver
     for external manipulation"

    vertexCache isNil ifTrue: [ self initializeVertexCache ].
    ^vertexCache!
 
vertexCache: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    vertexCache := anObject!
 
vertices
    "Returns all the vertices."

    ^self knownVertices!
   
veryDark
    "Sets the receiver's ambient to veryDark."

    self shadeTo: RenderAXShade new veryDark!
   
walkAtenuation
    "Returns the instance var of the receiver
     for external manipulation"

    walkAtenuation isNil ifTrue: [ self initializeWalkAtenuation ].
    ^walkAtenuation!
 
walkAtenuation: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    walkAtenuation := anObject!
   
walkFaster
    " Set the receiver to walk at faster rates if posible. "

    self walkAtenuation: (self walkAtenuation - 1 max: 1)!
  
walkReset
    " Set the receiver to walk at default rates. "

    self walkAtenuation: nil!
  
walkSlower
    " Set the receiver to walk at lower rates. "

    self walkAtenuation: self walkAtenuation + 1!
   
when: eventName evaluate: anAction
    "Append <anAction> to the list of actions to evaluate
     when the receiver triggers the event named <eventName>."

    eventName = #actorHit:with:
    ifTrue: [ self setNotificationCallBack: #actor to: #callBackActorNotification:hitActor: ].

    eventName = #lineHit:with:
    ifTrue: [ self setNotificationCallBack: #line to: #callBackLineNotification:line: ].

    eventName = #sectorCross:with:
    ifTrue: [ self setNotificationCallBack: #sector to: #callBackSectorNotification:sector: ].

    eventName = #missile:at:
    ifTrue: [ self setNotificationCallBack: #missile to: #callBackMissileNotification:x:y: ].

    ^super when: eventName evaluate: anAction! !



!RenderAXRandom class methods !
 
between: start and: stop
    "Returns a value between start and stop."

    ^stop - start * self current next + start
!
 
current
    "Returns the instance var of the receiver
     for external manipulation"

    current isNil ifTrue: [ self initializeCurrent ].
    ^current!
 
current: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    current := anObject!
 
initializeCurrent
    " Private - Initializes the receiver's current"

    current := self new.! !



!RenderAXRandom methods !
  
a
    "Returns the instance var of the receiver
     for external manipulation"

    a isNil ifTrue: [ self initializeA ].
    ^a!
 
a: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    a := anObject!
 
initializeA
    " Private - Initializes the receiver's a"

    a := 16r000041A7 asFloat.  " magic constant =      16807 "!
   
initializeM
    " Private - Initializes the receiver's m"

    m := 16r7FFFFFFF asFloat.    " magic constant = 2147483647 "!
 
initializeQ
    " Private - Initializes the receiver's q"

    q := (self m quo: self a) asFloat.!
   
initializeR
    " Private - Initializes the receiver's r"

    r := (self m \\ self a) asFloat.!
 
initializeSeed
    " Private - Initializes the receiver's seed"

    seed := Time millisecondClockValue.!

m
    "Returns the instance var of the receiver
     for external manipulation"

    m isNil ifTrue: [ self initializeM ].
    ^m!
 
m: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    m := anObject!
 
next
    " This method generates random instances of Float in the interval 0 to 1. "

    self seed: self nextValue.
    ^ self seed / self m!
  
nextValue
    "This method generates random instances of Integer
    in the interval 0 to 16r7FFFFFFF.
    This method does NOT update the seed; repeated sends answer the same value.
    The algorithm is described in detail in 'Random Number Generators:
    Good Ones Are Hard to Find' by Stephen K. Park and Keith W. Miller
    (Comm. Asso. Comp. Mach., 31(10):1192--1201, 1988). "

    | lo hi aLoRHi answer |
    hi := (self seed quo: self q) asFloat.
    lo := self seed - (hi * self q).     " = seed rem: q"
    aLoRHi := (self a * lo) - (self r * hi).
    answer := aLoRHi > 0.0 ifTrue:  [ aLoRHi ] ifFalse: [ aLoRHi + self m ].
    ^ answer!
   
q
    "Returns the instance var of the receiver
     for external manipulation"

    q isNil ifTrue: [ self initializeQ ].
    ^q!
 
q: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    q := anObject!
 
r
    "Returns the instance var of the receiver
     for external manipulation"

    r isNil ifTrue: [ self initializeR ].
    ^r!
 
r: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    r := anObject!
 
seed
    "Returns the instance var of the receiver
     for external manipulation"

    seed isNil ifTrue: [ self initializeSeed ].
    ^seed!
 
seed: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    seed := anObject! !



!RenderAXStrategy class methods !

constructEventsTriggered
    "Private - Construct the set of events triggered by instances of the receiver."

    ^super constructEventsTriggered
        add: #startChecking: ;
        add: #endChecking: ;
        add: #startRendering: ;
        add: #endRendering: ;
        yourself! !



!RenderAXStrategy methods !
  
endChecking: aSpace
    " Private - The receiver must perform the action to handle this event. "

    self triggerEvent: #endChecking: with: aSpace.!

endRendering: aSpace
    " Private - The receiver must perform the action to handle this event. "

    self triggerEvent: #endRendering: with: aSpace.!
  
startChecking: aSpace
    " Private - The receiver must perform the action to handle this event. "

    self triggerEvent: #startChecking: with: aSpace.!

startRendering: aSpace
    " Private - The receiver must perform the action to handle this event. "

    self triggerEvent: #startRendering: with: aSpace.! !



!RenderAXTimedStrategy methods !

endChecking: aSpace
    " Private - The receiver must perform the action to handle this event. "

    (nextTime notNil and: [ nextTime > Time now asSeconds ]) ifTrue: [ ^self ].
    self triggerEvent: #endChecking: with: aSpace.
    nextTime := Time now asSeconds + self interval.!
  
initializeInterval
    " Private - Initializes the receiver's interval"

    interval := 0.!
 
interval
    "Returns the instance var of the receiver
     for external manipulation"

    interval isNil ifTrue: [ self initializeInterval ].
    ^interval!
 
interval: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    interval := anObject!
   
startChecking: aSpace
    " Private - The receiver must perform the action to handle this event. "

    (nextTime notNil and: [ nextTime > Time now asSeconds ]) ifTrue: [ ^self ].
    self triggerEvent: #startChecking: with: aSpace.
    nextTime := Time now asSeconds + self interval.! !



!WadObject methods !

fileIn: aFileDirectoryEntry from: aStream size: sizeInBytes
    " Private, FileIn - Get the receiver from aStream and size of sizeInBytes.
    The default action is to do default fileIn."

    ^self fileInFrom: aStream size: sizeInBytes!
   
fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream.
    This method MUST be implemented by subclasses.
    MUST return the receiver if success, else nil must be returned to signal an error or a failure reading from aStream."

    ^self implementedBySubclass!
  
fileInFrom: aStream size: sizeInBytes
    " Private, FileIn - Get the receiver from aStream and size of sizeInBytes.
    The default action is to do default fileIn."

    ^self fileInFrom: (ReadWriteStream on: (aStream next: sizeInBytes))!
 
getOneOf: tokens from: aStream
    " Returns the next token in aStream, that matches one of tokens, or generates an error if not found."

    ^self
        getOneOf: tokens
        ifAbsent: [ self error: 'Invalid token.' ]
        from: aStream!

getOneOf: tokens ifAbsent: aBlock from: aStream
    " Returns the next token in aStream, that matches one of tokens, or evaluates aBlock if not found."

    | result |
    tokens do: [:each|
        (self peekToken: each from: aStream)
        ifTrue: [ ^self getToken: each from: aStream ].
    ].
    ^aBlock value!
   
getToken: aToken from: aStream
    " Try to read aToken from aStream and returns it or nil if it can't be read. "

    | result remaining |

    aToken isString ifTrue: [ "match the next token contents"
        remaining := ReadStream on: aToken.
        [remaining atEnd] whileFalse: [
            remaining peek = aStream peek ifFalse: [ ^nil ].
            remaining atEnd ifFalse: [ remaining next ].
            aStream atEnd ifFalse: [ aStream next ].
        ].
        ^aToken
        "  ^(aStream next: aToken size) = aToken ifTrue: [ aToken ]  "
    ].

    aToken isArray ifTrue: [ "match some alternatives"
        ^self getOneOf: aToken from; aStream
    ].

    aToken isClass ifTrue: [ "can be aWadElement"
        ^(aToken in: self) fileInFrom: aStream
    ].

    ^aToken evaluate: aStream. "computable token must return read token or nil"!
   
nextByteFrom: aStream
    " Returns the next byte in aStream.
    <byte>          is an unsigned 8-bit integer (0 to 255).
    "

    ^aStream nextByte!
   
nextCharFrom: aStream
    " Returns the next char in aStream.
    <char>          is a signed 8-bit integer (-128 to 127).
    "

    | result |
    result := self nextByteFrom: aStream.
    result > 16r7F ifTrue: [ result := result - 16r100 ].
    ^result!
   
nextLongFrom: aStream
    " Returns the next long in aStream.
    <long>          is a signed 32-bit integer (-2147483648 to 2147483647).
    "

    | result |
    result := aStream nextULong.
    result > 16r7FFFFFFF
    ifTrue: [  result := result - 16r100000000  ].
    ^result!
  
nextPointFrom: aStream
    " Returns the next point in aStream."

    ^(self nextShortFrom: aStream) @ (self nextShortFrom: aStream)!

nextShortFrom: aStream
    " Returns the next short in aStream.
    short>         is a signed 16-bit integer (-32768 to 32767).
    "

    | result |
    result := self nextUShortFrom: aStream.
    result > 16r7FFF ifTrue: [  result := result - 16r10000 ].
    ^result!
  
nextString8From: aStream
    " Returns the next 8 char in aStream.
    <string8>       is an ASCII string of from 1 to 8 bytes.
    If its length is less than 8 bytes, the remainder (zeros, hex 00) will be removed.
    "

    ^(aStream next: 8) trimBlanks!
  
nextUShortFrom: aStream
    " Returns the next ushort in aStream.
    <ushort>        is an unsigned 16-bit integer in lo-hi format (0 to 65535).
    "

    ^aStream nextUShort!
  
peekToken: aToken from: aStream
    " Returns true if the token aToken is the next token to be read. "

    | position result |
    position := aStream position.
    result := self getToken: aToken from: aStream.
    aStream position: position.
    ^result notNil!
 
root
	"Returns the receiver's root parent."

	^self! !



!WadElement class methods !

in: aParent
    "Returns an instance of the receiver contained in aParent."

    ^self new
        parent: aParent;
        yourself! !



!WadElement methods !
   
isColorMap
	"True if the receiver is a colorMap."

	^false!
  
isKnown
	"Returns true if the lump is recognized."

	^self isUnknown not!

isMarker
	"True if the receiver is a marker."

	^false!
  
isNamed
	"Returns true if the receiver can return it's name."

	^self respondsTo: #name!
 
isPicture
	"Returns true if the receiver is a picture lump."

	^false!
   
isSoundEffect
	"Returns true if the receiver is a sound effect lump."

	^false!
  
isUnknown
	"Returns true if the lump is not recognized. yet..."

	^false!

parent
    "Returns the instance var of the receiver
     for external manipulation"
    ^parent!

parent: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    parent := anObject!
   
printOn: aStream
	"Append the ASCII representation of the receiver to aStream."

	self isNamed ifFalse: [ ^super printOn: aStream ].
	aStream cr;nextPutAll: self class name,':',self name printString.!

root
	"Returns the receiver's root parent."

	^self parent notNil
	ifTrue: [self parent root]
	ifFalse: [ self ]! !



!Lump class methods !
   
supports: aName
    "The receiver must return true if it instances can handle lump structures with name aName. "

    ^self implementedBySubclass! !



!BlockMap class methods !

supports: aName
    "The receiver must return true if it instances can handle lump structures with name aName. "

    ^aName = 'BLOCKMAP'! !



!BlockMap methods !
  
blockLists
    "Returns the instance var of the receiver
     for external manipulation"
    ^blockLists!

blockLists: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    blockLists := anObject!
   
blocks
    "Returns the instance var of the receiver
     for external manipulation"
    ^blocks!

blocks: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    blocks := anObject!
   
fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream."

    self
        origin: (self nextPointFrom: aStream);
        blocks: (self nextPointFrom: aStream);
        listOffsets: (self nextOffsetsFrom: aStream);
        blockLists: (self nextBlockListsFrom: aStream);
        yourself!
 
listOffsets
    "Returns the instance var of the receiver
     for external manipulation"
    ^listOffsets!
  
listOffsets: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    listOffsets := anObject!
 
nextBlockListFrom: aStream
    " Private, FileIn - Get the next blockList from aStream."

	| result lineDef |
	result := OrderedCollection new.
	(0 = (self nextShortFrom: aStream)) ifFalse: [ self error: 'Must be zero.' ].
	[-1 = (lineDef := self nextShortFrom: aStream)] whileFalse: [
		result addLast: lineDef
	].
	^result asArray!
  
nextBlockListsFrom: aStream
    " Private, FileIn - Get the next blockLists from aStream."

	| result |
	result := Array new: self numberOfBlocks.
	1 to: result size do: [:i|
		result at: i put: (self nextBlockListFrom: aStream)
	].
	^result!
  
nextOffsetsFrom: aStream
    " Private, FileIn - Get the next listOffsets from aStream."

	| result |
	result := Array new: self numberOfBlocks.
	1 to: result size do: [:i|
		result at: i put: (self nextUShortFrom: aStream)
	].
	^result!
   
numberOfBlocks
	"Returns the total number of blocks."

	^self blocks x * self blocks y!
  
origin
    "Returns the instance var of the receiver
     for external manipulation"
    ^origin!

origin: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    origin := anObject! !



!LumpBasicContainer class methods !
  
supports: aName
    "The receiver must return true if it instances can handle lump structures with name aName. "

    ^false! !



!LumpBasicContainer methods !
 
contents
    "Returns the instance var of the receiver
     for external manipulation"
    ^contents!

contents: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    contents := anObject! !



!EndDOOM class methods !
 
supports: aName
    "The receiver must return true if it instances can handle lump structures with name aName. "

    ^aName = 'ENDOOM'! !



!EndDOOM methods !
 
fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream."

    self contents: (aStream next: 1000 * 2)! !



!LumpContainer methods !
  
contents
    "Returns the instance var of the receiver
     for external manipulation"

    contents isNil ifTrue: [ self initializeContents ].
    ^contents!
 
fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream."

    [aStream atEnd] whileFalse: [
        self contents add: (self getNextFrom: aStream)
    ]!
   
getNextFrom: aStream
    " Private, FileIn - Get the next element from aStream.
    This method must be implemented by subclasses."

    ^self implementedBySubclass!
   
initializeContents
    " Private - Initializes the receiver's contents"

    contents := OrderedCollection new.! !



!ColorMaps class methods !
 
supports: aName
    "The receiver must return true if it instances can handle lump structures with name aName. "

    ^aName = 'COLORMAP'! !



!ColorMaps methods !
 
blackColors
	"Colormap 33 is all black for some reason."

	^self contents last!
  
colorsForLightLevel: lightLevel
	"Returns the colors to be used for a lightLevel.
	Colormaps 0-31 are for the different brightness levels,
	0 being the brightest (light level 248-255),
	31 being the darkest (light level 0-7).
	Light level is defined in each sector."

	^self contents at: lightLevel // 8 + 1!
 
fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream."

    1 to: self contents size do: [:i|
        self contents at: i put: (self nextColorMapFrom: aStream)
    ].!
   
initializeContents
    " Private - Initializes the receiver's contents"

    contents := Array new: 34.!
 
invulnerabilityColors
	"Colormap 32 is used for every pixel in the display window
	(but not the status bar), regardless of sector brightness,
	when the player is under the effect of the 'Invulnerability' power-up.
	This colormap is all whites and greys."

	^self contents at: 33!
   
isColorMap
	"True if the receiver is a colorMap."

	^true!
   
lightAmplificationColors
	"While the light-amplification goggles power-up is in effect, everything
	in the display uses colormap 0, regardless of sector brightness."

	^self contents first!
   
nextColorMapFrom: aStream
    " Returns the next colorMap in aStream.
    <color_map>     := <mapping> [256]
    <mapping>       := <byte>
    "

    ^(aStream next: 256) asByteArray! !



!LumpLineDefs class methods !

supports: aName
    "The receiver must return true if it instances can handle lump structures with name aName. "

    ^aName = 'LINEDEFS'! !



!LumpLineDefs methods !
  
getNextFrom: aStream
    " Private, FileIn - Get the next element from aStream."

    ^LumpLineDef from: aStream in: self! !



!LumpNodes class methods !
   
supports: aName
    "The receiver must return true if it instances can handle lump structures with name aName. "

    ^aName = 'NODES'! !



!LumpNodes methods !

getNextFrom: aStream
    " Private, FileIn - Get the next element from aStream."

    ^LumpNode from: aStream in: self! !



!LumpSectors class methods !

supports: aName
    "The receiver must return true if it instances can handle lump structures with name aName. "

    ^aName = 'SECTORS'! !



!LumpSectors methods !

getNextFrom: aStream
    " Private, FileIn - Get the next element from aStream."

    ^LumpSector from: aStream in: self! !



!LumpSegs class methods !
 
supports: aName
    "The receiver must return true if it instances can handle lump structures with name aName. "

    ^aName = 'SEGS'! !



!LumpSegs methods !
  
getNextFrom: aStream
    " Private, FileIn - Get the next element from aStream."

    ^LumpSeg from: aStream in: self! !



!LumpSideDefs class methods !

supports: aName
    "The receiver must return true if it instances can handle lump structures with name aName. "

    ^aName = 'SIDEDEFS'! !



!LumpSideDefs methods !
  
getNextFrom: aStream
    " Private, FileIn - Get the next element from aStream."

    ^LumpSideDef from: aStream in: self! !



!LumpSubSectors class methods !
  
supports: aName
    "The receiver must return true if it instances can handle lump structures with name aName. "

    ^aName = 'SSECTORS'! !



!LumpSubSectors methods !

getNextFrom: aStream
    " Private, FileIn - Get the next element from aStream."

    ^LumpSubSector from: aStream in: self! !



!LumpThings class methods !

supports: aName
    "The receiver must return true if it instances can handle lump structures with name aName. "

    ^aName = 'THINGS'! !



!LumpThings methods !
  
getNextFrom: aStream
    " Private, FileIn - Get the next element from aStream."

    ^LumpThing from: aStream in: self! !



!LumpVertexes class methods !
  
supports: aName
    "The receiver must return true if it instances can handle lump structures with name aName. "

    ^aName = 'VERTEXES'! !



!LumpVertexes methods !
  
getNextFrom: aStream
    " Private, FileIn - Get the next element from aStream."

    ^LumpVertex from: aStream in: self! !



!LumpDemo class methods !
 
supports: aName
    "The receiver must return true if it instances can handle lump structures with name aName. "

    ^aName size > 4 and: [ (aName copyFrom: 1 to: 4) = 'DEMO' ]! !



!LumpDemo methods !
  
duration
    "Returns the duration (in seconds) of the demo.
    Every 1/35 of a second is a gametic, and for every gametic, there is one 4-byte chunk per player.
    So the time duration of a demo (in seconds) is approximately equal to its length in bytes divided by (140 * number_of_players)."

    ^self gametics size / 35!
 
fileIn: aFileDirectoryEntry from: aStream size: sizeInBytes
    " Private, FileIn - Get the receiver from aStream and size of sizeInBytes.
    The default action is to do default fileIn."

    self number: aFileDirectoryEntry name last asciiValue - $0 asciiValue.
    ^self contents: (aStream next: sizeInBytes)!
   
fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream."

	"nothing to do here."!
 
fillFrom: aStream
    " Private, FileIn - Get the receiver from aStream."

    self header: (self getHeaderFrom: aStream).
	gametics := OrderedCollection new.
    [aStream peek asciiValue = 128] whileFalse: [
        gametics add: (self getGameticFrom: aStream)
    ].!

fillFromContents
	" Private - Initializes the receiver's instances from it's contents."

	self fillFrom: (ReadWriteStream on: self contents).!
   
gametics
    "Returns the instance var of the receiver
     for external manipulation"

	gametics isNil ifTrue: [ self initializeGametics ].
    ^gametics!

gametics: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    gametics := anObject!
   
getGameticFrom: aStream
    " Private, FileIn - Get the receiver's GameTics from aStream. "

    ^GameTic from: aStream in: self!

getHeaderFrom: aStream
    " Private, FileIn - Get the receiver's header from aStream. "

    ^LumpDemoHeader from: aStream in: self!

header
    "Returns the instance var of the receiver
     for external manipulation"

	header isNil ifTrue: [ self initializeHeader ].
    ^header!

header: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    header := anObject!
   
initializeGametics
	" Private - Initializes the receiver's gametics"

	self fillFromContents.!
   
initializeHeader
	" Private - Initializes the receiver's header"

	self fillFromContents.!
   
name
	"Returns the receiver's name."

	^'DEMO',self number asString!
 
number
    "Returns the instance var of the receiver
     for external manipulation"
    ^number!

number: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    number := anObject! !



!LumpDMXGUS class methods !
  
supports: aName
    "The receiver must return true if it instances can handle lump structures with name aName. "

    ^aName = 'DMXGUS'! !



!LumpDMXGUS methods !
  
fileIn: aFileDirectoryEntry from: aStream size: sizeInBytes
    " Private, FileIn - Get the receiver from aStream and size of sizeInBytes."

    self contents: (aStream next: sizeInBytes) trimBlanks! !



!LumpNamedContainer methods !
   
fileIn: aFileDirectoryEntry from: aStream size: sizeInBytes
    " Private, FileIn - Get the receiver from aStream and size of sizeInBytes."

    self name: aFileDirectoryEntry name.
	^super fileIn: aFileDirectoryEntry from: aStream size: sizeInBytes!
  
fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream."

	"nothing to do here..."!
   
isNamed
	"Returns true if the receiver can return it's name."

	^true!
   
name
    "Returns the instance var of the receiver
     for external manipulation"
    ^name!

name: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    name := anObject!
   
printOn: aStream
	"Append the ASCII representation of the receiver to aStream."

	super printOn: aStream.
	aStream nextPutAll: '[',self contents size asString,']'! !



!LumpPicture class methods !
   
prologue
	" Private - Must return the receiver's prologue string.
	This method can be refined by subbclasses. "

	^nil!
 
supports: aName
    "The receiver must return true if it instances can handle lump structures with name aName. "

	| prologue |
	prologue := self prologue.
	prologue isNil ifTrue: [ ^super supports: aName ].
    ^aName size > prologue size
		and: [ (aName copyFrom: 1 to: prologue size) = prologue ]! !



!LumpPicture methods !
 
asDIB
	" Returns the receiver as a DIB.
	The DIB will be built from receiver's current state. "

	^DIB new
		bitmapInfo: self bitmapInfo;
		bits: self bits;
		yourself!
 
bitmapInfo
	" Private - Build a BitmapInfo structure acording to receiver's properties. "

	| bitmapInfo |
    bitmapInfo := WinBitmapInfo
        width: self width height: self height
        planes: 1 bitCount: 8.
    bitmapInfo
        clrUsed: 256; clrImportant: 256;
        xPelsPerMeter: 100; yPelsPerMeter: 100;
        sizeImage: (((bitmapInfo width * bitmapInfo bitCount) + 31) // 32 * 4) * bitmapInfo height;
        colorTable: self colorTable;
        yourself.
    ^bitmapInfo!

bits
	" Private - Returns the receiver's bits. "

	^self implementedBySubclass!
  
colorTable
    "Returns the instance var of the receiver
     for external manipulation"

	colorTable isNil ifTrue: [ self initializeColorTable ].
    ^colorTable!

colorTable: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    colorTable := anObject!
   
extent
	"Returns the receiver's extent in pixels."

	^self width @ self height!
  
fileIn: aFileDirectoryEntry from: aStream size: sizeInBytes
    " Private, FileIn - Get the receiver from aStream and size of sizeInBytes."

	super fileIn: aFileDirectoryEntry from: aStream size: sizeInBytes.
    self contents: (aStream next: sizeInBytes) asByteArray.!
   
height
	"Returns the receiver's height in pixels."

	^self implementedBySubclass!

initializeColorTable
	" Private - Initializes the receiver's colorTable"

	colorTable := self root defaultColorTable.!
   
isPicture
	"Returns true if the receiver is a picture lump."

	^true!

outputToFile: pathName
	" Output the receiver's image to file named pathName (in DIB format). "

	self asDIB asBitmap
		outputToFile: pathName;
		release;
		yourself.!
   
scanLineSize
	" Private - Returns the receiver's scan line size for bits. "

	^self width * 8 + 31 // 32 * 4!

texture
	" Returns the receiver's texture in current space. "

	^self textureIn: RenderAXSpace current!
  
textureIn: aRenderAXSpace
	" Returns the receiver's texture in aRenderAXSpace. "

	^self textureIn: aRenderAXSpace extent: self extent!
  
textureIn: aRenderAXSpace extent: aPoint
	" Returns the receiver's texture in aRenderAXSpace. "

	| texture |
	texture := self textureInUse.
	texture isNil ifTrue: [
		texture := aRenderAXSpace newTexture
			fromPicture: self
			extent: aPoint.
		self textureInUse: texture.
	].
	^texture!

textureInUse
	" Returns the receiver's catched texture (or nil). "

	^self propertyAt: #textureInUse!

textureInUse: aTexture
	" Sets the receiver's catched texture. "

	^self propertyAt: #textureInUse put: aTexture!

width
	"Returns the receiver's width in pixels."

	^self implementedBySubclass! !



!LumpFlat methods !
 
bits
	" Private - Returns the receiver's bits. "

	^self contents!
   
height
	"Returns the receiver's height in pixels."
	^64!
  
width
	"Returns the receiver's width in pixels."
	^64! !



!LumpGraphic methods !

bits
    "Returns the instance var of the receiver
     for external manipulation"

	bits isNil ifTrue: [ self initializeBits ].
    ^bits!

extent
    "Returns the instance var of the receiver
     for external manipulation"

	extent isNil ifTrue: [ self initializeExtent ].
    ^extent!

extent: aPoint
    "Sets the instance var of the receiver."

	extent := aPoint!
  
fillFrom: aStream
	" Private - Gets the receiver's private data from current contents. "

	| pointers width height start |
	self
		extent: (self nextPointFrom: aStream);
		offset: (self nextPointFrom: aStream);
		yourself.
	width := self width.
	height := self height.
	pointers := Array new: width.
	1 to: width do: [:i|
		pointers at: i put: (self nextLongFrom: aStream)
	].
	bits := ByteArray new: self scanLineSize * height.
	bits atAllPut: self maskByte.
	1 to: width do: [:i|
		aStream position: (pointers at: i).
		self getCollumn: i from: aStream
	].!
  
getCollumn: x from: aStream
	" Private - Gets the next <collumn> in aStream into chunk bytes. "

	| rowStart pixelCount height unused scanLineSize |
	height := self height.
	scanLineSize := self scanLineSize.
	[aStream peek asciiValue = 255] whileFalse: [
		rowStart := self nextByteFrom: aStream.
		pixelCount := self nextByteFrom: aStream.
		unused := self nextByteFrom: aStream.
		rowStart to: rowStart + pixelCount - 1 do: [:y|
			bits
				at: height - y - 1 * scanLineSize + x
				put: aStream nextByte
		].
		unused := self nextByteFrom: aStream.
	]!

getPrivateData
	" Private - Initializes the receiver's private data from current contents. "

	self fillFrom: (ReadWriteStream on: self contents asString)!
  
height
	^self extent y!

initializeBits
	" Private - Initializes the receiver's bits"

	self getPrivateData.!
 
initializeExtent
	" Private - Initializes the receiver's extent"

	self getPrivateData.!
 
initializeOffset
	" Private - Initializes the receiver's offset"

	self getPrivateData.!
 
maskByte
	" Private - Returns the mask byte color. "

	^0"255"!
  
offset
    "Returns the instance var of the receiver
     for external manipulation"

	offset isNil ifTrue: [ self initializeOffset ].
    ^offset!

offset: aPoint
    "Sets the instance var of the receiver."

	offset := aPoint!
  
width
	^self extent x! !



!LumpRawPicture methods !
  
bits
	" Private - Returns the receiver's bits. "

	| bits height width start |
	bits := ByteArray new: self scanLineSize * self height.
	height := self height.
	width := self width.
	1 to: height - 1 * width by: width do: [:y|
		start := width * (height - 1) - y.
		bits
			replaceFrom: start
			to: start + width
			with: self contents
			startingAt: y
	].
	^bits! !



!LumpScreen methods !
 
height
	"Returns the receiver's height in pixels."
	^200!
 
width
	"Returns the receiver's width in pixels."
	^320! !



!LumpCredit class methods !
  
supports: aName
    "The receiver must return true if it instances can handle lump structures with name aName. "

    ^aName = 'CREDIT'! !



!LumpHelpScreen class methods !

prologue
	" Private - Must return the receiver's prologue string. "

	^'HELP'! !



!LumpHintScreen class methods !
  
prologue
	" Private - Must return the receiver's prologue string. "

	^'PFUB'! !



!LumpTitleScreen class methods !
 
supports: aName
    "The receiver must return true if it instances can handle lump structures with name aName. "

    ^#('TITLEPIC' 'TITLE' 'ORDER') includes: aName! !



!LumpVictoryScreen class methods !

prologue
	" Private - Must return the receiver's prologue string. "

	^'VICTORY'! !



!LumpSoundEffect class methods !
  
prologue
	" Private - Must return the receiver's prologue string. "

	^self implementedBySubclass!
   
supports: aName
    "The receiver must return true if it instances can handle lump structures with name aName. "

	| prologue |
	self == LumpSoundEffect ifTrue: [ ^super supports: aName ].
	prologue := self prologue.
    ^aName size > prologue size
		and: [ (aName copyFrom: 1 to: prologue size) = prologue ]! !



!LumpSoundEffect methods !

fileIn: aFileDirectoryEntry from: aStream size: sizeInBytes
    " Private, FileIn - Get the receiver from aStream and size of sizeInBytes."

	super fileIn: aFileDirectoryEntry from: aStream size: sizeInBytes.
    self contents: (aStream next: sizeInBytes) asByteArray.!
   
isSoundEffect
	"Returns true if the receiver is a sound effect lump."

	^true! !



!LumpMusicSoundEffect class methods !

prologue
	" Private - Must return the receiver's prologue string. "

	^'D_'! !



!LumpMusicSoundEffect methods !

getMusicFrom: aStream
    " Private, FileIn - Get the music information from aStream."

	^LumpMusic from: aStream in: self!
  
music
    " Private, FileIn - Get the receiver's contents in music format."

	^self getMusicFrom: (ReadWriteStream on: contents asString)! !



!LumpPCSpeakerSoundEffect class methods !

prologue
	" Private - Must return the receiver's prologue string. "

	^'DP'! !



!LumpSoundCardSoundEffect class methods !
  
prologue
	" Private - Must return the receiver's prologue string. "

	^'DS'! !



!UnknownLump class methods !
   
supports: aName
    "The receiver must return true if it instances can handle lump structures with name aName. "

    ^false! !



!UnknownLump methods !

fileIn: aFileDirectoryEntry from: aStream size: sizeInBytes
    " Private, FileIn - Get the receiver from aStream and size of sizeInBytes."

    self
		name: aFileDirectoryEntry name;
		contents: (aStream next: sizeInBytes) asByteArray;
		yourself!
  
isUnknown
	"Returns true if the lump is not recognized. yet..."
	^true! !



!LumpLoadFailure methods !
   
fileIn: aFileDirectoryEntry from: aStream size: sizeInBytes
    " Private, FileIn - Get the receiver from aStream and size of sizeInBytes."

    self
		name: aFileDirectoryEntry name;
		contents: (aStream next: (sizeInBytes min: aStream size - aStream position)) asByteArray;
		yourself! !



!LumpNames class methods !
   
supports: aName
    "The receiver must return true if it instances can handle lump structures with name aName. "

    ^aName = 'PNAMES'! !



!LumpNames methods !
   
fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream."

	| numberOfNames |
	numberOfNames := self nextLongFrom: aStream.
	contents := Array new: numberOfNames.
	1 to: numberOfNames do: [:i|
		contents at: i put: (self nextString8From: aStream)
	].! !



!LumpTransparentSky class methods !
  
supports: aName
    "The receiver must return true if it instances can handle lump structures with name aName. "

    ^aName size > 5 and: [ (aName copyFrom: 1 to: 5) = 'F_SKY' ]! !



!LumpTransparentSky methods !
   
fileIn: aFileDirectoryEntry from: aStream size: sizeInBytes
    " Private, FileIn - Get the receiver from aStream and size of sizeInBytes.
    The default action is to do default fileIn."

    self number: aFileDirectoryEntry name last asciiValue - $0 asciiValue.
    ^self contents: (aStream next: sizeInBytes)!
   
fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream."

	"nothing to do here."!
 
name
	"Returns the receiver's name."

	^'F_SKY',self number asString!

number
    "Returns the instance var of the receiver
     for external manipulation"
    ^number!

number: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    number := anObject! !



!Reject class methods !
  
supports: aName
    "The receiver must return true if it instances can handle lump structures with name aName. "

    ^aName = 'REJECT'! !



!Reject methods !
  
fileInFrom: aStream size: sizeInBytes
    " Private, FileIn - Get the receiver from aStream and size of sizeInBytes."

	self contents: (aStream next: sizeInBytes)! !



!LumpGenMIDI class methods !

supports: aName
    "The receiver must return true if it instances can handle lump structures with name aName. "

    ^aName = 'GENMIDI'! !



!LumpGenMIDI methods !

data
    "Returns the instance var of the receiver
     for external manipulation"

	data isNil ifTrue: [ self initializeData ].
    ^data!

data: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    data := anObject!
   
fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream."

    self header: (self nextString8From: aStream).
	1 to: self data size do: [:i|
		self data at: i put: (self nextInstrumentDataFrom: aStream)
	].
	1 to: self instruments size do: [:i|
		self instruments at: i put: (self nextInstrumentFrom: aStream)
	].!

header
    "Returns the instance var of the receiver
     for external manipulation"
    ^header!

header: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    header := anObject!
   
initializeData
	" Private - Initializes the receiver's data"

	data := Array new: 150.!
  
initializeInstruments
	" Private - Initializes the receiver's instruments"

	instruments := Array new: 150.!
 
instruments
    "Returns the instance var of the receiver
     for external manipulation"

	instruments isNil ifTrue: [ self initializeInstruments ].
    ^instruments!

instruments: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    instruments := anObject!
 
nextInstrumentDataFrom: aStream
    " Private, FileIn - Get the next instrument data from aStream."

    ^(aStream next: 36) asByteArray!

nextInstrumentFrom: aStream
    " Private, FileIn - Get the next instrument name from aStream."

    ^(aStream next: 36) trimBlanks! !



!LumpTexture class methods !
   
supports: aName
    "The receiver must return true if it instances can handle lump structures with name aName. "

    ^aName size > 7 and: [ (aName copyFrom: 1 to: 7) = 'TEXTURE' ]! !



!LumpTexture methods !

entries
    "Returns the instance var of the receiver
     for external manipulation"
    ^entries!
  
entries: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    entries := anObject!
 
fileIn: aFileDirectoryEntry from: aStream size: sizeInBytes
    " Private, FileIn - Get the receiver from aStream and size of sizeInBytes.
    The default action is to do default fileIn."

    self number: aFileDirectoryEntry name last asciiValue - $0 asciiValue.
    ^self fileInFrom: (ReadWriteStream on: (aStream next: sizeInBytes))!
   
fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream."

    self
        numberOfTextures: (self nextLongFrom: aStream);
        offsets: (self nextOffsetsFrom: aStream);
        entries: (self nextEntriesFrom: aStream);
        yourself!
  
nextEntriesFrom: aStream
    " Private, FileIn - Get the entries collection from aStream."

	| result |
	result := Array new: self numberOfTextures.
	1 to: result size do: [:i|
		result at: i put: (self nextEntryFrom: aStream)
	].
	^result!

nextEntryFrom: aStream
    " Private, FileIn - Get the entry from aStream."

	^TextureEntry from: aStream in: self!
  
nextOffsetsFrom: aStream
    " Private, FileIn - Get the next listOffsets from aStream."

	| result |
	result := Array new: self numberOfTextures.
	1 to: result size do: [:i|
		result at: i put: (self nextLongFrom: aStream)
	].
	^result!
   
number
    "Returns the instance var of the receiver
     for external manipulation"
    ^number!

number: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    number := anObject!
   
numberOfTextures
    "Returns the instance var of the receiver
     for external manipulation"
    ^numberOfTextures!

numberOfTextures: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    numberOfTextures := anObject!
   
offsets
    "Returns the instance var of the receiver
     for external manipulation"
    ^offsets!
  
offsets: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    offsets := anObject! !



!PlayPalettes class methods !
  
supports: aName
    "The receiver must return true if it instances can handle lump structures with name aName. "

    ^aName = 'PLAYPAL'! !



!PlayPalettes methods !
   
fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream."

    1 to: self palettes size do: [:i|
        self palettes at: i put: (self nextPaletteFrom: aStream)
    ].!

initializePalettes
    " Private - Initializes the receiver's palettes"

    palettes := Array new: 14.!
 
nextPaletteFrom: aStream
    " Returns the next palette in aStream.
    <palette>       := {<red> <green> <blue>} [256]
    <red>           := <byte>
    <green>         := <byte>
    <blue>          := <byte>
    Note that while a palette entry is stored as Red-Green-Blue, the RGBquad data is actually stored as Blue-Green-Red.
    "

    | numColors colorTable red green blue |
    numColors := 256.
    colorTable := WriteStream on: (ByteArray new: numColors * 4).
    numColors timesRepeat: [
        red := aStream nextByte.
        green := aStream nextByte.
        blue := aStream nextByte.
        colorTable
            nextPut: blue;
            nextPut: green;
            nextPut: red;
            nextPut: 0.
    ].
    ^colorTable contents!
  
palettes
    "Returns the instance var of the receiver
     for external manipulation"

    palettes isNil ifTrue: [ self initializePalettes ].
    ^palettes!
 
palettes: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    palettes := anObject! !



!LumpElement class methods !
 
from: aStream in: aContainer
    "Returns an instance of the receiver read from aStream and contained in aContainer."

    ^(self in: aContainer)
            fileInFrom: aStream! !



!GameAction methods !
   
fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream."

    | forward strafe |
    forward := self nextCharFrom: aStream.
    strafe := self nextCharFrom: aStream.
    self movement: forward @ strafe.

    self
        turn: (self nextCharFrom: aStream);
        flags: (self nextByteFrom: aStream);
        yourself.!
  
flags
    "Returns the instance var of the receiver
     for external manipulation"
    ^flags!
  
flags: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    flags := anObject!
 
movement
    "Returns the instance var of the receiver
     for external manipulation"
    ^movement!

movement: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    movement := anObject!
   
turn
    "Returns the instance var of the receiver
     for external manipulation"
    ^turn!

turn: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    turn := anObject! !



!GameTic methods !
   
actions
    "Returns the instance var of the receiver
     for external manipulation"

    actions isNil ifTrue: [ self initializeActions ].
    ^actions!
 
actions: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    actions := anObject!
 
fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream."

    1 to: self actions size do: [:i|
        self actions at: i put: (self getActionFrom: aStream)
    ].!

getActionFrom: aStream
    " Private, FileIn - Get the next action from aStream."

    ^GameAction from: aStream in: self!
   
initializeActions
    " Private - Initializes the receiver's actions"

    actions := Array new: self numberOfPlayers.!
  
numberOfPlayers
    "Returns the number of players."

    ^self parent header players size! !



!LumpLineDef methods !
  
fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream."

    self
        from: (self nextShortFrom: aStream);
        to: (self nextShortFrom: aStream);
        flags: (self nextShortFrom: aStream);
        types: (self nextShortFrom: aStream);
        trigger: (self nextShortFrom: aStream);
        numberOfRightSideDef: (self nextShortFrom: aStream);
        leftSideDef: (self nextShortFrom: aStream);
        yourself!
 
flags
    "Returns the instance var of the receiver
     for external manipulation"
    ^flags!
  
flags: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    flags := anObject!
 
from
    "Returns the instance var of the receiver
     for external manipulation"
    ^from!

from: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    from := anObject!
   
leftSideDef
    "Returns the instance var of the receiver
     for external manipulation"
    ^leftSideDef!
  
leftSideDef: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    leftSideDef := anObject!
 
numberOfRightSideDef
    "Returns the instance var of the receiver
     for external manipulation"
    ^numberOfRightSideDef!

numberOfRightSideDef: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    numberOfRightSideDef := anObject!
   
to
    "Returns the instance var of the receiver
     for external manipulation"
    ^to!

to: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    to := anObject!
   
trigger
    "Returns the instance var of the receiver
     for external manipulation"
    ^trigger!
  
trigger: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    trigger := anObject!
 
types
    "Returns the instance var of the receiver
     for external manipulation"
    ^types!
  
types: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    types := anObject! !



!LumpMusic methods !
   
data
    "Returns the instance var of the receiver
     for external manipulation"
    ^data!

data: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    data := anObject!
   
dataSize
    "Returns the instance var of the receiver
     for external manipulation"
    ^dataSize!

dataSize: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    dataSize := anObject!
   
dataStart
    "Returns the instance var of the receiver
     for external manipulation"
    ^dataStart!
  
dataStart: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    dataStart := anObject!
 
fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream."

    self
        header: (aStream upTo: 16r1A asCharacter);
        dataSize: (self nextShortFrom: aStream);
        dataStart: (self nextShortFrom: aStream);
        numberOfPrimaryChannels: (self nextShortFrom: aStream);
        numberOfSecondaryChannels: (self nextShortFrom: aStream);
        numberOfPatches: (self nextShortFrom: aStream);
        yourself.

	(self nextShortFrom: aStream) = 0 ifFalse: [ self error: 'Must be zero.' ].
	patchNumbers := Array new: self numberOfPatches.
	1 to: self numberOfPatches do: [:i|
		patchNumbers at: i put: (self nextShortFrom: aStream)
	].

	aStream position: dataStart.
	self data: (aStream upTo: nil) asByteArray.!

header
    "Returns the instance var of the receiver
     for external manipulation"
    ^header!

header: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    header := anObject!
   
numberOfPatches
    "Returns the instance var of the receiver
     for external manipulation"
    ^numberOfPatches!
  
numberOfPatches: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    numberOfPatches := anObject!
 
numberOfPrimaryChannels
    "Returns the instance var of the receiver
     for external manipulation"
    ^numberOfPrimaryChannels!
  
numberOfPrimaryChannels: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    numberOfPrimaryChannels := anObject!
 
numberOfSecondaryChannels
    "Returns the instance var of the receiver
     for external manipulation"
    ^numberOfSecondaryChannels!
  
numberOfSecondaryChannels: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    numberOfSecondaryChannels := anObject!
 
patchNumbers
    "Returns the instance var of the receiver
     for external manipulation"
    ^patchNumbers!

patchNumbers: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    patchNumbers := anObject! !



!LumpNode methods !
  
fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream."

    self
        lineStart: (self nextPointFrom: aStream);
        partitionDelta: (self nextPointFrom: aStream);
        rightBounds: (self nextBoundsFrom: aStream);
        leftBounds: (self nextBoundsFrom: aStream);
        rightChild: (self nextUShortFrom: aStream);
        leftChild: (self nextUShortFrom: aStream);
        yourself!
  
leftBounds
    "Returns the instance var of the receiver
     for external manipulation"
    ^leftBounds!

leftBounds: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    leftBounds := anObject!
   
leftChild
    "Returns the instance var of the receiver
     for external manipulation"
    ^leftChild!
  
leftChild: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    leftChild := anObject!
 
lineStart
    "Returns the instance var of the receiver
     for external manipulation"
    ^lineStart!
  
lineStart: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    lineStart := anObject!
 
nextBoundsFrom: aStream
    " Private, FileIn - Get the next bounds from aStream."

    | x1 y1 x2 y2 |
    y2 := self nextShortFrom: aStream.
    y1 := self nextShortFrom: aStream.
    x1 := self nextShortFrom: aStream.
    x2 := self nextShortFrom: aStream.
    ^x1 @ y1 rightBottom: x2 @ y2!
  
partitionDelta
    "Returns the instance var of the receiver
     for external manipulation"
    ^partitionDelta!

partitionDelta: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    partitionDelta := anObject!
   
rightBounds
    "Returns the instance var of the receiver
     for external manipulation"
    ^rightBounds!
  
rightBounds: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    rightBounds := anObject!
 
rightChild
    "Returns the instance var of the receiver
     for external manipulation"
    ^rightChild!

rightChild: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    rightChild := anObject! !



!LumpSector methods !

ceilingHeight
    "Returns the instance var of the receiver
     for external manipulation"
    ^ceilingHeight!
  
ceilingHeight: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    ceilingHeight := anObject!
 
ceilingName
    "Returns the instance var of the receiver
     for external manipulation"
    ^ceilingName!
  
ceilingName: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    ceilingName := anObject!
 
colorMap
    "Returns the instance var of the receiver
     for external manipulation"

	colorMap isNil ifTrue: [ self initializeColorMap ].
    ^colorMap!

colors
	"Returns the colors to be used in this sector."

	^self colorMap colorsForLightLevel: self lightLevel!
   
fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream."

    self
        floorHeight: (self nextShortFrom: aStream);
        ceilingHeight: (self nextShortFrom: aStream);
        floorName: (self nextString8From: aStream);
        ceilingName: (self nextString8From: aStream);
        lightLevel: (self nextShortFrom: aStream);
        type: (self nextShortFrom: aStream);
        tag: (self nextShortFrom: aStream);
        yourself!
  
floorHeight
    "Returns the instance var of the receiver
     for external manipulation"
    ^floorHeight!
  
floorHeight: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    floorHeight := anObject!
 
floorName
    "Returns the instance var of the receiver
     for external manipulation"
    ^floorName!
  
floorName: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    floorName := anObject!
 
initializeColorMap
	" Private - Initializes the receiver's colorMap"

	colorMap := self root colorMaps.!
 
lightLevel
    "Returns the instance var of the receiver
     for external manipulation"
    ^lightLevel!

lightLevel: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    lightLevel := anObject!
   
tag
    "Returns the instance var of the receiver
     for external manipulation"
    ^tag!
  
tag: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    tag := anObject!
 
type
    "Returns the instance var of the receiver
     for external manipulation"
    ^type!

type: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    type := anObject! !



!LumpSeg methods !
   
angle
    "Returns the instance var of the receiver
     for external manipulation"
    ^angle!
  
angle: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    angle := anObject!
 
direction
    "Returns the instance var of the receiver
     for external manipulation"
    ^direction!
  
direction: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    direction := anObject!
 
end
    "Returns the instance var of the receiver
     for external manipulation"
    ^end!
  
end: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    end := anObject!
 
fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream."

    self
        start: (self nextShortFrom: aStream);
        end: (self nextShortFrom: aStream);
        angle: (self nextShortFrom: aStream);
        line: (self nextShortFrom: aStream);
        direction: (self nextShortFrom: aStream);
        offset: (self nextShortFrom: aStream);
        yourself!
 
line
    "Returns the instance var of the receiver
     for external manipulation"
    ^line!

line: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    line := anObject!
   
offset
    "Returns the instance var of the receiver
     for external manipulation"
    ^offset!

offset: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    offset := anObject!
   
start
    "Returns the instance var of the receiver
     for external manipulation"
    ^start!
  
start: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    start := anObject! !



!LumpSideDef methods !
 
fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream."

    self
        position: (self nextPointFrom: aStream);
        upperTexture: (self nextString8From: aStream);
        lowerTexture: (self nextString8From: aStream);
        middleTexture: (self nextString8From: aStream);
        sector: (self nextShortFrom: aStream);
        yourself!
  
lowerTexture
    "Returns the instance var of the receiver
     for external manipulation"
    ^lowerTexture!

lowerTexture: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    lowerTexture := anObject!
   
middleTexture
    "Returns the instance var of the receiver
     for external manipulation"
    ^middleTexture!
  
middleTexture: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    middleTexture := anObject!
 
position
    "Returns the instance var of the receiver
     for external manipulation"
    ^position!

position: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    position := anObject!
   
sector
    "Returns the instance var of the receiver
     for external manipulation"
    ^sector!

sector: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    sector := anObject!
   
upperTexture
    "Returns the instance var of the receiver
     for external manipulation"
    ^upperTexture!

upperTexture: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    upperTexture := anObject! !



!LumpSubSector methods !
 
count
    "Returns the instance var of the receiver
     for external manipulation"
    ^count!
  
count: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    count := anObject!
 
fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream."

    self
        count: (self nextShortFrom: aStream);
        startSector: (self nextShortFrom: aStream);
        yourself!
 
startSector
    "Returns the instance var of the receiver
     for external manipulation"
    ^startSector!
  
startSector: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    startSector := anObject! !



!LumpThing methods !
   
angle
    "Returns the instance var of the receiver
     for external manipulation"
    ^angle!
  
angle: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    angle := anObject!
 
fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream."

    self
        position: (self nextPointFrom: aStream);
        angle: (self nextShortFrom: aStream);
        type: (self nextShortFrom: aStream);
        options: (self nextShortFrom: aStream);
        yourself!
 
options
    "Returns the instance var of the receiver
     for external manipulation"
    ^options!
  
options: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    options := anObject!
 
position
    "Returns the instance var of the receiver
     for external manipulation"
    ^position!

position: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    position := anObject!
   
type
    "Returns the instance var of the receiver
     for external manipulation"
    ^type!

type: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    type := anObject! !



!LumpVertex methods !

fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream."

    self position: (self nextPointFrom: aStream)!
   
position
    "Returns the instance var of the receiver
     for external manipulation"
    ^position!

position: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    position := anObject! !



!LumpDemoHeader class methods !
  
from: aStream in: aContainer
    "Returns an instance of the receiver read from aStream and contained in aContainer."

    ^((self allSubclasses
        detect: [:one| one supports: aStream ]
        ifNone: [self])
            in: aContainer)
            fileInFrom: aStream!
 
supports: aStream
    "Returns true if the receiver can handle aStream."

    ^self implementedBySubclass! !



!LumpDemoHeader methods !

episode
    "Returns the instance var of the receiver
     for external manipulation"
    ^episode!
  
episode: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    episode := anObject!
 
fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream."

    self
        getPrologueFrom: aStream;
        getContentsFrom: aStream;
        getEpilogueFrom: aStream;
        yourself!

getContentsFrom: aStream
    " Private - Get the receiver contents from aStream. "

    self
        skill: (self nextByteFrom: aStream);
        episode: (self nextByteFrom: aStream);
        mission: (self nextByteFrom: aStream);
        yourself.!
   
getEpilogueFrom: aStream
    " Private - Get the receiver epilogue from aStream.
    The default action is to get the players.
    This method can be refined by subclasses."

    self players: ((1 to: 4) select: [:index| (self nextByteFrom: aStream) = 1])!
   
getPrologueFrom: aStream
    " Private - Get the receiver prologue from aStream.
    The default action is to do nothing.
    This method can be refined by subclasses."!

mission
    "Returns the instance var of the receiver
     for external manipulation"
    ^mission!
  
mission: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    mission := anObject!
 
players
    "Returns the instance var of the receiver
     for external manipulation"
    ^players!
  
players: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    players := anObject!
 
skill
    "Returns the instance var of the receiver
     for external manipulation"
    ^skill!
  
skill: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    skill := anObject! !



!NewLumpDemoHeader class methods !
 
supports: aStream
    "Returns true if the receiver can handle aStream."

    ^aStream peek asciiValue > 100 "has version number."! !



!NewLumpDemoHeader methods !

fast
    "Returns the instance var of the receiver
     for external manipulation"
    ^fast!

fast: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    fast := anObject!
   
getContentsFrom: aStream
    " Private - Get the receiver contents from aStream. "

    super getContentsFrom: aStream.
    self
        mode: (self nextByteFrom: aStream);
        respawn: (self nextByteFrom: aStream) ~= 0;
        fast: (self nextByteFrom: aStream) ~= 0;
        hasMonsters: (self nextByteFrom: aStream) = 0;
        viewPoint: (self nextByteFrom: aStream);
        yourself.!
  
getPrologueFrom: aStream
    " Private - Get the receiver prologue from aStream."

    super getPrologueFrom: aStream.
    self version: (self nextByteFrom: aStream).!
 
hasMonsters
    "Returns the instance var of the receiver
     for external manipulation"
    ^hasMonsters!
  
hasMonsters: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    hasMonsters := anObject!
 
mode
    "Returns the instance var of the receiver
     for external manipulation"
    ^mode!

mode: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    mode := anObject!
   
respawn
    "Returns the instance var of the receiver
     for external manipulation"
    ^respawn!
  
respawn: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    respawn := anObject!
 
version
    "Returns the instance var of the receiver
     for external manipulation"
    ^version!
  
version: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    version := anObject!
 
viewPoint
    "Returns the instance var of the receiver
     for external manipulation"
    ^viewPoint!
  
viewPoint: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    viewPoint := anObject! !



!TextureEntry methods !

fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream."

    self name: (self nextString8From: aStream).
	(self nextShortFrom: aStream) = 0 ifFalse: [ self error: 'Must be Zero.' ].
	(self nextShortFrom: aStream) = 0 ifFalse: [ self error: 'Must be Zero.' ].
    self
		width: (self nextShortFrom: aStream);
		height: (self nextShortFrom: aStream);
		yourself.
	(self nextShortFrom: aStream) = 0 ifFalse: [ self error: 'Must be Zero.' ].
	(self nextShortFrom: aStream) = 0 ifFalse: [ self error: 'Must be Zero.' ].

    self
		numberOfPatches: (self nextShortFrom: aStream);
		patches: (self nextPatchesFrom: aStream);
		yourself.
!
   
height
    "Returns the instance var of the receiver
     for external manipulation"
    ^height!

height: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    height := anObject!
   
name
    "Returns the instance var of the receiver
     for external manipulation"
    ^name!

name: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    name := anObject!
   
nextPatchesFrom: aStream
    " Private, FileIn - Get the patches collection from aStream."

	| result |
	result := Array new: self numberOfPatches.
	1 to: result size do: [:i|
		result at: i put: (self nextPatchFrom: aStream)
	].
	^result!
 
nextPatchFrom: aStream
    " Private, FileIn - Get the patch from aStream."

	^TexturePatch from: aStream in: self!
  
numberOfPatches
    "Returns the instance var of the receiver
     for external manipulation"
    ^numberOfPatches!
  
numberOfPatches: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    numberOfPatches := anObject!
 
patches
    "Returns the instance var of the receiver
     for external manipulation"
    ^patches!
  
patches: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    patches := anObject!
 
width
    "Returns the instance var of the receiver
     for external manipulation"
    ^width!
  
width: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    width := anObject! !



!TexturePatch methods !

colorMap
    "Returns the instance var of the receiver
     for external manipulation"
    ^colorMap!

colorMap: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    colorMap := anObject!
   
fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream."

    self
		offset: (self nextPointFrom: aStream);
		nameID: (self nextShortFrom: aStream);
		stepDirection: (self nextShortFrom: aStream);
		colorMap: (self nextShortFrom: aStream);
		yourself.!
 
name
    "Returns the wall patch name."

	| names |
	names := self root names.
    ^names size > self nameID ifTrue: [ names at: self nameID + 1 ]!

nameID
    "Returns the instance var of the receiver
     for external manipulation"
    ^nameID!

nameID: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    nameID := anObject!
   
offset
    "Returns the instance var of the receiver
     for external manipulation"
    ^offset!

offset: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    offset := anObject!
   
stepDirection
    "Returns the instance var of the receiver
     for external manipulation"
    ^stepDirection!
  
stepDirection: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    stepDirection := anObject! !



!WadDirectoryEntry methods !
   
lumpFrom: aStream
    " Private, FileIn - Get the lump associated with receiver from aStream.
    Must return a Lump or the receiver (aWadElement).
    By default returns the receiver.
    This method can be refined by subclasses. "

    ^self! !



!LumpInfo methods !
 
basicLumpFrom: aStream
    " Private, FileIn - Get the lump associated with receiver from aStream. "

    ^super lumpFrom: aStream!
  
fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream. "

    self offset: (self nextLongFrom: aStream).
    self sizeInBytes: (self nextLongFrom: aStream).
    self name: (self nextString8From: aStream).
    self isValid ifFalse: [ ^nil ].!
 
isNamed
	"Returns true if the receiver can return it's name."

	^true!
   
isValid
    " Must return true if the receiver is valid. "

    ^self sizeInBytes > 0!
   
lumpClass
    " Private, FileIn - Returns the Lump subclass that supports the receiver. "

    ^Lump allSubclasses
        detect: [:one| one supports: self name ]
        ifNone: [ UnknownLump "self error: self name, ' not implemented. Yet.' " ]!

lumpFrom: aStream
    " Private, FileIn - Get the lump associated with receiver from aStream. "

    aStream position: self offset.
    [ ^(self lumpClass in: self parent)
        fileIn: self from: aStream size: self sizeInBytes
	] on: Error
	do: [
		^(LumpLoadFailure in: self parent)
        fileIn: self from: aStream size: self sizeInBytes
	]!
  
name
    "Returns the instance var of the receiver
     for external manipulation"
    ^name!

name: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    name := anObject!
   
offset
    "Returns the instance var of the receiver
     for external manipulation"
    ^offset!

offset: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    offset := anObject!
   
sizeInBytes
    "Returns the instance var of the receiver
     for external manipulation"
    ^sizeInBytes!
  
sizeInBytes: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    sizeInBytes := anObject! !



!WadMarker methods !
   
isFlatEnd
	"True if the receiver is a flat end marker."

	^self name = 'F_END'!
  
isFlatMarker
	"True if the receiver is a flat marker."

	^self isFlatStart or: [ self isFlatEnd ]!
   
isFlatStart
	"True if the receiver is a flat start marker."

	^self name = 'F_START'!

isMap1Marker
	" Private - True if the receiver is a map marker for DOOM1."

	^self name size = 4
	and: [ self name first = $E
	and: [ (self name at: 3) = $M ]]!
   
isMap2Marker
	" Private - True if the receiver is a map marker for DOOM2."

	^self name size = 5
	and: [ (self name copyFrom: 1 to: 3) = 'MAP' ]!
   
isMapMarker
	"True if the receiver is a map marker."

	^self isMap1Marker
		or: [ self isMap2Marker ]!
  
isMarker
	"True if the receiver is a marker."

	^true!
   
isSpriteEnd
	"True if the receiver is a sprite end marker."

	^self name = 'S_END'!
  
isSpriteMarker
	"True if the receiver is a sprite marker."

	^self isSpriteStart or: [ self isSpriteEnd ]!
   
isSpriteStart
	"True if the receiver is a sprite start marker."

	^self name = 'S_START'!

isValid
    " Must return true if the receiver is valid. "

    ^self sizeInBytes = 0!
   
lumpFrom: aStream
    " Private, FileIn - Get the lump associated with receiver from aStream. "

    ^self basicLumpFrom: aStream!
   
mapLevelID
	"Returns a point with level & map IDs.
	Valid only if the receiver is a map marker."

	| digit |
	digit := [:char| char asciiValue - 48 ].
	^self isMapMarker
	ifTrue: [
		(self isMap1Marker
		ifTrue: [ digit value: (self name at: 2) ]
		ifFalse: [	digit value: (self name at: 3) ])
		@ (digit value: self name last)
	]! !



!WadMapLevel methods !
 
blockMap
    "Returns the instance var of the receiver
     for external manipulation"
    ^blockMap!

blockMap: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    blockMap := anObject!
   
fillFrom: aLumpStream
	" Fill the receiver's contents from aLumpStream. "

	self
		things: aLumpStream next contents asArray;
		lines: aLumpStream next contents asArray;
		sides: aLumpStream next contents asArray;
		vertices: aLumpStream next contents asArray;
		segments: aLumpStream next contents asArray;
		subSectors: aLumpStream next contents asArray;
		nodes: aLumpStream next contents asArray;
		sectors: aLumpStream next contents asArray;
		rejects: aLumpStream next;
		blockMap: aLumpStream next;
		yourself.
	^self!

lines
    "Returns the instance var of the receiver
     for external manipulation"
    ^lines!
  
lines: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    lines := anObject!
 
marker
    "Returns the instance var of the receiver
     for external manipulation"
    ^marker!

marker: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    marker := anObject!
   
name
	"Returns the receiver's name."

	^self marker name!

nodes
    "Returns the instance var of the receiver
     for external manipulation"
    ^nodes!
  
nodes: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    nodes := anObject!
 
rejects
    "Returns the instance var of the receiver
     for external manipulation"
    ^rejects!
  
rejects: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    rejects := anObject!
 
sectors
    "Returns the instance var of the receiver
     for external manipulation"
    ^sectors!
  
sectors: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    sectors := anObject!
 
segments
    "Returns the instance var of the receiver
     for external manipulation"
    ^segments!

segments: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    segments := anObject!
   
sides
    "Returns the instance var of the receiver
     for external manipulation"
    ^sides!
  
sides: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    sides := anObject!
 
subSectors
    "Returns the instance var of the receiver
     for external manipulation"
    ^subSectors!

subSectors: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    subSectors := anObject!
   
things
    "Returns the instance var of the receiver
     for external manipulation"
    ^things!

things: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    things := anObject!
   
vertices
    "Returns the instance var of the receiver
     for external manipulation"
    ^vertices!

vertices: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    vertices := anObject! !



!WadMonster methods !

asActor
	"Create a RenderAXActor from the receiver at a random location."

	self isValid ifFalse: [ ^nil ].
	^DoomActor fromMonster: self!
  
dibFor: aSprite rotated: aBoolean
	"Returns a DIB from aStrite and will be rotated if aBoolean is true."

	| dib |
	dib := aSprite notNil ifTrue: [ aSprite asDIB ].
	dib isNil ifTrue: [ ^nil ].
	aBoolean ifTrue: [ ^self flip: dib ].
	^dib!
  
dibs
	"Returns the receiver's dibs."

	| matrix row rotations aSprite |
	matrix := Array new: self frames size.
	1 to: frames size do: [:x|
		row := self frames at: x.
		row isArray
		ifFalse: [ matrix at: x put: (self dibFor: row rotated: false) ] "only an sprite"
		ifTrue: [ "sprites for rotations"
			rotations := Array new: row size.
			1 to: row size do: [:y|
				aSprite := row at: y.
				rotations at: y
					put: (self
						dibFor: aSprite
						rotated: (self isRotated: x@y))
			].
			matrix at: x put: rotations.
		].
	].
	^matrix!
   
display
	"Display the receiver's dibs (in tile mode) at aPoint with aPen."

	^self displayDIBs!
  
displayDIBs
	"Display the receiver's dibs (in tile mode) at aPoint with aPen."

	^self displayDIBsAt: 0@0 with: Display pen gap: 0@0!

displayDIBsAt: aPoint with: aPen
	"Display the receiver's dibs (in tile mode) at aPoint with aPen."

	^self displayDIBsAt: aPoint with: aPen gap: 0@0!
   
displayDIBsAt: aPoint with: aPen gap: distance
	"Display the receiver's dibs (in tile mode) at aPoint with aPen."

	| matrix offset extent x y |
	distance isPoint ifFalse: [
		^self displayDIBsAt: aPoint with: aPen gap: distance @ distance
	].
	matrix := self dibs.
	offset := aPoint.
	extent := self extentFrom: 1 to: matrix size.
	y := 1.
	matrix do: [:line|
		x := 1.
		line isArray
		ifTrue: [
			line do: [:each|
				each displayAt: offset with: aPen.
				(self isRotated: x@y)
				ifTrue: [ aPen reverse: (offset + distance extent: extent) ].
				offset := offset + (distance x + extent x @ 0).
				x := x + 1.
			].
		]
		ifFalse: [ line displayAt: offset with: aPen ].
		offset := aPoint x @ (offset y + extent y + distance y).
		y := y + 1.
	]!
 
extentFrom: first to: last
	"Returns the maximum extent found in the receiver's sprites."

	| row extent aSprite |
	extent := 0@0.
	first to: last do: [:x|
		row := self frames at: x.
		row isArray
		ifFalse: [ "only an sprite"
		  row notNil ifTrue: [
			extent
				x: (extent x max: row width);
				y: (extent y max: row height);
				yourself
		  ].
		]
		ifTrue: [ "sprites for rotations"
			1 to: row size do: [:y|
				aSprite := row at: y.
				extent
					x: (extent x max: aSprite width);
					y: (extent y max: aSprite height);
					yourself
			].
		].
	].
	^extent!
 
flip: sourceDIB
	" Private - Returns aDIB obtained rotating sourceDIB bits horizontally. "

	| stream width scanLineSize scan index aDIB |
	aDIB := sourceDIB species new.
	aDIB
		bitmapInfo: sourceDIB bitmapInfo copy;
		bits: sourceDIB bits copy;
		yourself.
	width := aDIB width.
	scanLineSize := width * 8 + 31 // 32 * 4.
	stream := ReadStream on: aDIB bits.
	[stream atEnd] whileFalse: [
		index := stream position + 1.
		scan := stream next: width.
		scanLineSize - width timesRepeat: [ stream next ].
		aDIB bits
			replaceFrom: index to: index + scan size - 1
		    with: scan reversed startingAt: 1
	].
	^aDIB!
   
frames
    "Returns the instance var of the receiver
     for external manipulation"

	frames isNil ifTrue: [ self initializeFrames ].
    ^frames!

getFramesFrom: aCollection
	" Private - Gets the frames from aCollection. "

	| stream matrix x y rotated |
	self initializeRotatedFrames.
	numberOfFrames := 1.
	numberOfRotations := 0.
	aCollection do: [:aSprite|
		stream := ReadStream on: aSprite name.
		stream next: self name size.
		[stream atEnd] whileFalse: [
			numberOfFrames := numberOfFrames max: stream next - $A asciiValue + 1.
			numberOfRotations := numberOfRotations max: stream next - $0 asciiValue.
		].
	].
	matrix := Array new: numberOfFrames.
	numberOfRotations > 0 ifTrue: [
		1 to: matrix size do: [:i|
			matrix at: i put: (Array new: numberOfRotations)
		].
	].
	aCollection do: [:aSprite|
		stream := ReadStream on: aSprite name.
		stream next: self name size.
		rotated := false.
		[stream atEnd] whileFalse: [
			x := stream next - $A asciiValue + 1.
			y := stream next - $0 asciiValue.
			y > 0
			ifTrue: [ (matrix at: x) at: y put: aSprite ]
			ifFalse: [ matrix at: x put: aSprite ].
			rotated ifTrue: [ self rotatedFrames add: x @ y ].
			rotated := true.
		].
	].
	^matrix!
  
hasRotations
    "Returns true if the receiver see diferent from some rotations."

    ^self numberOfRotations > 0!
  
initializeFrames
	" Private - Initializes the receiver's frames"

	| sprites |
	sprites := self parent sprites select: [:each|
		each name size > self name size
		and: [ (each name copyFrom: 1 to: self name size) = self name ] ].
	frames := self getFramesFrom: sprites.!
   
initializeRotatedFrames
	" Private - Initializes the receiver's rotatedFrames"

	rotatedFrames := Set new.!
  
isRotated: aPoint
	"Returns true if the dib for slide at aPoint must be rotated from sprite image."

	^self rotatedFrames includes: aPoint!
  
isValid
	"Returns true if the receiver is Valid (has valid sprites)."

	self dibs do: [:tuple|
		tuple isNil ifTrue: [ ^false ].
		tuple isArray ifTrue: [
			tuple do: [:one|
				one isNil ifTrue: [ ^false ].
			]
		].
	].
	^true!
   
name
    "Returns the instance var of the receiver
     for external manipulation"
    ^name!

name: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    name := anObject!
   
numberOfFrames
    "Returns the instance var of the receiver
     for external manipulation"

	numberOfFrames isNil ifTrue: [ self initializeFrames ].
    ^numberOfFrames!

numberOfFrames: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    numberOfFrames := anObject!
   
numberOfRotations
    "Returns the instance var of the receiver
     for external manipulation"

	numberOfRotations isNil ifTrue: [ self initializeFrames ].
    ^numberOfRotations!
   
numberOfRotations: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    numberOfRotations := anObject!
 
rotatedFrames
    "Returns the instance var of the receiver
     for external manipulation"

	rotatedFrames isNil ifTrue: [ self frames "force frame building" ].
    ^rotatedFrames!
  
spriteAt: aPoint
	"Returns the sprite to be used to display character at aPoint."

	| row |
	row := self frames at: aPoint y.
	row isArray ifFalse: [ "only an sprite"
		aPoint x = 1 ifFalse: [ ^nil" self error: 'Invalid index.' " ].
		^row
	].
	^row at: aPoint x!

validTypes
	"Returns the valid ActorTypes catched in the receiver (or nil)."

	^self propertyAt: #validTypes!

validTypes: aCollection
	"Set the valid ActorTypes catched in the receiver."

	^self propertyAt: #validTypes put: aCollection! !



!WadFile class methods !
 
fromDirectory: aDirectory
    "Read an instance selected from user from aDirectory.
    (WadFile fromDirectory: 'c:\OStyle\RenderAX\Resources\wads') inspect 
    "

    | options result dialog |
	aDirectory isString ifTrue: [
		^self fromDirectory: (Directory pathName: aDirectory)
	].
	dialog := (Smalltalk at: #ListDialog) new.
	dialog
		title: 'Select a ',self name;
		returnItems: true;
		textLines: aDirectory fullDirName;
		yourself.
	options := #('..')
		,(aDirectory subdirectories collect: [:each| '>',each last])
		,(aDirectory filesNamed: '*.wad').
	result := dialog openOn: options.
	result isNil ifTrue: [ ^nil ].
	result = '..' ifTrue: [
		^self fromDirectory: (aDirectory fullDirName reversed asStream
			 upTo: $\;upTo: $\;upTo: nil) reversed
	].
	result first = $> ifTrue: [
		^self fromDirectory: aDirectory fullDirName,(result copyFrom: 2 to: result size)
	].
    ^self fromFile: aDirectory fullDirName,result!

fromFile: pathName
    "Read an instance of the receiver for file named pathName.
    (WadFile fromFile: 'c:\Dooms\Doom1.wad') inspect 
    "

    | file result |
    [ file := File pathNameReadOnly: pathName.
     result := self fromStream: file.
    ] ensure: [ file notNil ifTrue: [ file close ] ].
    ^result!
 
fromStream: aStream
    "Read an instance of the receiver from aStream."

    ^self new fileInFrom: aStream!
 
fromUser
    "Read an instance selected from user.
    WadFile fromUser inspect 
    "

    | dialog |
	dialog := FileDialog new.
	dialog
	title: 'Select a WAD file.';
	addFilter: '*.wad' description: 'Doom Wad Files (*.WAD)';
	defFilter: '*.wad';
	open.
	^dialog file notNil ifTrue: [ self fromFile: dialog file ]! !



!WadFile methods !
 
colorMaps
	"Returns the collection of colorMaps."

	^self lumps detect: [:each| each isColorMap ]!
   
colorTables
	"Returns a collection with all pay palettes."

	| container |
	container := self lumps detect: [:each| each isKindOf: PlayPalettes ].
	^container palettes!
   
convertAll
	"Convert all information to RenderAXStructures in current space; if it is posible."

	self
		convertFlats;
		convertMonsters;
		yourself!
 
convertFlats
	"Convert all flats to RenderAXTextures if it is posible."

	^self flats collect: [:each| each texture ]!
   
convertMonster: aMonster
	"Convert monster named aName to a RenderAXActor if it is posible."

	aMonster isString
	 ifTrue: [ ^self convertMonster: (self monsterNamed: aMonster) ].

	^aMonster asActor!
  
convertMonsters
	"Convert all monsters to RenderAXActors if it is posible."

	^self monsters asArray reversed collect: [:each| each asActor ]!
   
defaultColorTable
	"Returns the default colorTable."

	^self colorTables first!
  
directory
    "Returns the instance var of the receiver
     for external manipulation"
    ^directory!
  
directory: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    directory := anObject!
 
fileInFrom: aStream
    " Private, FileIn - Get the receiver from aStream. "

    | numLumps directoryOffset |
    self header: (self getOneOf: #('PWAD' 'IWAD') from: aStream).
    numLumps := self nextLongFrom: aStream.
    directoryOffset := self nextLongFrom: aStream.
    aStream position: directoryOffset.

    directory := Array new: numLumps.
    lumps := Array new: numLumps.

    1 to: numLumps do: [:i|
        directory at: i put: (self getDirectoryFrom: aStream)
    ].

    1 to: numLumps do: [:i|
        self lumps
            at: i
            put: (self
                getLump: (directory at: i)
                from: aStream)
    ].

	self
		initializeFlats;
		initializeTexturePatches;
		initializeSprites;
		yourself!
  
flatFrom: aLump
	" Private - Returns a valid flat lump from aLump. "

	aLump isPicture ifTrue: [ ^aLump ].
	aLump isUnknown ifFalse: [ ^nil ].
	^(LumpFlat in: aLump parent)
		name: aLump name;
		contents: aLump contents;
		yourself!

flatIndexes
	" Private - Returns the lump indices of flats (an Interval or an empty array). "

	| index start aLump |
	index := 1.
	[	self lumps size < index ifTrue: [ ^Array new ].
		aLump := self lumps at: index.
		aLump isMarker and: [ aLump isFlatStart ]
	 ] whileFalse: [ index := index + 1 ].
	index := index + 1.
	start := index + 1.
	[	self lumps size < index ifTrue: [ ^start to: index ].
		aLump := self lumps at: index.
		aLump isMarker and: [ aLump isFlatEnd ]
	 ] whileFalse: [ index := index + 1 ].
	^start to: index - 1!
  
flats
    "Returns the instance var of the receiver
     for external manipulation"

	flats isNil ifTrue: [ self initializeFlats ].
    ^flats!

getDirectoryFrom: aStream
    " Private, FileIn - Get the next directory entry from aStream. "

    | options |
    options := Array
        with: LumpInfo
        with: WadMarker.
    ^self getOneOf: options from: aStream!
  
getLump: aWadDirectoryEntry from: aStream
    " Private, FileIn - Get the lump from aStream using info in lumpInfo. "

    ^aWadDirectoryEntry lumpFrom: aStream!

getMonster: aName
	" Private - Returns the monster named aName. "

	"WARNING:
		we will create a monster here. Save your image...
	 :-) "

	^(WadMonster in: self)
		name: aName;
		yourself!
  
header
    "Returns the instance var of the receiver
     for external manipulation"

    header isNil ifTrue: [ self initializeHeader ].
    ^header!
 
header: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    header := anObject!
   
initializeFlats
	" Private - Initializes the receiver's flats"

	| aLump aFlat |
	flats := OrderedCollection new.
	self flatIndexes do: [:index|
		aLump := self lumps at: index.
		aFlat := self flatFrom: aLump.
		aFlat notNil ifTrue: [
			self lumps at: index put: aFlat.
			flats add: aFlat.
		].
	].
	flats := flats asArray
!
   
initializeHeader
    " Private - Initializes the receiver's header"

    header := 'PWAD'.!
  
initializeMonsters
	" Private - Initializes the receiver's monsters"

	monsters := Set new.
	self monsterNames do: [:each|
		monsters add: (self getMonster: each)
	].!
   
initializeSprites
	" Private - Initializes the receiver's sprites"

	| aLump aSprite |
	sprites := OrderedCollection new.
	self spriteIndexes do: [:index|
		aLump := self lumps at: index.
		aSprite := self spriteFrom: aLump.
		aSprite notNil ifTrue: [
			self lumps at: index put: aSprite.
			sprites add: aSprite.
		].
	].
	sprites := sprites asArray!
   
initializeTexturePatches
	" Private - Initializes the receiver's texture patches."

	| aLump index aLumpTexturePatch |
	self textures do: [:aTexture|
		aTexture patches do: [:aPatch|
			aLump := self lumpNamed: aPatch name.
			(aLump notNil and: [ aLump isUnknown ])
			ifTrue: [
				aLumpTexturePatch :=
					(LumpTexturePatch in: aPatch parent)
						name: aLump name;
						contents: aLump contents;
						yourself.
				index := self lumps indexOf: aLump.
				self lumps at: index put: aLumpTexturePatch
			].
		].
	].!

levels
	"Returns a collection with all the levels defined in the receiver."

	| markers stream |
	markers := self mapMarkers.
	stream := ReadStream on: self lumps.
	^markers collect: [:aMarker|
		stream upTo: aMarker.
		(WadMapLevel in: self)
			marker: aMarker;
			fillFrom: stream
	]!
   
lumpNamed: aName
	"Returns the lump named aName or nil if not found."

	^self lumpNamed: aName ifAbsent: []!
 
lumpNamed: aName ifAbsent: aBlock
	"Returns the lump named aName or the result of evaluating aBlock."

	^self lumps
		detect: [:one| one isNamed and: [ one name = aName ] ]
		ifNone: aBlock!
 
lumpNames
	"Returns a collection with all lumps names."

	| container |
	container := self lumps
		detect: [:each| each isKindOf: LumpNames ]
		ifNone: [ ^Array new ].
	^container contents!

lumps
    "Returns the instance var of the receiver
     for external manipulation"
    ^lumps!
  
lumps: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    lumps := anObject!
 
mapMarkers
	"Returns a collection with all map markers."

	^self lumps select: [:each| each isMarker and: [ each isMapMarker ]]!
 
markers
	"Returns the lump markers."

	^self lumps select: [:each| each isMarker ]!
  
monster: aName
	"Returns the monster named aName."

	^self monsterNamed: aName!
  
monsterNamed: aName
	"Returns the monster named aName or nil if not found."

	^self monsterNamed: aName ifAbsent: []!

monsterNamed: aName ifAbsent: aBlock
	"Returns the monster named aName or the result of evaluating aBlock."

	| upcase |
	upcase := aName asUpperCase. "Normally monster names are in upper case"
	^self monsters
		detect: [:one|
			one isNamed
			and: [ one name = aName
			or: [ one name = upcase ]]
		]
		ifNone: aBlock!
 
monsterNames
	"Returns a collection with the names of the defined monsters."

	| names |
	names := Set new.
	self sprites do: [:each|
		each name size > 4 ifTrue: [
			names add: (each name copyFrom: 1 to: 4)
		].
	].
	^names!

monsters
    "Returns the instance var of the receiver
     for external manipulation"

	monsters isNil ifTrue: [ self initializeMonsters ].
    ^monsters!

monsters: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    monsters := anObject!
   
names
	"Returns a collection with all lumps names."

	^self lumpNames!
   
pictures
	"Returns the collection of pictures."

	^self lumps select: [:each| each isPicture ]!
  
soundEffects
	"Returns a collection with all sound effects."

	^self lumps select: [:each| each isSoundEffect ]!
 
spriteFrom: aLump
	" Private - Returns a valid sprite lump from aLump. "

	aLump isPicture ifTrue: [ ^aLump ].
	aLump isUnknown ifFalse: [ ^nil ].
	^(LumpGraphic in: aLump parent)
		name: aLump name;
		contents: aLump contents;
		yourself!
 
spriteIndexes
	" Private - Returns the lump indices of sprites (an Interval or empty array). "

	| index start aLump |
	index := 1.
	[	self lumps size < index ifTrue: [ ^Array new ].
		aLump := self lumps at: index.
		aLump isMarker and: [ aLump isSpriteStart ]
	 ] whileFalse: [ index := index + 1 ].
	index := index + 1.
	start := index + 1.
	[	self lumps size < index ifTrue: [ ^start to: index ].
		aLump := self lumps at: index.
		aLump isMarker and: [ aLump isSpriteEnd ]
	 ] whileFalse: [ index := index + 1 ].
	^start to: index - 1!
 
sprites
    "Returns the instance var of the receiver
     for external manipulation"

	sprites isNil ifTrue: [ self initializeSprites ].
    ^sprites!

sprites: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    sprites := anObject!
 
textureNamed: aName
	"Returns the texture named aName or nil if not found."

	^self textureNamed: aName ifAbsent: []!

textureNamed: aName ifAbsent: aBlock
	"Returns the texture named aName or the result of evaluating aBlock."

	^self textures
		detect: [:one| one isNamed and: [ one name = aName ] ]
		ifNone: aBlock!

textures
	"Returns a collection with all textures."

	| container |
	container := self lumps
		detect: [:each| each isKindOf: LumpTexture ]
		ifNone: [ ^Array new ].
	^container entries!
   
unknownLumps
	"Returns the collection of all unknown lumps."

	^self lumps select: [:each| each isUnknown ]! !



!RenderAXOCXPane class methods !
   
clsid
    " Private - Returns the control clsid. "

    ^GUID
        clsidFromString: 'RenderAXXControl.RenderAX'
    "old version...  clsidFromString: '{A0B7DC53-C09F-11D0-BB08-00AA0064C217}' "
    "new version... clsidFromString: '{126CD613-201F-11D1-BBAB-00AA0064C217}' " !
 
mask
    " Code Generation - Must return the mask code string. "

    ^'RenderAX'!
   
ocxFileName
    " Private - The receiver can return the file name of the ocx control (*.ocx). "

    ^'RenderAXXControl.ocx'! !



!RenderAXOCXPane methods !

about
    "Open the about box dialog."

    ^self aboutBox!
  
aboutBox
    "Open the about box dialog."

    ^self AboutBox!
   
actorDefs

    "Gets the filename of the ActorDefs file.
    This file contains the data needed to associate Actors with Texture Definitions.
    This file is created in the Edit4DX Map Editor.
    For help on creation and modification of ActorDef's, please consult the Edit4dx help file."

    ^self getActorDefs!
   
actorDefs: pathName

    "Sets the filename of the ActorDefs file.
    This file contains the data needed to associate Actors with Texture Definitions.
    This file is created in the Edit4DX Map Editor.
    For help on creation and modification of ActorDef's, please consult the Edit4dx help file."

    ^self setActorDefs: pathName!
   
addActor: actorID
    actorType: actorType
    at: aPoint
    height: height
    sector: sector

    "Add a new actor in the receiver scene."

    ^self addActor: actorID
        actorType: actorType
        x: aPoint x
        y: aPoint y
        height: height
        sector: sector!
 
addActor: actorID
    actorType: actorType
    x: x y: y
    height: height
    sector: sector

    "This method adds an actor to a sector with specific attributes.
    actorID : The number which can be used to refer to the actor.
    ActorType : The Actor type defined in the ActorDefs file.
    X, Y : The X and Y coordinates to place the actor.
    Height : The height of the actor.
    Sector : The sector to place the actor.
    Example
        RenderDX.AddActor(1,1,300,300,64,1)
            Adds actor # 1 of type 1 to Sector 1 at coordinates (300,300).
    "

    ^self
        AddActor: actorID
        with: actorType asParameter
        with: x
        with: y
        with: height
        with: sector!
   
altShadeTo: red green: green blue: blue distance: distance

    "This defines the alternate shading table.
    Sectors with the 'Alternate Shading' flag are shaded with this table.
    In the viewport, any sectors past the alternate shaded sector are also shaded with this table, regardless of their flags - This makes possible things like pillars of blue fog, etc.
    Please see the ShadeTo method for information on how to call this method.
    "

    ^self
        AltShadeTo: red
        with: green
        with: blue
        with: distance!
 
autoMove

    "This option is used for testing purposes to enable the control to process mouse messages for movement.
    This is not timed, and should only be used during development.
    Default is on.
    For correct movement, use the MoveActor Method."

    ^self getAutoMove!
 
autoMove: aBoolean

    "This option is used for testing purposes to enable the control to process mouse messages for movement.
    This is not timed, and should only be used during development.
    Default is on.
    For correct movement, use the MoveActor Method."

    ^self setAutoMove: aBoolean!
 
bitmapSet

    "The filename of the BitmapSet file.
    This file contains the complete bitmap data data needed for texture building.
    This file is created in the Edit4DX Map Editor.
    For help on creation and modification of a BitmapSet, please consult the Edit4dx help file."

    ^self getBitmapSet!
  
bitmapSet: fileName

    "The filename of the BitmapSet file.
    This file contains the complete bitmap data data needed for texture building.
    This file is created in the Edit4DX Map Editor.
    For help on creation and modification of a BitmapSet, please consult the Edit4dx help file."

    ^self setBitmapSet: fileName!
  
canLoadControl
    " Private, Loading - A problem has occurred during control site contruction."

    (OLERegistryInterface controlClassIDMap includesKey: self clsid)
    ifFalse: [
        self canRegisterControl ifTrue: [ ^self loadControl: false  ].
    ].

    MessageBox
        warning: 'Unable to create the control -
    you may not have this control installed
    or you may have a system configuration problem.

To donwload the control please visit http://www.eldermage.com
The control is contained in the file RenderAXXControl.ocx

	Contact Information:
	web:    http://www.eldermage.com
	Email:  jaimi@eldermage.com

If you have any questions about this control
 and it''s use from the Smalltalk side
 you can send a mail to aleReimondo@sugarWeb.com'.

    ^false!

canRegisterControl
    " Private - Try to register the receiver's control file (.OCX). "

    | pathName dialog mask |
    pathName := self species ocxFileName.
    mask := self species mask.
    pathName isNil ifTrue: [
        dialog := FileDialog new.
        dialog
            title: 'Register "',mask,'" Control from OCX File';
            addFilter: '*.ocx' description: 'OLE Control Files (*.OCX)';
            defFilter: mask,'.ocx';
            open.
        dialog file isNil ifTrue: [ ^false ].
         pathName := dialog file
    ].
    ^OLEControlChoiceDialog registerControlFromOCXFile: pathName!

checkActor: actorID

    "This method must be called for all moving actors,
     so that gravity can work upon them.
    RenderDX1.CheckActor(0); // make sure that actor 0 has gravity."

    ^self CheckActor: actorID!
 
close
    "Private - Close the receiver and destroy the device context."

    self space stopTracking.
    self palette: nil.
    ^super close!

cursor

    " Undocumented - Unknown."

    ^self getCursor!

cursor: anInteger

    " Undocumented - Unknown."

    ^self setCursor: anInteger!
  
dataPitch

    "The width in pixels from edge to edge of the rendering bitmap.
    Note that this is not always the width of the control (Windows DIBs must be 4bits aligned)."

    ^self getDataPitch!
   
dataPitch: anInteger

    "The width in pixels from edge to edge of the rendering bitmap.
    Note that this is not always the width of the control."

    ^self setDataPitch: anInteger!
  
dataPointer

    "The pointer to the rendered image of the map."

    ^self getDataPointer!
 
dataPointer: anInteger

    "The pointer to the rendered image of the map."

    ^self setDataPointer: anInteger!
   
enabled

    " Undocumented - Unknown."

    ^self getEnabled!
  
enabled: aBoolean

    " Undocumented - Unknown."

    ^self setEnabled: aBoolean!
  
findSector: aPoint

    "This method determines in which sector an x,y coordinate fall in.
    Sector := RenderDX.FindSector(300,200);
        //Finds the sector which contains the coordinates (300,200)
    Returns nil if no sector is at this coordinates."

    | result |
    result := self FindSector: aPoint x asFloat with: aPoint y asFloat.
    ^result ~= -1 ifTrue: [ id ]!
 
flatSet

    "The filename of the FlatSet file.
    This file contains the complete bitmap data data needed for rendering floors and ceilings.
    This file is created in the Edit4DX Map Editor.
    For help on creation and modification of a FlatSet, please consult the Edit4dx help file."

    ^self getFlatSet!
 
flatSet: fileName

    "The filename of the FlatSet file.
    This file contains the complete bitmap data data needed for rendering floors and ceilings.
    This file is created in the Edit4DX Map Editor.
    For help on creation and modification of a FlatSet, please consult the Edit4dx help file."

    ^self setFlatSet: fileName!
 
getActor: actorID

    "This method returns a pointer to the actor.
    RenderDX.GetActor(2);  // Returns a pointer to actor 2."

    ^self GetActor: actorID!
 
getBitmapInfo
    "Returns a WinBitmapInfo structure obtained from the receiver.
    Note that while a palette entry is stored as Red-Green-Blue, the RGBquad data is actually stored as Blue-Green-Red.
    "

    | bitmapInfo numColors stream bytes colorTable pitch red green blue |
    numColors := 256.
    bytes := self palettePointer asExternalAddress
        copyFrom: 1 to: numColors * 3.
    stream := ReadStream on: bytes.
    colorTable := WriteStream on: (ByteArray new: numColors * 4).
    [stream atEnd] whileFalse: [
        red := stream next.
        green := stream next.
        blue := stream next.
        colorTable
            nextPut: blue;
            nextPut: green;
            nextPut: red;
            nextPut: 0.
    ].
    pitch := self dataPitch.
    bitmapInfo := WinBitmapInfo
        width: pitch height: self height
        planes: 1 bitCount: 8.
    bitmapInfo
        clrUsed: 256; clrImportant: 256;
        xPelsPerMeter: 100; yPelsPerMeter: 100;
        sizeImage: (((bitmapInfo width * bitmapInfo bitCount) + 31) // 32 * 4) * bitmapInfo height;
        colorTable: colorTable contents;
        yourself.
    ^bitmapInfo!
  
getDataDIB
    "Returns a DIB built from the receiver."

    ^RenderAXDIB new
        bitmapInfo: self getBitmapInfo;
        pointer: self getDataPointer asExternalAddress;
        yourself!
   
getDataPointer
    "This method returns a pointer to the rendered map image.
     This allows post editing of the render window."

    ^self GetDataPointer!

getPalette
    "This method returns a standard Windows h-palette."

    ^self GetPalette!

getPalPointer
    "This method returns a pointer to the 256 color RGB palette.
    MyPalette := RenderDX.GetPalPointer; // MyPalette now points to the RGB palette."

    ^self GetPalPointer!
  
getSector: sectorID

    "This method returns a pointer to a sector.
    RenderDX.GetSector(20);  // Returns a pointer to sector 2."

    ^self GetSector: sectorID!
   
initializeSpace
    " Private - Initializes the receiver's space"

    space := RenderAXSpace in: self.!
 
level

    "The filename of the level file.
    This file contains all the data needed for initializing a level.
    It contains the sectors, linedefs, vertexes and actors instances for one level.
    Setting this property will load the new level, completely replacing the old level.
    This file is created in the Edit4DX Map Editor.
    For help on creation and modification of levels, please consult the Edit4dx help file."

    ^self getLevel!
   
level: fileName

    "The filename of the level file.
    This file contains all the data needed for initializing a level.
    It contains the sectors, linedefs, vertexes and actors instances for one level.
    Setting this property will load the new level, completely replacing the old level.
    This file is created in the Edit4DX Map Editor.
    For help on creation and modification of levels, please consult the Edit4dx help file."

    ^self setLevel: fileName!
   
loadControl
    " Loading - Load OCX and construct the control."

    ^self loadControl: true!
   
loadControl: retry
    " Loading - Load OCX and construct the control."

    | controlSite |
    self clsid: self class clsid.
    controlSite := self siteObject.
    [ CursorManager execute changeFor: [ controlSite constructControl ] ]
    on: OLEError do: [ :ex | ].

	(controlSite isValid not and: [ retry ])
	ifTrue: [
		self canLoadControl ifFalse: [ ^false ]
	].

    self ASSERT: controlSite isValid.
	^true!
  
mapMode

    "Determines how the map is displayed.
    0 - map is not displayed. (default)
    1 - only map is displayed, rendering is disabled.
    2 - Map is displayed over rendering. Neat, but disorienting."

    ^self getMapMode!

mapMode: anInteger

    "Determines how the map is displayed.
    0 - map is not displayed. (default)
    1 - only map is displayed, rendering is disabled.
    2 - Map is displayed over rendering. Neat, but disorienting."

    ^self setMapMode: anInteger!
  
mapZoom

    "This option sets the level of zoom on the map.
    Range is 0 - 8.
    The smaller the number, the larger the map is displayed."

    ^self getMapZoom!
 
mapZoom: anInteger

    "This option sets the level of zoom on the map.
    Range is 0 - 8.
    The smaller the number, the larger the map is displayed."

    ^self setMapZoom: anInteger \\ 9!
  
moveActor: actorID distance: distance

    "Moves an actor forward, in the direction they are pointing.
    RenderDX.MoveActor(0,12.5); // moves actor 0 by 12.5 units."

    ^self MoveActor: actorID with: distance!
 
palette
    "This method returns a standard Windows h-palette."

    | palette |
    palette := super palette.
    palette isNil ifTrue: [
        self palette: (ExternalHandle fromInteger: self getPalette).
        ^super palette
    ].
    ^palette!

paletteColors
    "Returns a collection with all the colors in the current palette."

    | result numColors stream bytes |
    numColors := 256.
    bytes := self palettePointer asExternalAddress
        copyFrom: 1 to: numColors * 3.
    stream := ReadStream on: bytes.
    result := OrderedCollection new.
    [stream atEnd] whileFalse: [
        result add:
            (Color
                red: stream next
                green: stream next
                blue: stream next)
    ].
    ^result asArray!
 
paletteFile

    "The filename of a palette file.
    This is the data that TRenderDX will use to color your display, and shade textures.
    It is a straight dump of 768 byte values, arranged R,G,B,R,G,B,R,G,B etc. starting from color0 to color 255."

    ^self getPaletteFile!

paletteFile: fileName

    "The filename of a palette file.
    This is the data that TRenderDX will use to color your display, and shade textures.
    It is a straight dump of 768 byte values, arranged R,G,B,R,G,B,R,G,B etc. starting from color0 to color 255."

    ^self setPaletteFile: fileName!

palettePointer

    "This property contains the pointer to the 256 color RGB palette currently being used."

    ^self getPalPointer!
   
palettePointer: anInteger

    "This property contains the pointer to the 256 color RGB palette currently being used."

    ^self setPalPointer: anInteger!
 
pointOfViewActor: actorID

    "Sets the Point of View Actor.
    All subsequent renderings come from this actors POV.
    Typical use is controlling multiple actors, views from cameras, etc.
    RenderDX.PovActor(0);
    // Sets the pov to be generated from Actor 0 - the default actor."

    ^self PovActor: actorID!
  
positionActor: actorID
    at: aPoint
    height: height
    angle: angle

    "Postions actor at coordinates passed. Typical uses are for teleporting etc."

    ^self PositionActor: actorID with: aPoint x with: aPoint y with: height with: angle!
   
positionActor: actorID
    x: x y: y z: z
    angle: angle

    "Postions actor at coordinates passed. Typical uses are for teleporting etc.
    RenderDX1.PositionActor(0,100,200,300,512);
    // This positions actor 0 at x:100, y:200, height = 300. Angle = 512."

    ^self PositionActor: actorID with: x with: y with: z with: angle!
  
povActor: actorID

    "Sets the Point of View Actor.
    All subsequent renderings come from this actors POV.
    Typical use is controlling multiple actors, views from cameras, etc.
    RenderDX.PovActor(0);
    // Sets the pov to be generated from Actor 0 - the default actor."

    ^self PovActor: actorID!
  
raiseSectorCeiling: sectorID height: height speed: speed

    "This method changes the height of the ceiling in a sector.
    RaiseSectorCeiling( Sector, Height, Speed : Integer);
        Sector : The sector which will be changed.
        Height : The new height to move the ceiling to.
        Speed : The speed at which the ceiling level changes.
    RenderDX.RaiseSectorCeiling(1,500,3)
    //Changes the ceiling height in sector 1 to 500 at a speed of 3."

    ^self RaiseSectorCeiling: sectorID with: height with: speed!
 
raiseSectorFloor: sectorID height: height speed: speed

    "This method changes the height of the floor in a sector.
    RaiseSectorFloor( Sector, Height, Speed : Integer);
        Sector : The sector which will be changed.
        Height : The new height to move the floor to.
        Speed : The speed at which the floor level changes.
    RenderDX.RaiseSectorFloor(1,300,3)
    //Changes the floor height in sector 1 to 300 at a speed of 3."

    ^self RaiseSectorFloor: sectorID with: height with: speed!
 
realizePalette
    " Selects & Realize the receiver's palette.
    Returns the handle to the selected palette or nil if failed"

    | palette hDC changed hPalT |
    hDC := self getDC.
    palette := self palette.
    palette notNil ifTrue: [
        (hPalT := GDILibrary selectPalette: hDC
            with: palette asParameter
            forceBackground: false) = 0
                ifTrue: [ ^self "osError" ].
        (changed := GDILibrary realizePalette: hDC) = 16rFFFFFFFF
            ifTrue: [ ^self osError ].
        (GDILibrary selectPalette: hDC
            with: hPalT asParameter
            forceBackground: false) = 0
                ifTrue: [ ^self osError ].
    ].
   self releaseDC: hDC.
    ^changed "Returns the number of entries that changed..."!
  
render

    "Renders the view into the bitmap buffer."

    ^self
        render: self mapMode
        shear: self shear!
 
render: mode shear: shear

    "Renders the view into the bitmap buffer.
    To display it, you must repaint the control:
    RenderDX1.render(0,0); // set these to 0 for now
    RenderDX1.repaint;"

    ^self Render: mode with: shear!
  
renderEvents
    "Answer the names of the events that can be triggered by the receiver's control.
    The events specification is
    Events:

    OnActorCross
        DISPID: 3
        Event name: #OnActorCross:with:
        Arguments:
            MovActor: VT_I4
            CrossedActor: VT_I4
        Return type: VT_VOID

    OnLineCross
        DISPID: 1
        Event name: #OnLineCross:with:with:
        Arguments:
            Actor: VT_I4
            line: VT_I4
            sector: VT_I4
        Return type: VT_VOID

    OnSectorEntry
        DISPID: 2
        Event name: #OnSectorEntry:with:
        Arguments:
            Actorno: VT_I4
            SectorNo: VT_I4
        Return type: VT_VOID

    ( 3 events )
    "

    ^self siteObject controlEvents!
  
renderPalette

    "This is the handle of the 256 color palette used by the 4DX bitmap.
    When you are running in 256 color mode (the recommended mode).
    You must use this to set your forms default palette, or windows cannot display the rendered bitmap correctly.

In the public section of your form, you must override the GetPalette Function and replace it with yours:
 {in your form declaration}
 public
    function  GetPalette : HPalette; override;

 {your form declaration continues }

{ you must supply this function for 256 color
  graphics mode to work correctly}
function  TForm1.GetPalette : HPalette;
begin
  result := HPalette(RenderDX1.Palette);
end;

in the OnShow section of your form, do the following:

procedure TTextureEdit.FormShow(Sender: TObject);
begin
     SelectPalette(canvas.handle,HPalette(RenderDX1.Palette),false);
     RealizePalette(canvas.handle);
end;"

    ^self getPalette!
  
renderPalette: anInteger

    "This is the handle of the 256 color palette used by the 4DX bitmap.
    When you are running in 256 color mode (the recommended mode).
    You must use this to set your forms default palette, or windows cannot display the rendered bitmap correctly.

In the public section of your form, you must override the GetPalette Function and replace it with yours:
 {in your form declaration}
 public
    function  GetPalette : HPalette; override;

 {your form declaration continues }

{ you must supply this function for 256 color
  graphics mode to work correctly}
function  TForm1.GetPalette : HPalette;
begin
  result := HPalette(RenderDX1.Palette);
end;

in the OnShow section of your form, do the following:

procedure TTextureEdit.FormShow(Sender: TObject);
begin
     SelectPalette(canvas.handle,HPalette(RenderDX1.Palette),false);
     RealizePalette(canvas.handle);
end;"

    ^self setPalette: anInteger!

renderVisible

    "This property determines whether the control is visible."

    ^self getVisible!

renderVisible: aBoolean

    "This property determines whether the control is visible."

    ^self setVisible: aBoolean!

savePalette: fileName

    " Undocumented - Save the current 256 colors palette"

    ^self SavePalette: fileName!
  
saveTextBM: bmID fileName: fileName

    " Undocumented - Unknown"

    ^self SaveTextBM: bmID with: fileName!
  
saveTextMap: fileName

    " Undocumented - Unknown"

    ^self SaveTextMap: fileName!
  
saveTextPal: fileName

    " Undocumented - Unknown"

    ^self SaveTextPal: fileName!
  
shadeTo: red green: green blue: blue distance: distance

    "Rebuilds the standard shading table.
    Pass the R,G,B of the destination color, and the distance (in units) to the fadeout point.
    The standard palette is best fit for shading to black, though any color can actually be shaded to,
     and the engine will compensate with best fit colors.
    RenderDX1.ShadeTo(0,0,0,512);   // shades to black, things past 512 distance are dark. Shading to 512 is very dark.
    RenderDX1.ShadeTo(0,0,0,2000);  // shades to black, (r,g,b = 0); An average shading value.
    RenderDX1.ShadeTo(0,0,0,4000);  // shades to black, (r,g,b = 0); A light area. Doesn't get dark too quickly.
    RenderDX1.ShadeTo(192,192,192,1024); // this shades to a light gray, like a fog.
    RenderDX1.ShadeTo(128, 0 , 0, 1024); // this shades to a blood red color."

    ^self
        ShadeTo: red
        with: green
        with: blue
        with: distance!
   
shear

    "Skews the view up or down by the shear value.
    Setting this to a negative value will cause the next rendering to point down toward the floor.
    A Positive value will cause it to point up, looking toward the ceiling."

    ^self getshear!

shear: anInteger

    "Skews the view up or down by the shear value.
    Setting this to a negative value will cause the next rendering to point down toward the floor.
    A Positive value will cause it to point up, looking toward the ceiling."

    ^self setshear: anInteger!
  
space
    "Returns the instance var of the receiver
     for external manipulation"

    space isNil ifTrue: [ self initializeSpace ].
    ^space!
 
spinActor: actorID angle: angle

    "Spins an actor by n degrees.
    In 4DX terms, there are 1024 internal degrees in a circle.
    RenderDX1.SpinActor(0,512); // turns actor 0 completely around."

    ^self SpinActor: actorID with: angle!
 
textureSet

    "The filename of the TextureSet file.
    This file contains the definitions of textures and patches that are used to render walls and sprites.
    This file is created in the Edit4DX Map Editor.
    For help on creation and modification of levels, please consult the Edit4dx help file."

    ^self getTextureSet!

textureSet: aString

    "The filename of the TextureSet file.
    This file contains the definitions of textures and patches that are used to render walls and sprites.
    This file is created in the Edit4DX Map Editor.
    For help on creation and modification of levels, please consult the Edit4dx help file."

    ^self setTextureSet: aString!
  
wmChar: wordInteger with: longInteger
        "Private - Process the character input message."

	MessageBox message: (Array with: (Character value: wordInteger) with: longInteger) printString
		,'\'withCrs,self class name,'>>wmChar:with:'.
	^super wmChar: wordInteger with: longInteger! !



!RenderAXPane class methods !
  
constructEventsTriggered
        "Private - answer the set of events that instances of the
        receiver can trigger."
    ^super constructEventsTriggered
        add: #OnActorCross:with: ;
        add: #OnLineCross:with:with: ;
        add: #OnSectorEntry:with: ;
        yourself! !



!RenderAXPane methods !
   
about
    "Open the about box dialog."

    ^self aboutBox!
  
aboutBox
    "Open the about box dialog."

	MessageBox message: self class name
		,'\@1998 Alejandro F. Reimondo\aleReimondo@sugarWeb.com'withCrs!
  
actorDefs

    "Gets the filename of the ActorDefs file.
    This file contains the data needed to associate Actors with Texture Definitions.
    This file is created in the Edit4DX Map Editor.
    For help on creation and modification of ActorDef's, please consult the Edit4dx help file."

    ^actorDefs!
   
actorDefs: pathName

    "Sets the filename of the ActorDefs file.
    This file contains the data needed to associate Actors with Texture Definitions.
    This file is created in the Edit4DX Map Editor.
    For help on creation and modification of ActorDef's, please consult the Edit4dx help file."

    (self isValid and: [actorDefs ~= pathName]) ifTrue: [
		self space loadActorDefs: pathName asParameter notImplementedYet.
		actorDefs := pathName
	]!

addActor: actorID
    actorType: actorType
    at: aPoint
    height: height
    sector: sector

    "Add a new actor in the receiver scene."

    ^self dll
		addActor: actorID asParameter
        type: actorType asParameter
        x: aPoint x
        y: aPoint y
        height: height asParameter
        sector: sector asParameter!
   
altShadeTo: red green: green blue: blue distance: distance

    "This defines the alternate shading table.
    Sectors with the 'Alternate Shading' flag are shaded with this table.
    In the viewport, any sectors past the alternate shaded sector are also shaded with this table, regardless of their flags - This makes possible things like pillars of blue fog, etc.
    Please see the ShadeTo method for information on how to call this method.
    "

    ^self dll
		alternateShade: red asParameter
		green: green asParameter
		blue: blue asParameter
		distance: distance asParameter!

bitmapSet

    "The filename of the BitmapSet file.
    This file contains the complete bitmap data data needed for texture building.
    This file is created in the Edit4DX Map Editor.
    For help on creation and modification of a BitmapSet, please consult the Edit4dx help file."

    ^bitmapSet!
  
bitmapSet: fileName

    "The filename of the BitmapSet file.
    This file contains the complete bitmap data data needed for texture building.
    This file is created in the Edit4DX Map Editor.
    For help on creation and modification of a BitmapSet, please consult the Edit4dx help file."

    (self isValid and: [bitmapSet ~= fileName]) ifTrue: [
		self dll loadBitmapSet: fileName asParameter.
    	bitmapSet := fileName
	].!
   
checkActor: actorID

    "This method must be called for all moving actors,
     so that gravity can work upon them.
    RenderDX1.CheckActor(0); // make sure that actor 0 has gravity."

    ^self dll checkActor: actorID!
 
close
    "Private - Close the receiver and destroy the device context."

    self space stopTracking.
    self palette: nil.
    ^super close!

colorData
    "Returns the instance var of the receiver
     for external manipulation"

	colorData isNil ifTrue: [ self initializeColorData ].
    ^colorData!

dataPitch

    "The width in pixels from edge to edge of the rendering bitmap.
    Note that this is not always the width of the control (Windows DIBs must be 4bits aligned)."

    ^dibPitch!

dataPointer

    "The pointer to the rendered image of the map."

    ^databits!

displayRenderResults
	"Private - Display the render DIB."

	^self!
   
displayWindow
	"Private - Let the owner process the display event or draw all the retained segments."

	self displayRenderResults.
	^super displayWindow
    !
 
dll
	"Returns the interface dll."

	^self space dll!
 
findSector: aPoint

    "This method determines in which sector an x,y coordinate fall in.
    Sector := RenderDX.FindSector(300,200);
        //Finds the sector which contains the coordinates (300,200)
    Returns nil if no sector is at this coordinates."

    | result |
    result := self dll findSector: aPoint x asFloat with: aPoint y asFloat.
    ^result ~= -1 ifTrue: [ id ]!
 
flatSet

    "The filename of the FlatSet file.
    This file contains the complete bitmap data data needed for rendering floors and ceilings.
    This file is created in the Edit4DX Map Editor.
    For help on creation and modification of a FlatSet, please consult the Edit4dx help file."

    ^flatSet!
 
flatSet: fileName

    "The filename of the FlatSet file.
    This file contains the complete bitmap data data needed for rendering floors and ceilings.
    This file is created in the Edit4DX Map Editor.
    For help on creation and modification of a FlatSet, please consult the Edit4dx help file."

    (self isValid and: [flatSet ~= fileName]) ifTrue: [
		self dll loadFlatSet: fileName asParameter.
		flatSet := fileName
	].!
 
getActor: actorID

    "This method returns a pointer to the actor.
    RenderDX.GetActor(2);  // Returns a pointer to actor 2."

    ^self dll getActor: actorID asParameter!
 
getBitmapInfo
    "Returns a WinBitmapInfo structure obtained from the receiver.
    Note that while a palette entry is stored as Red-Green-Blue, the RGBquad data is actually stored as Blue-Green-Red.
    "

    | bitmapInfo numColors stream bytes colorTable pitch red green blue |
    numColors := 256.
    bytes := self palettePointer asExternalAddress
        copyFrom: 1 to: numColors * 3.
    stream := ReadStream on: bytes.
    colorTable := WriteStream on: (ByteArray new: numColors * 4).
    [stream atEnd] whileFalse: [
        red := stream next.
        green := stream next.
        blue := stream next.
        colorTable
            nextPut: blue;
            nextPut: green;
            nextPut: red;
            nextPut: 0.
    ].
    pitch := self dataPitch.
    bitmapInfo := WinBitmapInfo
        width: pitch height: self height
        planes: 1 bitCount: 8.
    bitmapInfo
        clrUsed: 256; clrImportant: 256;
        xPelsPerMeter: 100; yPelsPerMeter: 100;
        sizeImage: (((bitmapInfo width * bitmapInfo bitCount) + 31) // 32 * 4) * bitmapInfo height;
        colorTable: colorTable contents;
        yourself.
    ^bitmapInfo!
  
getDataDIB
    "Returns a DIB built from the receiver."

    ^RenderAXDIB new
        bitmapInfo: self getBitmapInfo;
        pointer: self getDataPointer asExternalAddress;
        yourself!
   
getDataPointer
    "This method returns a pointer to the rendered map image.
     This allows post editing of the render window."

    ^databits!
   
getSector: sectorID

    "This method returns a pointer to a sector.
    RenderDX.GetSector(20);  // Returns a pointer to sector 2."

    ^self dll getSector: sectorID asParameter!
   
initializeColorData
	" Private - Initializes the receiver's colorData"

	| defPal |
	defPal := #(
0 0 0 128 0 0 0 128 0 128 128 0 0 0 128 128 0 128 0 128 128 192 192 192 
192 220 192 166 202 240 87 255 87 87 255 255 255 87 87 255 87 255
255 255 87 255 255 255 239 239 239 223 223 223 211 211 211 195 195 195
179 179 179 167 167 167 151 151 151 139 139 139 123 123 123 111 111 111
95 95 95 83 83 83 67 67 67 55 55 55 39 39 39 27 27 27 211 63 0 
199 55 0 187 47 0 175 39 0 163 35 0 155 27 0 143 23 0 131 19 0 
119 15 0 107 11 0 99 7 0 87 7 0 75 0 0 63 0 0 51 0 0 43 0 0 
223 187 167 211 175 155 199 163 147 187 155 139 175 143 127 163 135 
119 151 123 111 143 115 103 131 103 91 119 95 83 107 83 75 95 75 67 
83 67 59 71 55 51 59 47 43 51 39 35 0 59 167 0 55 159 0 51 151 0 47 143 
0 43 135 0 43 127 0 39 119 0 35 111 0 31 103 0 31 95 0 27 87 0 23 79 0 23 
71 0 19 63 0 15 59 0 15 51 131 195 0 123 183 0 115 175 0 107 163 0 99 151 
0 95 143 0 87 131 0 79 123 0 71 111 0 67 103 0 59 91 0 51 83 0 47 71 0 39 
63 0 31 51 0 27 43 0 0 231 231 0 207 207 0 183 183 0 159 159 0 135 135 0 
111 111 0 87 87 0 67 67 0 159 0 0 143 0 0 131 0 0 119 0 0 103 0 0 91 0 0 79 
0 0 67 0 223 0 227 199 0 203 179 0 179 155 0 155 135 0 135 111 0 111 87 0 
87 67 0 67 223 199 0 195 175 0 171 151 0 143 131 0 119 107 0 91 83 0 67 59 
0 43 39 0 95 191 255 71 167 231 55 147 211 39 127 187 23 107 167 15 91 143 
7 75 123 0 59 103 223 139 0 195 119 0 171 103 0 147 87 0 123 71 0 99 55 0 
75 39 0 51 27 0 163 103 63 147 95 55 131 91 51 115 83 43 103 75 39 87 67 
35 71 55 27 59 47 23 0 0 147 0 0 135 0 0 123 0 0 111 0 0 99 0 0 87 0 0 75 0 
0 67 235 171 139 211 151 123 187 131 107 163 111 91 143 95 79 119 79 63 
95 63 51 75 47 39 155 0 231 131 0 207 119 0 183 99 0 159 83 0 135 71 0 115 
55 0 91 43 0 67 179 219 183 159 195 163 139 171 143 123 151 123 103 127 
107 87 107 87 67 83 67 51 63 51 227 0 231 203 0 207 183 0 183 159 0 159 
135 0 135 111 0 115 91 0 91 67 0 67 215 231 219 203 215 203 191 203 191 
179 191 179 167 179 167 151 167 155 139 151 143 127 139 131 115 127 
119 103 115 107 91 103 95 79 87 79 67 75 67 59 63 59 47 51 47 35 39 35 
235 183 175 219 171 163 207 159 155 195 151 147 179 139 135 167 131 
127 155 119 115 139 107 107 127 99 95 115 87 87 99 79 75 87 67 67 75 
55 55 59 47 47 47 35 35 35 27 27 247 111 23 243 107 19 243 99 19 239 
99 19 239 95 19 235 87 19 235 83 15 231 79 15 231 75 15 227 71 15 227 
67 11 223 63 11 223 59 11 219 55 11 219 51 7 215 51 7 0 0 0 0 0 0 0 0 0 
0 0 0 0 0 0 0 0 0 255 251 240 160 160 164 128 128 128 255 0 0 0 255 0 
255 255 0 0 0 255 255 0 255 0 255 255 255 255 255
	).
	colorData := ByteArray new: defPal size.
	1 to: defPal size do: [:i|
		colorData at: i put: (defPal at: i)
	].!

initializeSpace
    " Private - Initializes the receiver's space"

    space := RenderAXSpace in: self.!
 
level: fileName

    "The filename of the level file.
    This file contains all the data needed for initializing a level.
    It contains the sectors, linedefs, vertexes and actors instances for one level.
    Setting this property will load the new level, completely replacing the old level.
    This file is created in the Edit4DX Map Editor.
    For help on creation and modification of levels, please consult the Edit4dx help file."

    ^self dll loadLevel: fileName!
  
mapMode

    "Determines how the map is displayed.
    0 - map is not displayed. (default)
    1 - only map is displayed, rendering is disabled.
    2 - Map is displayed over rendering. Neat, but disorienting."

	mapMode isNil ifTrue: [ mapMode := 0 ].
    ^mapMode!
  
mapMode: anInteger

    "Determines how the map is displayed.
    0 - map is not displayed. (default)
    1 - only map is displayed, rendering is disabled.
    2 - Map is displayed over rendering. Neat, but disorienting."

    ^mapMode := anInteger!

mapZoom

    "This option sets the level of zoom on the map.
    Range is 0 - 8.
    The smaller the number, the larger the map is displayed."

	mapZoom isNil ifTrue: [ mapZoom := 4  ].
    ^mapZoom!
  
mapZoom: anInteger

    "This option sets the level of zoom on the map.
    Range is 0 - 8.
    The smaller the number, the larger the map is displayed."

    mapZoom := anInteger \\ 9.
	self dll mapZoomLevel: mapZoom.!
  
moveActor: actorID distance: distance

    "Moves an actor forward, in the direction they are pointing.
    RenderDX.MoveActor(0,12.5); // moves actor 0 by 12.5 units."

    ^self dll moveActor: actorID asParameter step: distance asParameter!
 
palettePointer

    "This property contains the pointer to the 256 color RGB palette currently being used."

    ^self colorData!
   
pointOfViewActor: actorID

    "Sets the Point of View Actor.
    All subsequent renderings come from this actors POV.
    Typical use is controlling multiple actors, views from cameras, etc.
    RenderDX.PovActor(0);
    // Sets the pov to be generated from Actor 0 - the default actor."

    ^self dll povActor: actorID asParameter!
  
positionActor: actorID
    at: aPoint
    height: height
    angle: angle

    "Postions actor at coordinates passed. Typical uses are for teleporting etc."

    ^self dll
		positionActor: actorID asParameter
		x: aPoint x y: aPoint y
		z: height asParameter
		angle: angle asParameter!
   
positionActor: actorID
    x: x y: y z: z
    angle: angle

    "Postions actor at coordinates passed. Typical uses are for teleporting etc.
    RenderDX1.PositionActor(0,100,200,300,512);
    // This positions actor 0 at x:100, y:200, height = 300. Angle = 512."

    ^self dll
		positionActor: actorID asParameter
		x: x y: y z: z
		angle: angle asParameter!
 
povActor: actorID

    "Sets the Point of View Actor.
    All subsequent renderings come from this actors POV.
    Typical use is controlling multiple actors, views from cameras, etc.
    RenderDX.PovActor(0);
    // Sets the pov to be generated from Actor 0 - the default actor."

    ^self dll povActor: actorID asParameter!
  
raiseSectorCeiling: sectorID height: height speed: speed

    "This method changes the height of the ceiling in a sector.
    RaiseSectorCeiling( Sector, Height, Speed : Integer);
        Sector : The sector which will be changed.
        Height : The new height to move the ceiling to.
        Speed : The speed at which the ceiling level changes.
    RenderDX.RaiseSectorCeiling(1,500,3)
    //Changes the ceiling height in sector 1 to 500 at a speed of 3."

    ^self dll
		raiseSectorCeiling: sectorID asParameter
		height: height asParameter
		speed: speed asParameter!
 
raiseSectorFloor: sectorID height: height speed: speed

    "This method changes the height of the floor in a sector.
    RaiseSectorFloor( Sector, Height, Speed : Integer);
        Sector : The sector which will be changed.
        Height : The new height to move the floor to.
        Speed : The speed at which the floor level changes.
    RenderDX.RaiseSectorFloor(1,300,3)
    //Changes the floor height in sector 1 to 300 at a speed of 3."

    ^self dll
		raiseSectorFloor: sectorID asParameter
		height: height asParameter
		speed: speed asParameter!
 
realizePalette
    " Selects & Realize the receiver's palette.
    Returns the handle to the selected palette or nil if failed"

    | palette hDC changed hPalT |
    hDC := self getDC.
    palette := self palette.
    palette notNil ifTrue: [
        (hPalT := GDILibrary selectPalette: hDC
            with: palette asParameter
            forceBackground: false) = 0
                ifTrue: [ ^self "osError" ].
        (changed := GDILibrary realizePalette: hDC) = 16rFFFFFFFF
            ifTrue: [ ^self osError ].
        (GDILibrary selectPalette: hDC
            with: hPalT asParameter
            forceBackground: false) = 0
                ifTrue: [ ^self osError ].
    ].
   self releaseDC: hDC.
    ^changed "Returns the number of entries that changed..."!
  
render

    "Renders the view into the bitmap buffer."

    ^self
        render: self mapMode
        shear: self shear!
 
render: mode shear: aShear

    "Renders the view into the bitmap buffer.
    To display it, you must repaint the control:
    RenderDX1.render(0,0); // set these to 0 for now
    RenderDX1.repaint;"

    ^self dll render: mode shear: aShear!
   
shadeTo: red green: green blue: blue distance: distance

    "Rebuilds the standard shading table.
    Pass the R,G,B of the destination color, and the distance (in units) to the fadeout point.
    The standard palette is best fit for shading to black, though any color can actually be shaded to,
     and the engine will compensate with best fit colors.
    RenderDX1.ShadeTo(0,0,0,512);   // shades to black, things past 512 distance are dark. Shading to 512 is very dark.
    RenderDX1.ShadeTo(0,0,0,2000);  // shades to black, (r,g,b = 0); An average shading value.
    RenderDX1.ShadeTo(0,0,0,4000);  // shades to black, (r,g,b = 0); A light area. Doesn't get dark too quickly.
    RenderDX1.ShadeTo(192,192,192,1024); // this shades to a light gray, like a fog.
    RenderDX1.ShadeTo(128, 0 , 0, 1024); // this shades to a blood red color."

    ^self dll
		shade: red asParameter
		green: green asParameter
		blue: blue asParameter
		distance: distance asParameter!

shear

    "Skews the view up or down by the shear value.
    Setting this to a negative value will cause the next rendering to point down toward the floor.
    A Positive value will cause it to point up, looking toward the ceiling."

	shear isNil ifTrue: [ shear := 0 ].
    ^shear!
  
shear: anInteger

    "Skews the view up or down by the shear value.
    Setting this to a negative value will cause the next rendering to point down toward the floor.
    A Positive value will cause it to point up, looking toward the ceiling."

    ^shear := anInteger!

space
    "Returns the instance var of the receiver
     for external manipulation"

    space isNil ifTrue: [ self initializeSpace ].
    ^space!
 
spinActor: actorID angle: angle

    "Spins an actor by n degrees.
    In 4DX terms, there are 1024 internal degrees in a circle.
    RenderDX1.SpinActor(0,512); // turns actor 0 completely around."

    ^self dll
		spinActor: actorID asParameter
		step: angle asParameter!
   
textureSet

    "The filename of the TextureSet file.
    This file contains the definitions of textures and patches that are used to render walls and sprites.
    This file is created in the Edit4DX Map Editor.
    For help on creation and modification of levels, please consult the Edit4dx help file."

    ^textureSet!

textureSet: fileName

    "The filename of the TextureSet file.
    This file contains the definitions of textures and patches that are used to render walls and sprites.
    This file is created in the Edit4DX Map Editor.
    For help on creation and modification of levels, please consult the Edit4dx help file."

    (self isValid and: [textureSet ~= fileName]) ifTrue: [
	    self dll loadTextureSet: fileName asParameter.
		textureSet := fileName
	].! !



!RenderAXTest class methods !

controlFramingBlock
    " Private - Returns the framming block for the control pane. "

    | factor |
    factor := 640 / 480.
    ^[:box|
        box
    ]!
   
createViewFor: aCoordinator
        "Create and configure a window for <aCoordinator>."

    | aWindow |

    aWindow := super createViewFor: aCoordinator.
    aWindow
        backColor: Color buttonFace;
        owner: aCoordinator;
        "
        removeSizingBorderStyle;
        removeMaximizeButtonStyle;
        "
        yourself.

    aWindow
        when: #opened
            send: #opened: to: aCoordinator with: aWindow;
        when: #aboutToClose
            send: #aboutToClose: to: aCoordinator with: aWindow;
        when: #closed
            send: #closed: to: aCoordinator with: aWindow;
        yourself.

    ^aWindow!

windowPolicyClass
        "Answer the class of window policy for the receiver."

    ^StandardWindowPolicy "NoMenusWindowPolicy"!

windowTitle
    " Private - answer the window title. "

    ^ 'RenderAX Test - Drag to walk, Shift to run - @Ale''97'! !



!RenderAXTest methods !
  
about
    " Private - Open the about box. "

    ^self pane about!
   
aboutToClose: aWindow
        " Private - the window is about to close. "

   !
  
accept
    " Private - The wants to save the current space. "

    | pathName dialog |
    pathName := self space directory fullDirName,
        (File fileName: self space name extension: '4St').
    dialog := FileDialog new.
    dialog
        addFilter: '*.4st' description: 'RenderAX Files (*.4ST)';
        saveTitle: 'Save Smalltalk Space As...'
        fileName: pathName.
    pathName := dialog file.
    pathName notNil ifTrue: [
        CursorManager execute changeFor: [
            RenderAXMap
                saveAs: pathName
                withResources: (MessageBox confirm: 'Save with resources (bitmaps, flats...) ?').
        ].
    ].

    pathName := self space directory fullDirName,
        (File fileName: self space name extension: '4dx').
    dialog := FileDialog new.
    dialog
        addFilter: '*.4dx' description: 'RenderAX Files (*.4DX)';
        saveTitle: 'Save Level As...'
        fileName: pathName.
    pathName := dialog file.
    pathName isNil ifTrue: [ ^nil ]. "user cancelled"
    
    CursorManager execute changeFor: [
        self space saveLevelAs: pathName.
    ].!
   
activateSpaceNotification
    " Private - Activate full space notifications. "

    self space actors do: [:each| each sendNotification].
    self space sectorsDo: [:sector|
        sector sendNotification.
        sector lines do: [:line| line sendNotification ]
    ].!
  
actorCross: movedActor with: crossedActor
        " Private - Notify about event. "

    self
        notify: 'OnActorCross:\This event is generated when an actor bumps into or runs over another actor.\This can be used to pick up potions, Inflict missile damage, trigger events, etc.\\'withCrs
            ,'Actor #',movedActor asString,' crossed actor #',crossedActor asString!
 
actorHit: thisActor with: hitActor
    " Private - Process event. "

    self notify: 'Notification #actor ',thisActor asString,' hitActor:',hitActor asString.!
 
actorsMenu
    " Private - Returns the actors menu. "

    | menu |
    menu := Menu new
        owner: self;
        title: 'A&ctors';
        appendItem: '&Add...' selector: #addActor;
        appendItem: 'te&leport all' selector: #teleportActors;
        appendSeparator;
        appendSubMenu: self currentActorMenu;
        yourself.
    self isRunTime ifFalse: [
        menu
            appendSeparator;
            appendItem: '&inspect...' selector: #inspectActors;
            yourself.
    ].
    ^menu!

addActor
    " Private - Add a new actor. "

    | prompt type location actor current |
    current := self currentActor.
    location := current position.

    prompt := self
        promptPoint: 'Position of the new actor (aPoint)?'
        default: (location x @ location y) truncated asString.
    prompt isPoint ifFalse: [ ^self ].
    location position: prompt.

    prompt := self
        promptNumber: 'Height of the new actor (aNumber)?'
        default: location height asString.
    prompt isNumber ifFalse: [ ^self ].
    location height: prompt.

    type := self
        promptNumber: 'Type of the new actor (aNumber)?'
        default: current type asParameter asString.
    type isNumber ifFalse: [ ^self ].

    self space
        add: (RenderAXActor new type: type;yourself)
        at: location
        !
  
ambientMenu
    " Private - Returns the ambient menu. "

    | menu |
    menu := Menu new
        owner: self space;
        title: 'Sp&ace';
        appendItem: 'st&art tracking' selector: #startTracking;
        appendItem: 'st&op tracking' selector: #stopTracking;
        appendItem: 'track only when a&ctive' selector: #trackingWhenActive;
        appendItem: 'track Al&ways' selector: #trackingAlways;
        appendSeparator;
        appendSubMenu: self strategyMenu;
        appendSeparator;
        appendItem: 'sector &Map...' action: (Message receiver: self selector: #sectorMap);
        appendSubMenu: self shadeMenu;
        appendSeparator;
        appendItem: '&Load Now' selector: #load;
        appendItem: 'Load &From...' action: (Message receiver: self selector: #changeSpaceLocation);
        appendSeparator;
        appendItem: '&Reset' selector: #reset;
        yourself.
    self isRunTime ifFalse: [
        menu appendItem: '&inspect' selector: #inspect
    ].
    ^menu!

blindStrategy
    " Private - Sets the strategy to blind walking. "

    | strategy |
    strategy := RenderAXStrategy new.
    strategy
        when: #startChecking: send: #blindWalk: to: self;
        yourself.
    self space strategy: strategy.!

blindWalk: aSpace
    " Private - Perform the blind walk strategy action no the space model. "

    | chasers current delta angle currentOffset gap step location |
    current := self currentActor.
    currentOffset := current position offset.
    chasers := self space actors select: [:one|
        one ~= current and: [ one isValid and: [ true"one sector = current sector" ] ] ].
    chasers do: [:each|
        currentOffset := each
            propertyAt: #destination
            ifAbsentPut: [ each sector anyPlace ].
        angle := currentOffset - each position offset.
        delta := (angle dotProduct: angle) sqrt.
        delta > 150
        ifTrue: [
            step := 3"each halfwit".
            gap := 0"Time now seconds - 30 * 3". "degrees of noise"
            location := each location.
            each
                adjust: -16;
                angle: (RenderAXAngle new getAngle: angle + gap);
                move: step;
                yourself.
            each currentFrame: each currentFrame + 1 \\ (each numberOfFrames max: 1).
            "Float clearExceptionFlags ifTrue: [ Terminal bell ]."
            location = each location ifTrue: [
                each "jump; "propertyAt: #destination put: each sector anyPlace.
            ].
        ]
        ifFalse: [ "reach destination..."
            each go: each width "* 2". "let it cross a sector"
			each validTypes size > 1
			ifTrue: [ each useNextValidType "type: each validTypes first" ]
			ifFalse: [ each jump ].
            each propertyAt: #destination put: each sector anyPlace.
        ].
    ].!
   
changeSpaceLocation
    " Private - Lets the user set the space name. "

    | file dialog name directory result |
    dialog := FileDialog new.
    dialog
        addFilter: '*.4dx' description: 'Level Files (*.4DX)';
        addFilter: '*.tdf' description: 'TextureSet Files (*.TDF)';
        addFilter: '*.typ' description: 'ActorDefs Files (*.TYP)';
        addFilter: '*.bst' description: 'BitmapSet Files (*.BST)';
        addFilter: '*.flt' description: 'FlatSet Files (*.FLT)';
        addFilter: '*.4dx;*.tdf;*.typ;*.bst;*.flt' description: 'RenderAX Files...';
        defFilter: '*.4dx;*.tdf;*.typ;*.bst;*.flt';
        openFile: '*.4dx;*.tdf;*.typ;*.bst;*.flt';
        yourself.
    file := dialog file.
    file isNil ifTrue: [ ^self ].
    name := file fileName fileNameLessPath.
    directory := Directory pathName: file fileNamePath.
    self space
        name: name;
        directory: directory;
        reset;
        load;
        fixupAll;
        yourself!
   
chaser: aSpace
    " Private - Perform the chaser strategy action no the space model. "

    | chasers current delta angle currentOffset gap step |
    current := self currentActor.
    currentOffset := current position offset.
    chasers := self space actors select: [:one|
        one ~= current and: [ one isValid and: [ true"one sector = current sector" ] ] ].
    chasers do: [:each|
        angle := currentOffset - each position offset.
        delta := (angle dotProduct: angle) sqrt.
        (delta between: 350 and: 1000)
        ifTrue: [
            step := 3"each halfwit".
            gap := Time now seconds - 30 * 3. "degrees of noise"
            each
                adjust: -16;
                angle: (RenderAXAngle new getAngle: angle + gap);
                move: step;
                yourself.
            each currentFrame: each currentFrame + 1 \\ (each numberOfFrames max: 1).
            "Float clearExceptionFlags ifTrue: [ Terminal bell ]."
        ].
    ].!
   
chaserStrategy
    " Private - Sets the strategy to chaser. "

    | strategy |
    strategy := RenderAXStrategy new.
    strategy
        when: #startChecking: send: #chaser: to: self;
        yourself.
    self space strategy: strategy.!
 
closed: aWindow
        " Private - the window has been closed.  Close down the application.
        Shut down the process if there are no more windows open. "

    self isRunTime
        ifTrue: [ self exitIfLastWindow ].!

currentActor
    " Private - Returns the current actor. "

    ^self space currentActor!
 
currentActorMenu
    " Private - Returns the current actor menu. "

    | menu |
    menu := Menu new
        owner: self;
        title: '&current';
        appendItem: 'in&formation...' selector: #dumpCurrentActor;
        appendItem: '&turn...' selector: #turnCurrentActor;
        appendItem: 'te&leport' selector: #teleportCurrentActor;
        yourself.
    self isRunTime ifFalse: [
        menu
            appendSeparator;
            appendItem: '&inspect' selector: #inspectCurrentActor;
            yourself
    ].
    ^menu!
  
currentSectorMenu
    " Private - Returns the sector actor menu. "

    | menu |
    menu := Menu new
        owner: self;
        title: '&current';
        appendItem: 'in&formation...' selector: #dumpCurrentSector;
        yourself.
    self isRunTime ifFalse: [
        menu
            appendSeparator;
            appendItem: '&inspect' selector: #inspectCurrentSector;
            yourself
    ].
    ^menu!
   
disableNotification
    " Private - Disable the notifications. "

    self space removeAllActionsWithReceiver: self.
        !
  
door: aSpace
    " Private - Perform the open/close door strategy action no the space model. "

    | chasers currentActor currentSector facingSector aDoor sense |
    currentActor := self currentActor.
    aDoor := currentActor facingLine.
    aDoor isNil ifTrue: [ ^self ].
    aDoor isDoor ifFalse: [ ^self ].

    sense := Cursor sense.
    ((self pane frameRectangle insetBy: 10)
        containsPoint: sense)
    ifFalse: [ ^self ].
    Display pen
        place: sense;
        circleFilled: 10;
        yourself.

    Notifier isShiftKeyDown ifFalse: [ ^self ].
    facingSector := aDoor facingSector.
    currentSector := aDoor sector.

    aDoor isOpen
    ifTrue: [ "close the door"
        facingSector "save old settings"
            propertyAt: #ceilingHeight put: facingSector ceilingHeight;
            propertyAt: #floorHeight put: facingSector floorHeight;
            yourself.
        facingSector "close ALL the sector doors "
            ceilingHeight: 80;
            floorHeight: 80;
            yourself.
    ]
    ifFalse: [ "open the door"
        facingSector "open ALL the sector doors "
            ceilingHeight: (facingSector propertyAt: #ceilingHeight ifAbsent: [196]);
            floorHeight: (facingSector propertyAt: #floorHeight ifAbsent: [0]);
            yourself.
    ]!
   
doorStrategy
    " Private - Sets the strategy to open/close doors. "

    | strategy |
    strategy := RenderAXTimedStrategy new.
    strategy
        interval: 1"seconds";
        when: #startChecking: send: #door: to: self;
        yourself.
    self space strategy: strategy.!
   
dump: selectors of: anObject
    " Private - Dump anObject into notifier. "

    self notify: '----',anObject asString,' dump----------------------------------------'.
    selectors do: [:each|
        self notify: each,'=',(anObject perform: each) asString
    ].
    self notify: '------------------------------------------------------------------------------'!
  
dumpCurrentActor
    " Private - Dump current actor into notifier. "

    self
        dump: #(
            number type flags
            x y height angle sectorID
            currentHp currentFrame velocity
            target physht halfwit percAttack
            frames doType used talkEvent
            latMov damageBase eyeHeight
            event tag range
            verticalForce mapNumber
            adjust mood damage
        )
        of: self currentActor!

dumpCurrentSector
    " Private - Dump current sector into notifier. "

    self
        dump: #(
            number tag
            currentFlagNames
            tripFlagNames
            boundingBox
            ceilingHeight ceilingTextureID textureCeilingAdjust
            floorHeight floorTextureID
            underHeight underTextureID
            swing
        )
        of: self currentActor sector!
   
enableNotification
    " Private - Enable the notifications. "

    self activateSpaceNotification.
    self space
        when: #actorHit:with: send: #actorHit:with: to: self;
        when: #lineHit:with: send: #lineHit:with: to: self;
        when: #sectorCross:with: send: #sectorCross:with: to: self;
        when: #missile:at: send: #missile:at: to: self;
        yourself.!

eventsMenu
    " Private - Returns the notifications menu. "

    | menu |
    menu := Menu new
        owner: self;
        title: '&Events';
        appendItem: '&enable' selector: #enableNotification;
        appendItem: '&disable' selector: #disableNotification;
        yourself.
    ^menu!
   
exitIfLastWindow
        " Private - Shut down the application if there are no more windows open. "

    Notifier windows
        detect: [ :w | w isApplicationWindow or: [ w isDialogWindow ] ]
        ifNone: [ ^Smalltalk exit ]!
 
fire: aSpace
    " Private - Perform the fire strategy action no the space model. "

    | mouseLocation actor sense |
    sense := Cursor sense.
    mouseLocation := sense - self pane frameRectangle origin.
    actor := self space findActorDisplayedAt: mouseLocation.
    actor notNil ifTrue: [
        Notifier isButton1Down ifTrue: [
            actor currentFrame: actor currentFrame + 1 \\ (actor numberOfFrames max: 1).
			actor currentFrame = 1 ifTrue: [
				actor validTypes size > 1
				ifTrue: [ actor useNextValidType ]
				ifFalse: [ actor jump ].
			] ifFalse: [ actor jump ].
        ].
        Display pen
        "    place: sense;circle: 20 "
            reverse: (sense - (16 @ 2) extent: 32@4);
            reverse: (sense - (2 @ 16) extent: 4@32);
            yourself.
    ].!
  
fireStrategy
    " Private - Sets the strategy to fire. "

    | strategy |
    strategy := RenderAXStrategy new.
    strategy
        when: #endRendering: send: #fire: to: self;
        yourself.
    self space strategy: strategy.!

help
    "Display the receiver's help sheet."

('
Help for ',self species asString,'

    Drag the mose over the pane to walk.
    Press shift key while draggin to run.
    Press rightMouse key to jump.
    Press control key to shear the camera.

Strategies:
    default: do nothing.
    chaser: the actors will follow you.
    fire: show the fire spot when the mouse is on an actor.
    door: lets you open/close doors (w/ shift key pressed).

') edit!
  
initializeNotifier
    " Private - Initializes the receiver's notifier"

    notifier := TextWindow
        windowLabeled: self class name,' notifier.'
        frame: (0@0 extent: Display extent // (4@3))!
  
initWindowSize
    " Returns the open window size. "

    ^640@480
        * 2 // 3
        // 8 * 8!
  
inspectActors
    " Private - Inspect actors. "

    self space actors inspect.!
 
inspectCurrentActor
    " Private - Inspect the current actor. "

    self currentActor inspect!
 
inspectCurrentSector
    " Private - Inspect the current sector. "

    self currentActor sector inspect!

inspectDIB
    " Private - Inspect the DIB interface. "

    self space dib inspect!
 
inspectSectors
    " Private - Inspect sectors. "

    self space sectors inspect.!
  
isRunTime
    " Private - Returns true when evaluating in RunTime. "

    ^SessionModel current isRunTime!
   
lineCross: actor with: line with: sector
        " Private - Notify about event. "

    self
        notify: 'OnLineCross:\This event is generated when an actor crosses a line that has the Notify flag set.\This can be used to trigger events, cause damage, restore health, teleport, etc.\\'withCrs
            ,'Actor #',actor asString,' crossed line #',line asString,' in sector #',sector asString!
 
lineHit: thisActor with: thisLine
    " Private - Process event. "

    self notify: 'Notification #line ',thisActor asString,' pLine:',thisLine asString.!
  
mapModeMenu
    " Private - Returns the mapMode menu. "

    | menu |
    menu := Menu new
        title: '&Map mode';
        appendItem: '&default' action: (Message receiver: self pane selector: #mapMode: arguments: (Array with: 0));
        appendItem: '&only map' action: (Message receiver: self pane selector: #mapMode: arguments: (Array with: 1));
        appendItem: 'map &over rendering' action: (Message receiver: self pane selector: #mapMode: arguments: (Array with: 2));
        yourself.
    ^menu!

mapZoomMenu
    " Private - Returns the mapZoom menu. "

    | menu |
    menu := Menu new
        title: 'Map &Zoom';
        appendItem: '&normal (3)' action: [ self pane mapZoom: 3 ];
        appendItem: '&query ?  (0=max, 8=min)' action: [ MessageBox message: 'Current mapZoom = ',self pane mapZoom asString ];
        appendSeparator;
        yourself.
    0 to: 8 do: [:zoom|
        menu
            appendItem: 'zoom x &',zoom asString
            action: (Message receiver: self pane selector: #mapZoom: arguments: (Array with: zoom))
    ].
    ^menu!

missile: thisActor at: aPoint
    " Private - Process event. "

    self notify: 'Notification #missile ',thisActor asString,' x:', aPoint x asString,' y:',aPoint y asString.!
  
noStrategy
    " Private - Sets the strategy to no strategy. "

    self space strategy: nil.!
   
notifier
    "Returns the instance var of the receiver
     for external manipulation"

    (notifier isNil or: [ notifier handle isValid not ])
    ifTrue: [ self initializeNotifier ].
    ^notifier!
  
notify: text
    " Private - Notify the text in the notifier. "

    self notifier cr;nextPutAll: text!
  
opened: aWindow
        " Private - the window has just been opened. "

    self pane
        when: #OnActorCross:with: send: #actorCross:with: to: self;
"        with: 'OnActorCross:\This event is generated when an actor bumps into or runs over another actor.\This can be used to pick up potions, Inflict missile damage, trigger events, etc.'withCrs; "
        when: #OnLineCross:with:with: send: #lineCross:with:with: to: self;
"        with: 'OnLineCross:\This event is generated when an actor crosses a line that has the Notify flag set.\This can be used to trigger events, cause damage, restore health, teleport, etc.'withCrs;"
        when: #OnSectorEntry:with: send: #sectorEntry:with: to: self;
"        with: 'OnSectorEntry:\This event is generated when an actor enters a sector actor.\This can be used to trigger events when an actor enters an area.'withCrs;"
        yourself.!
  
openFile
    " Private - Lets the user load a new level file. "

    self changeSpaceLocation!
   
paneMenu
    " Private - Returns the pane menu. "

    | menu |
    menu := Menu new
        owner: self pane;
        title: '&Pane';
        appendSubMenu: self mapModeMenu;
        appendSubMenu: self mapZoomMenu;
        appendItem: 'reset &Map' action: (Message receiver: self selector: #resetMap);
        appendSeparator;
        appendSubMenu: self eventsMenu;
        yourself.
    self isRunTime ifFalse: [
        menu
            appendSeparator;
            appendItem: '&inspect' selector: #inspect;
            appendItem: '&DIB inspect' action: (Message receiver: self selector: #inspectDIB);
            yourself
    ].
    menu
        appendSeparator;
        appendItem: '&About box...' selector: #aboutBox;
        yourself.
    ^menu!

promptNumber: title default: aString
    " Private - Prompts for a number. "

    | string |
    string := Prompter prompt: title default: aString.
    string isNil ifTrue: [ ^nil ].
    ^string asNumber!
  
promptPoint: title default: aString
    " Private - Prompts for a point. "

    | string stream |
    string := Prompter prompt: title default: aString.
    string isNil ifTrue: [ ^nil ].
    stream := ReadStream on: string.
    ^(stream upTo: $@) asNumber @ (stream upTo: $@) asNumber!
   
renderMenu
    " Private - Returns the render menu. "

    | menu |
    menu := Menu new
        owner: self;
        title: '&RenderAX';
        appendSubMenu: self ambientMenu;
        appendSubMenu: self paneMenu;
        appendSubMenu: self actorsMenu;
        appendSubMenu: self sectorsMenu;
        appendSeparator;
        appendSubMenu: self runMenu;
        appendSubMenu: self walkMenu;
        appendSeparator;
        appendItem: '&help' selector: #help;
        appendItem: '&About...' selector: #about;
        yourself.
    ^menu!

resetMap
    " Private - Reset the map display. "

    self pane
        mapMode: 2;
        mapZoom: 3;
        yourself!

runMenu
    " Private - Returns the run menu. "

    | menu |
    menu := Menu new
        owner: self space;
        title: '&Run';
        appendItem: '&faster' selector: #runFaster;
        appendItem: '&reset' selector: #runReset;
        appendItem: '&slower' selector: #runSlower;
        yourself.
    ^menu!
  
sectorCross: thisActor with: thisSector
    " Private - Process event. "

    self notify: 'Notification #sector ',thisActor asString,' sector:',thisSector asString.!
   
sectorEntry: actor with: sector
        " Private - Notify about event. "

    self
        notify: 'OnSectorEntry:\This event is generated when an actor enters a sector actor.\This can be used to trigger events when an actor enters an area.\\'withCrs
            ,'Actor #',actor asString,' sector #',sector asString!
 
sectorMap
    " Private - Returns the rendering sector map."

    | extent step map |
    extent := self promptPoint: 'Space map between 0@0 and... ?' default: '200 @ 200'.
    extent isPoint ifFalse: [ Terminal bell.^self ].
    step  := self promptNumber: 'Interval ?' default: '10'.
    step isNumber ifFalse: [ Terminal bell.^self ].
    CursorManager execute changeFor: [
        map := self space sectorsIn: (0@0 extent: extent) by: step.
    ].
    map inspect.
    ^map!
  
sectorShow: aSpace
    " Private - Perform the show sector strategy action no the space model. "

    | sector pen text radius |
    sector := self space sectorAt: self currentActor location.

    sector notNil ifTrue: [
        pen := Display pen.
        text := sector id asString.
        radius := (pen font stringWidth: text) // 2 + 3.
        pen
            place: self pane frameRectangle rightBottom - radius - 3;
            circleFilled: radius;
            centerText: text;
            yourself
    ].!
 
sectorsMenu
    " Private - Returns the sectors menu. "

    | menu |
    menu := Menu new
        owner: self;
        title: '&Sectors';
        appendSubMenu: self currentSectorMenu;
        yourself.
    self isRunTime ifFalse: [
        menu
            appendSeparator;
            appendItem: '&inspect current...' selector: #inspectCurrentSector;
            appendItem: 'in&spect all...' selector: #inspectSectors;
            yourself.
    ].
    ^menu!
 
sectorStrategy
    " Private - Sets the strategy to show sector. "

    | strategy |
    strategy := RenderAXStrategy new.
    strategy
        when: #endRendering: send: #sectorShow: to: self;
        yourself.
    self space strategy: strategy.!
 
setRenderMenu: aPane
    " Private - Set aPane menu with the render menu. "

    | menu |
    menu := self renderMenu.
    menu notNil ifTrue: [
        aPane setMenu: menu
    ].!
 
shadeMenu
    " Private - Returns the shade menu. "

    | menu |
    menu := Menu new
        owner: self space;
        title: '&Shade and ambient effects';
        appendItem: '&bloodRed' selector: #bloodRed;
        appendItem: '&fog' selector: #fog;
        appendItem: '&normal' selector: #normal;
        appendItem: '&veryDark' selector: #veryDark;
        yourself.
    ^menu!
   
space
    " Private - Returns the rendering space."

    ^self pane space!
   
startTracking
    " Start tracking process. "

    self space startTracking.!

stopTracking
    " Stop tracking process. "

    self space stopTracking.!
   
strategyMenu
    " Private - Returns the strategy menu. "

    | menu |
    menu := Menu new
        owner: self;
        title: '&Strategy';
        appendItem: 'd&efault' selector: #noStrategy;
        appendSeparator;
        appendItem: '&chaser' selector: #chaserStrategy;
        appendItem: '&blind' selector: #blindStrategy;
        appendItem: '&fire' selector: #fireStrategy;
        appendItem: 'open/close &door' selector: #doorStrategy;
        appendItem: 'show &sector' selector: #sectorStrategy;
        yourself.
    ^menu!
 
teleportActors
    " Private - Teleport the actors. "

    self space actors do: [:each| each teleport ].

    "auto-start tracking."
    self startTracking.!

teleportCurrentActor
    " Private - Teleport the current actor. "

    ^self currentActor teleport!
 
turnCurrentActor
    " Private - Turn the current actor. "

    | degrees |
    degrees := self promptNumber: 'Degrees to turn ?' default: '30'.
    degrees isNil ifTrue: [ ^self ].
    self currentActor turn: (RenderAXAngle new degrees: degrees)!
   
walkMenu
    " Private - Returns the walk menu. "

    | menu |
    menu := Menu new
        owner: self space;
        title: '&Walk';
        appendItem: '&faster' selector: #walkFaster;
        appendItem: '&reset' selector: #walkReset;
        appendItem: '&slower' selector: #walkSlower;
        yourself.
    ^menu! !



!RenderAXNativeTest class methods !
   
buildView: aView forModel: aCoordinator
    "Create the structure of the window <aView> for the application <aCoordinator>."

    | aPane |
    aView labelWithoutPrefix: self windowTitle.
    aPane := self
        createPaneIn: aView
        for: aCoordinator
        framing: self controlFramingBlock.
	aCoordinator pane: aPane.
    aView
        when: #opened send: #startTracking to: aCoordinator;
        when: #help send: #help to: aCoordinator;
        yourself.
!

createPaneIn: aWindow for: aCoordinator framing: aSizeSpecification
        " Private - Create a new pane in <aWindow>. "

    | aPane |
    aPane := RenderAXPane new.
    aWindow
        addSubpane: ( aPane
            owner: aCoordinator;
            framingBlock: aSizeSpecification;
            yourself ).
    aPane
        when: #needsMenu
        send: #setRenderMenu:
        to: aCoordinator
        with: aPane.
    ^aPane! !



!RenderAXNativeTest methods !
 
pane
    "Returns the instance var of the receiver
     for external manipulation"
    ^pane!

pane: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    pane := anObject! !



!RenderAXOLETest class methods !
 
buildView: aView forModel: aCoordinator
    "Create the structure of the window <aView> for the application <aCoordinator>."

    | aControlPane |

    aView labelWithoutPrefix: self windowTitle.

    aControlPane := self
        createControlSitePaneIn: aView
        for: aCoordinator
        name: aCoordinator container getNextSiteName
        framing: self controlFramingBlock.

    aView
        when: #opened send: #loadControl to: aControlPane;
        when: #opened send: #startTracking to: aCoordinator;
        when: #help send: #help to: aCoordinator;
        yourself.
!
   
createControlSitePaneIn: aWindow
    for: aContainerCoordinator
    name: aSiteName
    framing: aSizeSpecification
        " Private - create a new OLE control site pane in <aWindow>.
        Set the site pane's owner to <aContainerCoordinator> and its
        framing specification <aSizeSpecification>.
        Answer the control site pane. "

    | aSitePane |

    aSitePane := RenderAXOCXPane new.
    self
        installSitePane: aSitePane
        in: aWindow
        for: aContainerCoordinator
        name: aSiteName
        framing: aSizeSpecification.
    aSitePane
        when: #needsMenu
        send: #setRenderMenu:
        to: aContainerCoordinator
        with: aSitePane.
    ^aSitePane!
  
createViewFor: aCoordinator
        "Create and configure a window for <aCoordinator>.
        The main window of a container application has an
        OLE container object associated with it. "

    | aWindow |

    aWindow := super createViewFor: aCoordinator.
    aWindow
        container: aCoordinator container;  " find or create "
        yourself.

    self supportsInPlaceActivation
        ifTrue: [
            "in-place active container window must use WS_CLIPCHILDREN
                 so that its painting does not interfere with the painting
                 of the server's in-place active child window."
            aWindow addClipchildrenStyle.
            ].
    ^aWindow!
  
installSitePane: aSitePane
    in: aWindow
    for: aContainerCoordinator
    name: aSiteName
    framing: aSizeSpecification
        " Private - install a new OLE site pane in <aWindow>.
        Set the site pane's owner to <aContainerCoordinator> and its
        framing specification <aSizeSpecification>. "

    aWindow
        addSubpane: ( aSitePane
            owner: aContainerCoordinator;
            setName: aSiteName;
            framingBlock: aSizeSpecification;
            yourself ).
    aContainerCoordinator container registerSite: aSitePane siteObject.
    aContainerCoordinator activeSite: aSitePane siteObject.!

open: aCoordinator
    "Build and open a window for <aCoordinator>."

    | result |
    OLESessionManager isContainerSupportAvailable
        ifFalse: [
            MessageBox
                notify: 'Unsupported Platform'
                withText: 'The OLE control feature is not supported on this operating system.'.
            ^nil ].
    ^super open: aCoordinator.!
   
supportsInPlaceActivation
        " Private - answer whether in-place activation should be supported
        in the receiver's view. "

    ^false ! !



!RenderAXOLETest methods !

aboutToClose: aWindow
        " Private - the window is about to close. "

    " must be done before window closes to handle IPA site properly "
    self container close.
!
   
activeSite
    "Returns the instance var of the receiver
     for external manipulation"

    activeSite isNil ifTrue: [ self initializeActiveSite ].
    ^activeSite!
 
activeSite: aClientSite
        " Private - set the currently selected site in the receiver to <aClientSite>. "

    activeSite notNil
        ifTrue: [ activeSite deactivate ].
    activeSite := aClientSite.
    aClientSite activate.!
   
closed: aWindow
        " Private - the window has been closed.  Close down the application.
        Shut down the process if there are no more windows open. "

    self container release.  " decrement the artifical ref count "
    self container: nil.

    ^super closed: aWindow!

container
        " Private - answer the receiver's container object. "

    ^container!
 
container: aContainer
        " Private - set the receiver's container object to <aContainer>. "

    container := aContainer.!
  
initialize
        " Private - Initialize the receiver. "

    self initializeContainer.
    super initialize.!
 
initializeActiveSite
    " Private - Initializes the receiver's activeSite"

    self activeSite: self container sites first.
    !
 
initializeContainer
        " Private - initialize the receiver's container object. "

    self container: ( OLEContainerObject new
        name: 'OLE Container';
        yourself )!
 
opened: aWindow
        " Private - the window has just been opened. "

    self container addRef.  " artificially reference count the container while the window is open (needed for IPA support) "
    " note that we do not allocate a compound doc file backing for the receiver, as we do not intend to persist the state "

    ^super opened: aWindow!
 
pane
    " Private - Returns the rendering pane."

    ^self activeSite sitePane!

siteObject
    " Private - answer the receiver's container siteObject. "

    ^container siteObject! !



!RenderAXDLL class methods !
   
callbackTable
    " Private - Returns the callback shape table for defining callback handlers."

    ^#(
    "(callBackName (arguments...) returnType callingConvertion)"

    (line (ulong ulong ) long api) "lvect = function(pa : pactor; pl : plinedef) : integer;"
    (actor (ulong ulong) long api) "avect = function(pa,hitactor : pactor) : integer;"
    (sector (ulong ulong) long api) "svect = function(pa : pactor; ps : psector) : integer;"
    (missile (ulong long long) long api) "mvect = function(pa : pactor; x,y : integer) : integer;"

    )!
   
fileName
        "Answer the receiver's file name."

    ^'4dxdll.dll'!
  
newCallBack: callBackName sending: selector to: aReceiver
    "Returns a CallBack object for sending message with selector to aReceiver.
    callBackName must be a valid name defined in callbackTable."

    | tuple aMessage parameterTypes |
    tuple := self callbackTable
        detect: [:one| one first = callBackName ]
        ifNone: [ ^self error: 'Invalid callback name.'].

    "check selector arguments with parameterTypes size"
    parameterTypes := tuple at: 2.
    (selector asString select: [:c| c = $: ]) size = parameterTypes size
    ifFalse: [ ^self error: 'Invalid selector (Must have ',parameterTypes size asString,' arguments.' ].

    aMessage := Message new
        receiver: aReceiver;
        selector: selector;
        yourself.
    ^CallBack
        registerMessage: aMessage
        parameterTypes: parameterTypes
        returnType: (tuple at: 3)
        callingConvention: (tuple size > 3 ifTrue: [ tuple at: 4 ] ifFalse: [#api]).
! !



!RenderAXDLL methods !
   
actor: number
    " Returns the actor structure with id=number. "

    ^self
        structureNamed: #ExternalRenderAXActor
        at: (self getActor: number)!
   
addActor: actor type: aType x: x y: y height: height sector: sector

    ^self
        structureNamed: #ExternalRenderAXActor
        at: (self
            privateAddActor: actor
            type: aType asParameter
            x: (self numberToSingle: x) asParameter
            y: (self numberToSingle: y) asParameter
            height: (self numberToSingle: height) asParameter
            sector: sector)!
 
addBitmap: number
    width: w height: h
    pitch: pitch
    bytes: bytes
    data: pointer
    name: aName
    " Private - Use #newBitmap:... "

    <api: 'dx_addbitmap' long long long long long struct struct long>
    ^self invalidArgument!

addPatch: texture bitmap: bitmap xoffset: x yoffset: y
    " Private - Use #newPatch to add them..."

    <api: 'dx_addpatch' long long long long long>
    ^self invalidArgument!
  
addTypeData: actorType frame: frame dir: dir texture: texture reverse: reverse
    <api: 'dx_addtypedata' long long long long long long>
    ^self invalidArgument!
   
addTypeInfo: actorType frames: frames dirs: dirs name: aName
    <api: 'dx_addtypeinfo' long long long struct long>
    ^self invalidArgument!

alternateShade: red green: green blue: blue distance: distance
    <api: 'dx_alternateshade' long long long long none>
    ^self invalidArgument!
 
assignPalette: palette
    <api: 'dx_assignpalette' struct long>
    ^self invalidArgument!
   
autoLoad: datafile
    "WARNING: not recommended for normal users."
    <api: 'dx_autoload' struct long>
    ^self invalidArgument!
  
buildTexture: pMetaTexture
    data: pointer
    maxSize: maxSize
    flip: flip
    <api: 'dx_buildtexture' ulong ulong long long none>
    ^self invalidArgument!

checkActor: actor
    <api: 'dx_checkactor' long none>
    ^self invalidArgument!
 
cleanUp
	"Frees all data and closes down the engine."

    <api: 'dx_cleanup' long>
    ^self invalidArgument!
  
clearLevel
    "Remove all level contents."

    ^self initializeLevel!
  
createFlat: number
    width: width
    pitch: pitch
    address: pointer
    name: aName
    <api: 'dx_createflat' long long long struct struct ulongReturn>
    ^self invalidArgument!
  
createTexture: number width: width height: height name: aName
    " Private - Use #newTexture:... to create them..."

    <api: 'dx_createtexture' long long long struct long>
    ^self invalidArgument!
   
deleteSector: number
    <api: 'dx_deletesector' long none>
    ^self invalidArgument!

deleteTexture: number
    <api: 'dx_deletetexture' long none>
    ^self invalidArgument!
  
facingLine: actNo distance: single
    " Returns the line in front of actNo at distance single. "

    ^self
        structureNamed: #ExternalRenderAXLineDef
        at: (self getFacingLine: actNo distance: single asFloat)!

findActor: aPoint

    ^self findActor: aPoint x y: aPoint y!
 
findActor: x y: y
    " Returns the actor id of actor at x@y. "

    | number |
    number := self
        privateFindActor: x asInteger
        y: y asInteger.
    ^number >= 0 ifTrue: [ number ]!

findSector: aPoint

    ^self findSector: aPoint x y: aPoint y!
   
findSector: x y: y
    " Returns the sector id of sector at x@y. "

    ^self
        privateFindSector: (self numberToSingle: x) asParameter
        y: (self numberToSingle: y) asParameter!
 
fixActor: pActor
    <api: 'dx_fixactor' ulong none>
    ^self invalidArgument!
   
fixAngle: angle
    <api: 'dx_fixangle' long long>
    ^self invalidArgument!
 
fixLine: pLineDef
    <api: 'dx_fixline' ulong none>
    ^self invalidArgument!
   
fixupActors
    <api: 'dx_fixupactors' none>
    ^self invalidArgument!
   
fixupLines
    <api: 'dx_fixuplines' none>
    ^self invalidArgument!
 
fixupSector: sector
    <api: 'dx_fixupsector' long none>
    ^self invalidArgument!
  
flushTextureCache
    <api: 'dx_flushtexturecache' none>
    ^self invalidArgument!
   
freeBitmap: number
    <api: 'dx_freebitmap' long long>
    ^self invalidArgument!

getActor: number
    " Private - Returns the actor pointer with id=number."

    <api: 'dx_getactor' long long>
    ^self invalidArgument!
  
getAngle: aPoint

    ^self getAngle: aPoint x y: aPoint y!
   
getAngle: x y: y
    " Get the angle id at x@y. "

    ^self
        privateGetAngle: (self numberToSingle: x) asParameter
        y:  (self numberToSingle: y) asParameter!
   
getBitmap: number
    <api: 'dx_getbitmap' long ulongReturn>
    ^self invalidArgument!
   
getBitmapHeight: number
    <api: 'dx_getbitmapheight' long long>
    ^self invalidArgument!
  
getBitmapInfo: number
    <api: 'dx_getbitmapinfo' long ulongReturn>
    ^self invalidArgument!
   
getBitmapName: number
    <api: 'dx_getbitmapname' long long>
    ^self invalidArgument!
  
getBitmapNameString: number
    "Returns the string that represents the bitmap name."

     | integer address |
    integer := self getBitmapName: number.
    integer = 0 ifTrue: [ ^nil ].
    address := ExternalAddress fromInteger: integer.
    ^String fromAddress: address!
  
getBitmapPointer: bitmapID
    "Returns the ExternalAddress pointer for bitmap with id bitmapID."

    | integer |
    integer := self getBitmap: bitmapID.
    ^integer ~= 0 ifTrue: [ ExternalAddress fromInteger: integer ]!

getBitmapWidth: number
    <api: 'dx_getbitmapwidth' long long>
    ^self invalidArgument!

getClosestColor: aColor

    ^self
        getClosestColor: aColor red
        green: aColor green
        blue: aColor blue!
  
getClosestColor: red green: green blue: blue
    <api: 'dx_getclosestcolor' long long long long>
    ^self invalidArgument!
   
getFacingLine: actNo distance: single
    " Private - Get line in front of actNo at distance single. "

    <api: 'dx_getfacingline' long struct long>
    ^self invalidArgument!
   
getFlat: number
    <api: 'dx_getflat' long ulongReturn>
    ^self invalidArgument!
   
getFlatName: number
    <api: 'dx_getflatname' long ulongReturn>
    ^self invalidArgument!
   
getFlatNameString: number
    "Returns the string that represents the flat name."

     | integer address |
    integer := self getFlatName: number.
    integer = 0 ifTrue: [ ^nil ].
    address := ExternalAddress fromInteger: integer.
    ^String fromAddress: address!

getFlatPointer: flatID
    "Returns the ExternalAddress pointer for flat with id flatID."

    | integer |
    integer := self getFlat: flatID.
    ^integer ~= 0 ifTrue: [ ExternalAddress fromInteger: integer ]!

getFlatWidth: number
    <api: 'dx_getflatwidth' long ulongReturn>
    ^self invalidArgument!
 
getMetaTexture: texture
    " Private - Get MetaTexture with id=texture. "

    <api: 'dx_getmetatexture' long ulong>
    ^self invalidArgument!

getSector: number
    " Private - Get sector with id=sector. "

    <api: 'dx_getsector' long ulong>
    ^self invalidArgument!
 
getShownActors
    " Private - Get currently shown actors pointer."

    <api: 'dx_shownactors' ulong>
    ^self invalidArgument!
   
getShownSectors
    " Private - Get currently shown sectors pointer."

    <api: 'dx_shownsectors' ulong>
    ^self invalidArgument!

getTexture: texture
    <api: 'dx_gettexture' long ulong>
    ^self invalidArgument!
  
getTextureHeight: texture
    <api: 'dx_gettextureheight' long ulong>
    ^self invalidArgument!
  
getTextureName: number
    <api: 'dx_gettexturename' long long>
    ^self invalidArgument!

getTextureNameString: number
    "Returns the string that represents the texture name."

     | integer address |
    integer := self getTextureName: number.
    integer = 0 ifTrue: [ ^nil ].
    address := ExternalAddress fromInteger: integer.
    ^String fromAddress: address!
   
getTextureWidth: texture
    <api: 'dx_gettexturewidth' long ulong>
    ^self invalidArgument!

getTypeData: actorType frame: frame dir: dir
    " Private - Use getTypeDataPointer:..."

    <api: 'dx_gettypedata' long long long ulongReturn>
    ^self invalidArgument!
 
getTypeDirs: actorType
    <api: 'dx_gettypedirs' long long>
    ^self invalidArgument!
   
getTypeFrames: actorType
    <api: 'dx_gettypeframes' long long>
    ^self invalidArgument!
   
getTypeName: number
    <api: 'dx_gettypename' long long>
    ^self invalidArgument!
  
getTypeNameString: number
    "Returns the string that represents the type name."

     | integer address |
    integer := self getTypeName: number.
    integer = 0 ifTrue: [ ^nil ].
    address := ExternalAddress fromInteger: integer.
    ^String fromAddress: address!

getVertex: number
    " Private - Get vertex with id=number. "

    <api: 'dx_getvertex' long ulong>
    ^self invalidArgument!
 
importWad: fileName levelName: aName
    <api: 'dx_importwad' struct struct long>
    ^self invalidArgument!
  
init: w h: h pitch: pitch orientation: orientation databuff: databuff palette: palette
    <api: 'dx_init' long long long long ulong ulong long>
    ^self invalidArgument!
   
initializeLevel
    <api: 'dx_initlevel' none>
    ^self invalidArgument!
 
insertVertex: aPoint

    ^self insertVertex: aPoint x y: aPoint y!
   
insertVertex: x y: y

    ^self
        privateInsertVertex: (self numberToSingle: x) asParameter
        y: (self numberToSingle: y) asParameter!
  
loadBitmapSet: fileName
    <api: 'dx_loadbitmapset' struct long>
    ^self invalidArgument!
  
loadFlatSet: fileName
    <api: 'dx_loadflatset' struct long>
    ^self invalidArgument!
  
loadLevel: fileName
    <api: 'dx_loadlevel' struct long>
    ^self invalidArgument!
  
loadTextureSet: fileName
    <api: 'dx_loadtextureset' struct long>
    ^self invalidArgument!

mapColors: bound normal: normal arrow: arrow
    <api: 'dx_mapcolors' long long long none>
    ^self invalidArgument!
 
mapZoomLevel: zoomlevel
    <api: 'dx_mapzoomlevel' long none>
    ^self invalidArgument!
 
metaTexture: number
    " Returns the MetaTexture structure with id=number. "

    ^self
        structureNamed: #ExternalRenderAXMetaTexture
        at: (self getMetaTexture: number)!
   
modifyPatch: texture patch: patch offset: aPoint

    ^self
        modifyPatch: texture
        patch: patch
        xOffset: aPoint x
        yOffset: aPoint y
!
  
modifyPatch: texture
    patch: patch
    xOffset: x
    yOffset: y
    <api: 'dx_modifypatch' long long long long none>
    ^self invalidArgument!

moveActor: actor step: step
    " Move actor with id=actor by step. "

    ^self
        privateMoveActor: actor
        step: (self numberAsSingle: step) asParameter!

moveX: x angle: angle distance: distance
    "Move observer? "

    | result |
    result := self
        privateMoveX: (self numberToSingle: x) asParameter
        angle: angle
        distance: (self numberToSingle: distance) asParameter.
    ^RenderAXSingle new
        value: result;
        value!

moveY: y angle: angle distance: distance
    "Move observer? "

    | result |
    result := self
        privateMoveY: (self numberToSingle: y) asParameter
        angle: angle
        distance: (self numberToSingle: distance) asParameter.
    ^RenderAXSingle new
        value: result;
        value!

newActor: actorID
    type: aType
    at: aPoint
    height: height
    "Create a new actor of aType at aPoint."

    ^self
        addActor: actorID
        type: aType
        x: aPoint x
        y: aPoint y
        height: height
        sector: (self sectorAt: aPoint) asParameter!
   
newActor: actorID
    type: aType
    at: aPoint
    height: height
    sector: sector
    "Create a new actor of aType at aPoint in sector."

    ^self
        addActor: actorID
        type: aType
        x: aPoint x
        y: aPoint y
        height: height
        sector: sector!
  
newBitmap: number extent: extent bytes: bytes name: aName

    ^self
        addBitmap: number
        width: extent x
        height: extent y
        pitch: extent x
        bytes: 1
        data: bytes
        name: aName!
  
newFlat: number width: width address: pointer name: aName
    "Define a new flat with ID=number"

    ^self
        createFlat: number
        width: width
        pitch: width
        address: pointer
        name: aName!
  
newLine: sector from: from to: to
    " Creates a new line in sector between from and to vertexes with default texture. "

    ^self newLine: sector
        from: from to: to
        texture: 0!
 
newLine: sector from: from to: to texture: texture
    " Creates a new line in sector between from and to vertexes with a texture. "

    | result |
    result := self
        privateAddLine: sector
        from: from to: to
        texture: texture.
    ^self
        structureNamed: #ExternalRenderAXLineDef
        at: result !

newPatch: textureID bitmap: bitmap at: aPoint

    ^self
        addPatch: textureID
        bitmap: bitmap asParameter
        xoffset: aPoint x
        yoffset: aPoint y!
  
newSector: sectorID
    " Creates a new sector and returns it's pointer. "

    ^self
        newSector: sectorID
        floorTexture: 0 ceilingTexture: 0
        floorHeight: 0 ceilingHeight: 255!

newSector: sectorID
    floorTexture: foorTexture
    ceilingTexture: ceilingTexture
    floorHeight: floorHeight
    ceilingHeight: ceilingHeight
    " Creates a new sector and returns it's pointer. "

    | result |
    result := self
        privateAddSector: sectorID
        floorTexture: foorTexture
        ceilingTexture: ceilingTexture
        floorHeight: (self numberToSingle: floorHeight) asParameter
        ceilingHeight: (self numberToSingle: ceilingHeight) asParameter.
    ^self
        structureNamed: #ExternalRenderAXSector
        at: result !

newTexture: number extent: extent name: aName
    "Build a new texture with id=number."

    ^self
        createTexture: number
        width: extent x
        height: extent y
        name: aName!
   
newVertex: vertexID at: aPoint

    ^self newVertex: vertexID x: aPoint x y: aPoint y!

newVertex: vertexID x: x y: y

    | result |
    result := self
            privateAddVertex: vertexID asParameter
            x: (self numberToSingle: x) asParameter
            y: (self numberToSingle: y) asParameter.
    ^self
        structureNamed: #ExternalRenderAXVertex
        at: result !

normalShade: red green: green blue: blue distance: distance
    <api: 'dx_normalshade' long long long long none>
    ^self invalidArgument!
   
numberToSingle: aNumber
    " Private - Converts a Smalltalk aNumber (8 byte float) to a external 4 byte float.
    Change the exponent byte from format xxyyyzzz to xxzzz and shift the
    mantissa bits over keeping only the rightmost four bytes.
    Note that Floats are stored in reverse byte order so the high order bytes of byte
    i are shifted into the low order bytes of byte i + 1.
    Returns aByteArray"

    "We will use OLE services to do this task"
    ^RenderAXSingle new
        value: aNumber asFloat;
        yourself

"
    | result |
    aNumber isFloat ifFalse: [ ^self numberToSingle: aNumber asFloat ].
    result := ByteArray new: 4.
    1 to: 4 do: [:index|
        result at: index put:
            ((aNumber at: index + 4) & 16r1F bitShift: 3)
                | ((aNumber at: index + 3) & 16rE0 bitShift: -5)
    ].
    result at: 4 put: ((result at: 4) & 16r3F) | ((aNumber at: 8) & 16rC0).
    ^result
"!
   
on: aCallBackName send: aSelector to: aReceiver
    " On Event determined by aCallBackName send a message to aReceiver to handle it.
    See receivers class #callbackTable method."

    | callback setSelector |
    callback := self species
        newCallBack: aCallBackName asSymbol
        sending: aSelector
        to: aReceiver.

    setSelector := aCallBackName asString.
    setSelector at: 1 put: setSelector first asUpperCase.
    setSelector := ('set',setSelector,'CallBack:') asSymbol.

    self perform: setSelector with: callback asParameter.
    ^callback!
   
positionActor: actor x: x y: y z: z angle: angle
    " Position actor with id actor at x@y@z@angle "

    ^self
        privatePositionActor: actor
        x: (self numberToSingle: x) asParameter
        y: (self numberToSingle: y) asParameter
        z: (self numberToSingle: z) asParameter
        angle: angle!
   
povActor: number
    <api: 'dx_povactor' long long>
    ^self invalidArgument!

privateAddActor: actor type: aType x: x y: y height: height sector: sector
    " Private - "

    <api: 'dx_addactor' long long ulong ulong ulong long long>
    ^self invalidArgument!
 
privateAddLine: sector from: from to: to texture: texture
    <api: 'dx_addline' long long long long long>
    ^self invalidArgument!
 
privateAddSector: sector floorTexture: foorTexture ceilingTexture: ceilingTexture floorHeight: floorHeight ceilingHeight: ceilingHeight
    " Private - "

    <api: 'dx_addsector' long long long ulong ulong ulong>
    ^self invalidArgument!

privateAddVertex: sector x: x y: y
    " Private - "

    <api: 'dx_addvertex' long ulong ulong long>
    ^self invalidArgument!

privateFindActor: x y: y
    " Private - "

    <api: 'dx_findactor' long long long>
    ^self invalidArgument!
 
privateFindSector: x y: y
    " Private - "

    <api: 'dx_findsector' ulong ulong long>
    ^self invalidArgument!
 
privateGetAngle: x y: y
    " Private - "

    <api: 'dx_getangle' ulong ulong long>
    ^self invalidArgument!
 
privateInsertVertex: x y: y
    " Private - "

    <api: 'dx_insertvertex' ulong ulong long>
    ^self invalidArgument!
 
privateMoveActor: actor step: step
    " Private - "

    <api: 'dx_movetactor' long struct long>
    ^self invalidArgument!

privateMoveX: x angle: angle distance: distance
    " Private - "

    <api: 'dx_movex' ulong long ulong ulong>
    ^self invalidArgument!
  
privateMoveY: y angle: angle distance: distance
    " Private - "

    <api: 'dx_movey' ulong long ulong ulong>
    ^self invalidArgument!
  
privatePositionActor: actor x: x y: y z: z angle: angle
    " Private - "

    <api: 'dx_positionactor' long ulong ulong ulong long none>
    ^self invalidArgument!

privateShownActors
    <api: 'dx_shownactors' ulong>
    ^self invalidArgument!
   
privateShownSectors
    <api: 'dx_shownsectors' ulong>
    ^self invalidArgument!
 
raiseSectorCeiling: sector height: height speed: speed
    <api: 'dx_raisesectorceiling' long long long long>
    ^self invalidArgument!
  
raiseSectorFloor: sector height: height speed: speed
    <api: 'dx_raisesectorfloor' long long long long>
    ^self invalidArgument!
  
render: mode shear: shear
    <api: 'dx_render' long long long>
    ^self invalidArgument!

resize: aPoint data: pointer pitch: pitch

    ^self resize: aPoint x height: aPoint y data: pointer pitch: pitch!

resize: width height: height data: pointer pitch: pitch
	"This function needs to be called when you resize the data buffer.
	Note: this does not resize the buffer for you - it only recalculate
	the tables that are specific to buffer size."

    <api: 'dx_resize' long long struct long long>
    ^self invalidArgument!
 
saveLevel: fileName
    <api: 'dx_savelevel' struct long>
    ^self invalidArgument!
  
sector: number
    " Returns the sector structure with id=number. "

    ^self
        structureNamed: #ExternalRenderAXSector
        at: (self getSector: number)!
   
sectorAt: aPoint
    " Returns the sector id at aPoint. "

    ^self findSector: aPoint x asFloat y: aPoint y asFloat!
   
setActorCallBack: callback
    <api: 'dx_setactorcallback' ulong none>
    ^self invalidArgument!
 
setLineCallBack: callback
    <api: 'dx_setlinecallback' ulong none>
    ^self invalidArgument!
   
setMissileCallBack: callback
    <api: 'dx_setmissilecallback' ulong none>
    ^self invalidArgument!
 
setSectorCallBack: callback
    <api: 'dx_setsectcallback' ulong none>
    ^self invalidArgument!
 
setType: actorType at: aPoint with: textureID reversed: aBoolean
    "Set the texture to be used when displaying actor of type actorType
    when set at frame (aPoint y) at direction (aPoint x)."

    ^self
        addTypeData: actorType asParameter
        frame: aPoint y asParameter
        dir: aPoint x asParameter
        texture: textureID asParameter
        reverse: aBoolean asParameter!
  
setType: actorType name: aName extent: extent
    "Create(add) a new ActorType with:
        Id=actorType
        name=aName
        directions=extent y (number of frames when rotating)
        frames=extent x (number of frames when walking)
    This type will need (direction x frames) number of textures.
    See methods (add/set)TypeData:... 
    "

    ^self
        addTypeInfo: actorType
        frames: extent x
        dirs: extent y
        name: aName asParameter!

shade: red green: green blue: blue distance: distance
    ^self normalShade: red green: green blue: blue distance: distance!
   
shownActorCount
    <api: 'dx_shownactorcount' long>
    ^self invalidArgument!
   
shownActorsIDs
    "Returns an array of actor IDs currently visibles."

	| count address bytes |
	count := self shownActorCount.
	count = 0 ifTrue: [ ^Array new ].
	address := ExternalAddress fromString: self getShownActors.
	bytes := address copyFrom: 1 to: count * 4.
	^(1 to: bytes size by: 4) collect: [:i|
		(bytes at: i)
		+ (256 * (bytes at: i + 1))
		+ (65536 * (bytes at: i + 2))
		+ (16777216 * (bytes at: i + 3))
	]!

shownSectors
    "Get Shown Sectors."

    ^self notImplementedYet
        structureNamed: #ExternalRenderAXSector
        at: self getShownSectors!
   
singleToNumber: aByteArray
    " Private - Converts a Smalltalk ByteArray (4 byte float) to aFloat.
    Note that Floats are stored in reverse byte order.
    Returns aFloat"

    | result byte |
    aByteArray isOLEStructure "We support RenderAXSingles..."
    ifTrue: [ ^aByteArray value ].

    result := Float new.
    1 to: 4 do: [:index|
        byte := aByteArray at: index.
        result
            at: index + 2
            put: (byte bitShift: 5) & 16rFF | (result at: index + 2);
            at: index + 3
            put: (byte bitShift: -3) | (result at: index + 3).
    ].
    result at: 8 put: ((result at: 8) & 16r3F) | ((aByteArray at: 4) & 16rC0).
    ^result

!
 
spawnMissile
    <api: 'dx_spawnmissile' long>
    ^self invalidArgument!
 
spinActor: actor step: step
    <api: 'dx_spinactor' long struct none>
    ^self invalidArgument!
 
structureNamed: aStructureName at: structPointer
    " Private - Returns aStructure pointed by structu pointer. "

    | address |
    address := ExternalAddress fromString: structPointer.
    address isValid ifFalse: [ ^nil ].
    ^(Smalltalk at: aStructureName) atAddress: address!
   
teleportActor
    <api: 'dx_teleportactor' long>
    ^self invalidArgument!
   
vertex: number
    " Returns the vertex structure with id=number. "

    ExternalRenderAXVertex sizeInBytes. "force class initialization."
    ^self
        structureNamed: #ExternalRenderAXVertex
        at: (self getVertex: number)! !



!RenderAXStructure class methods !

accesorsMap
    " Private - Returns the accesor methods map.
    It is a collection of tuples with (fieldName,type) "

    | result type |
    result := OrderedCollection new.
    self recordSpecification do: [:tuple|
        type := tuple last.
        tuple first do: [:selector|
            result add: (Array with: selector with: type)
        ].
    ].
    ^result!
  
buildAccesorsTo: selector arrayOf: aType startingAt: offset
    " Private - Build the getter and setter methods to selector. "

    "currently not supported..."!

buildAccesorsTo: selector ofType: aType startingAt: offset
    " Private - Build all the accesor methods to selector specting an object of type aType at offset offset. "

    (aType isSymbol and: [aType first isLowerCase]) ifTrue: [
        ^self buildStandardAccesorsTo: selector ofType: aType startingAt: offset
    ].

    aType isNumber ifTrue: [
        ^self buildBytesAccesorsTo: selector count: aType startingAt: offset
    ].

    aType isArray ifTrue: [
        aType size = 1 ifTrue: [ "pointer to an ole structure"
            ^self buildAccesorsTo: selector pointerStructure: aType first startingAt: offset
        ].
        ^self buildAccesorsTo: selector arrayOf: aType startingAt: offset
    ].

    aType isSymbol ifTrue: [ "an ole structure"
            ^self buildAccesorsTo: selector structure: aType startingAt: offset
    ].

    ^self notImplementedYet!
 
buildAccesorsTo: selector pointerStructure: aType startingAt: offset
    " Private - Build the getter and setter methods to selector. "

    | message |
    self
        "getter method"
        compileSource: selector,'
    " Generated - Returns the ',selector,' property (as a ByteArray)."

    ^self structurePointedAtOffset: ',offset asString,' type: #',aType asString;

        "setter method"
        compileSource: selector,': aPointer
    " Generated - Sets the ',selector,' property with aPointer."

    ^self structurePointedAtOffset: ',offset asString,' put: aPointer';

        yourself.!

buildAccesorsTo: selector structure: aType startingAt: offset
    " Private - Build the getter and setter methods to selector. "

    | message |
    self
        "getter method"
        compileSource: selector,'
    " Generated - Returns the ',selector,' property (as anOLEStructure)."

    ^self structureAtOffset: ',offset asString,' type: ',aType;

        "WARNING: setter method can't be generated"
        yourself.!
 
buildBytesAccesorsTo: selector count: count startingAt: offset
    " Private - Build the getter and setter methods to selector. "

    | message |
    self
        "getter method"
        compileSource: selector,'
    " Generated - Returns the ',selector,' property (as a ByteArray)."

    ^self bytesAtOffset: ',offset asString,' count: ',count asString;

        "setter method"
        compileSource: selector,': aByteObject
    " Generated - Sets the ',selector,' property with aByteObject."

    ^self bytesAtOffset: ',offset asString,' put: anByteObject';

        yourself.!
  
buildSizeInBytes: size
    " Private - Build the #sizeInBytes method... "

    self
        compile: 'sizeInBytes
    " Private - Answer the size in bytes of the receiver''s instances. "
    ^',size asString
        in: self class!
  
buildSpecification
    " Private - Build all the accesor methods obtained from receiver's record specification. "

    | map fields type size offset |
    offset := 0.
    self recordSpecification do: [:tuple|
        fields := tuple first.
        type := tuple last.
        size := self sizeOfType: type.
        fields do: [:selector|
            self buildAccesorsTo: selector ofType: type startingAt: offset.
            offset := offset + size.
        ].
    ].
    self buildSizeInBytes: offset.!
 
buildStandardAccesorsTo: selector ofType: aType startingAt: offset
    " Private - Build the getter and setter methods to selector. "

    | message |
    self
        "getter method"
        compileSource: selector,'
    " Generated - Returns the ',selector,' property."

    ^self ',aType,'AtOffset: ',offset asString;

        "setter method"
        compileSource: selector,': anObject
    " Generated - Sets the ',selector,' property with anObject."

    ^self ',aType,'AtOffset: ',offset asString,' put: anObject';

        yourself.!
   
compile: source in: aClass
    " Private - Try to compile source, log source and return the generated key. "

    | result |
    (result := aClass compile: source trimBlanks) isNil
    ifTrue: [ self error: 'Error during code generation...'. ^nil ].

    self sourceManager current
        logSource: source trimBlanks
        forSelector: result key
        inClass: aClass.

    ^result!
   
compileSource: source
    " Private - Try to compile source, log source and return the generated key. "

    ^self compile: source in: self!
 
initialize
    " Private - initialize the class state. "

    self
        buildSpecification;
        registerStructureName.!
 
inspectorFields
    "Answer the names of the fields contained in this kind of definition."

    | fields |
    fields := Set new.
    self recordSpecification do: [:each|
        fields addAll: each first
    ].

    ^self inspectorClass fields: fields asSortedCollection!
   
recordSpecification
    " Private - Returns the record specification. "

    ^self implementedBySubclass!

registerStructureName
    " Private - register the host data structure name represented by the receiver. "

    OLEStructure registerStructureName: self symbol for: self.!
  
sizeInBytes
    " Private - Answer the size in bytes.
    This method must be implemented in subclasses.
    If this method is activated is because the class needs initialization/registration."

    ^self
        initialize;
        sizeInBytes!

sizeOfType: aType
    " Private - Returns the size for a field of type aType. "

    aType isNumber ifTrue: [ ^aType ].

    "default types..."
    #(    (byte 1)
        (short boolean uShort 2)
        (long address handle singleFloat uLong interface oleAddress 4)
        (largeInteger float uLargeInteger 8)
        (guid 16)
    ) do: [:pair| (pair includes: aType) ifTrue: [ ^pair last] ].

    aType isArray ifTrue: [
        aType size = 1 "type pointer"
        ifTrue: [ ^self sizeOfType: #address ].

        "an array of typed fields..."
        ^aType first * (self sizeOfType: aType last)
    ].

    "Can be a class symbol..."
    (aType isSymbol and: [ Smalltalk includesKey: aType ])
    ifTrue: [ ^(Smalltalk at: aType) sizeInBytes ].

    ^self error: 'Invalid type in record specification: ',aType asString.!
   
sourceManager
    "Private - Returns the source manager support class."

    ^Smalltalk at: #SourceManager! !



!RenderAXStructure methods !

isInternal: aSymbol
    " Private - Answer true if aSymbol determines a field mantained by engine and must not be stored when downloading.
    By default answer no.
    This can be refined by subclasses."

    ^false!
  
storeMap
    " save/restore - Returns the map to be used to restore the receiver.
    It will be built from fields without pointers. "

    | map aType |
    map := self class accesorsMap
        select: [:tuple|
            (self isInternal: tuple first) not
            and: [ 
                aType := tuple last.
                (aType isSymbol and: [aType first isLowerCase]) "standard selector"
                or: [ aType isNumber ] "stored bytes"
            ]
        ].

    "Obtain data to restore receiver's state."
    map do: [:pair|
        pair
            at: 2 put: (self perform: pair first);
            at: 1 put: (pair first,':') asSymbol;
            yourself
    ].
    ^map    !
   
structurePointedAtOffset: offset put: aRenderAXStructure
    " Private - Sets structure from aRenderAXStructure at offset <offset> in the receiver. "

    self addressAtOffset: offset put: aRenderAXStructure!
 
structurePointedAtOffset: offset type: structureName
    " Private - Answer a structure of type <structureName> from pointer at offset <offset> in the receiver. "

    | aClass address |
    aClass := (structureName isSymbol and: [ Smalltalk includesKey: structureName ])
        ifTrue: [ Smalltalk at: structureName ]
        ifFalse: [ OLEStructure classForStructureNamed: structureName ].
    address := self addressAtOffset: offset.
    address isNil ifTrue: [ ^nil ].
    ^aClass atAddress: address! !



!ExternalRenderAXActor class methods !
  
recordSpecification
    " Private - Returns the record specification. "

    ^#(
        (( flags ) long)
        (( x y height eyeHeight physht adjust halfwit ) singleFloat)
        (( angle actorType sector currentFrame ) long)
        ((    verticalForce velocity
            range "distance they can attack from..."
            ) singleFloat)
        ((     damage damageBase "damage caused = 0 to damage + dambase"
            maxHp currentHp used
            percAttack mood target
            tag    "special tag on actor."
            doType "type we are doing when hit."
            doTag    "hitting this does tag # dotag."
            event    "event number on actor. (calls user event handler)."
            talkEvent
            latMov    "turning rate."
            frames
            number
            mapNumber "what map we are on. We may not need this..."
            ) long)
        (( pLineDef ) (ExternalRenderAXLineDef))
    )!
   
sizeInBytes
    " Private - Answer the size in bytes of the receiver's instances. "
    ^132! !



!ExternalRenderAXActor methods !
   
actorType
    " Generated - Returns the actorType property."

    ^self longAtOffset: 36!

actorType: anObject
    " Generated - Sets the actorType property with anObject."

    ^self longAtOffset: 36 put: anObject!
 
adjust
    " Generated - Returns the adjust property."

    ^self singleFloatAtOffset: 24!
   
adjust: anObject
    " Generated - Sets the adjust property with anObject."

    ^self singleFloatAtOffset: 24 put: anObject!

angle
    " Generated - Returns the angle property."

    ^self longAtOffset: 32!

angle: anObject
    " Generated - Sets the angle property with anObject."

    ^self longAtOffset: 32 put: anObject!
 
currentFrame
    " Generated - Returns the currentFrame property."

    ^self longAtOffset: 44!
  
currentFrame: anObject
    " Generated - Sets the currentFrame property with anObject."

    ^self longAtOffset: 44 put: anObject!
   
currentHp
    " Generated - Returns the currentHp property."

    ^self longAtOffset: 72!

currentHp: anObject
    " Generated - Sets the currentHp property with anObject."

    ^self longAtOffset: 72 put: anObject!
 
damage
    " Generated - Returns the damage property."

    ^self longAtOffset: 60!
  
damage: anObject
    " Generated - Sets the damage property with anObject."

    ^self longAtOffset: 60 put: anObject!
   
damageBase
    " Generated - Returns the damageBase property."

    ^self longAtOffset: 64!
  
damageBase: anObject
    " Generated - Sets the damageBase property with anObject."

    ^self longAtOffset: 64 put: anObject!
   
doTag
    " Generated - Returns the doTag property."

    ^self longAtOffset: 100!
   
doTag: anObject
    " Generated - Sets the doTag property with anObject."

    ^self longAtOffset: 100 put: anObject!

doType
    " Generated - Returns the doType property."

    ^self longAtOffset: 96!
  
doType: anObject
    " Generated - Sets the doType property with anObject."

    ^self longAtOffset: 96 put: anObject!
   
event
    " Generated - Returns the event property."

    ^self longAtOffset: 104!
   
event: anObject
    " Generated - Sets the event property with anObject."

    ^self longAtOffset: 104 put: anObject!

eyeHeight
    " Generated - Returns the eyeHeight property."

    ^self singleFloatAtOffset: 16!
 
eyeHeight: anObject
    " Generated - Sets the eyeHeight property with anObject."

    ^self singleFloatAtOffset: 16 put: anObject!
  
flags
    " Generated - Returns the flags property."

    ^self longAtOffset: 0!
 
flags: anObject
    " Generated - Sets the flags property with anObject."

    ^self longAtOffset: 0 put: anObject!
  
frames
    " Generated - Returns the frames property."

    ^self longAtOffset: 116!
 
frames: anObject
    " Generated - Sets the frames property with anObject."

    ^self longAtOffset: 116 put: anObject!
  
halfwit
    " Generated - Returns the halfwit property."

    ^self singleFloatAtOffset: 28!
 
halfwit: anObject
    " Generated - Sets the halfwit property with anObject."

    ^self singleFloatAtOffset: 28 put: anObject!
  
height
    " Generated - Returns the height property."

    ^self singleFloatAtOffset: 12!
   
height: anObject
    " Generated - Sets the height property with anObject."

    ^self singleFloatAtOffset: 12 put: anObject!

latMov
    " Generated - Returns the latMov property."

    ^self longAtOffset: 112!
 
latMov: anObject
    " Generated - Sets the latMov property with anObject."

    ^self longAtOffset: 112 put: anObject!
  
mapNumber
    " Generated - Returns the mapNumber property."

    ^self longAtOffset: 124!
   
mapNumber: anObject
    " Generated - Sets the mapNumber property with anObject."

    ^self longAtOffset: 124 put: anObject!

maxHp
    " Generated - Returns the maxHp property."

    ^self longAtOffset: 68!

maxHp: anObject
    " Generated - Sets the maxHp property with anObject."

    ^self longAtOffset: 68 put: anObject!
 
mood
    " Generated - Returns the mood property."

    ^self longAtOffset: 84!
  
mood: anObject
    " Generated - Sets the mood property with anObject."

    ^self longAtOffset: 84 put: anObject!
   
number
    " Generated - Returns the number property."

    ^self longAtOffset: 120!
 
number: anObject
    " Generated - Sets the number property with anObject."

    ^self longAtOffset: 120 put: anObject!
  
percAttack
    " Generated - Returns the percAttack property."

    ^self longAtOffset: 80!
  
percAttack: anObject
    " Generated - Sets the percAttack property with anObject."

    ^self longAtOffset: 80 put: anObject!
   
physht
    " Generated - Returns the physht property."

    ^self singleFloatAtOffset: 20!
   
physht: anObject
    " Generated - Sets the physht property with anObject."

    ^self singleFloatAtOffset: 20 put: anObject!

pLineDef
    " Generated - Returns the pLineDef property (as a ByteArray)."

    ^self structurePointedAtOffset: 128 type: #ExternalRenderAXLineDef!
 
range
    " Generated - Returns the range property."

    ^self singleFloatAtOffset: 56!
 
range: anObject
    " Generated - Sets the range property with anObject."

    ^self singleFloatAtOffset: 56 put: anObject!
  
sector
    " Generated - Returns the sector property."

    ^self longAtOffset: 40!
  
sector: anObject
    " Generated - Sets the sector property with anObject."

    ^self longAtOffset: 40 put: anObject!
   
tag
    " Generated - Returns the tag property."

    ^self longAtOffset: 92!

tag: anObject
    " Generated - Sets the tag property with anObject."

    ^self longAtOffset: 92 put: anObject!
 
talkEvent
    " Generated - Returns the talkEvent property."

    ^self longAtOffset: 108!
   
talkEvent: anObject
    " Generated - Sets the talkEvent property with anObject."

    ^self longAtOffset: 108 put: anObject!

target
    " Generated - Returns the target property."

    ^self longAtOffset: 88!
  
target: anObject
    " Generated - Sets the target property with anObject."

    ^self longAtOffset: 88 put: anObject!
   
used
    " Generated - Returns the used property."

    ^self longAtOffset: 76!
  
used: anObject
    " Generated - Sets the used property with anObject."

    ^self longAtOffset: 76 put: anObject!
   
velocity
    " Generated - Returns the velocity property."

    ^self singleFloatAtOffset: 52!
   
velocity: anObject
    " Generated - Sets the velocity property with anObject."

    ^self singleFloatAtOffset: 52 put: anObject!

verticalForce
    " Generated - Returns the verticalForce property."

    ^self singleFloatAtOffset: 48!
 
verticalForce: anObject
    " Generated - Sets the verticalForce property with anObject."

    ^self singleFloatAtOffset: 48 put: anObject!
  
x
    " Generated - Returns the x property."

    ^self singleFloatAtOffset: 4!
  
x: anObject
    " Generated - Sets the x property with anObject."

    ^self singleFloatAtOffset: 4 put: anObject!
   
y
    " Generated - Returns the y property."

    ^self singleFloatAtOffset: 8!
  
y: anObject
    " Generated - Sets the y property with anObject."

    ^self singleFloatAtOffset: 8 put: anObject! !



!ExternalRenderAXLineDef class methods !
 
recordSpecification
    " Private - Returns the record specification. "

    ^#(
        (( fromVert toVert ) long) "vertex this line comes from/to. If you change a vertex, you must recalc the line."
        ((    x1 y1 x2 y2 "Coordinates of the line. Saved here just for speed."
            dx dy    "deltaxy of the line(it's vector.xy"
            rx1 ry1 rx2 ry2 "Generated by engine No Need to modify"
            cos sine
            length
            distance    "average distance to viewer. Regenerated by renderer"
            temp1 temp2 temp3 temp4) singleFloat)
        ((    doType    "type we are doing when hit."
            doTag    "hitting this does tag # dotag."
            sector    "the sector number that this contains"
            facing    "the sector number that this is facing"
            texture
            flags
            lineNumber
            tripFlags
            trip1 trip2 trip3 trip4 "misc values for different trip wires."
            texture2    "the second texture for this wall - when it is switched"
            topTexture topTexture2 "the textures for the 'top slice'."
            ltype    "flags for line type."
            startCollumn stopCollumn ) long)
        (( nextLine) (ExternalRenderAXLineDef))
        (( unused ) long)
    )!

sizeInBytes
    " Private - Answer the size in bytes of the receiver's instances. "
    ^160! !



!ExternalRenderAXLineDef methods !
 
cos
    " Generated - Returns the cos property."

    ^self singleFloatAtOffset: 48!
 
cos: anObject
    " Generated - Sets the cos property with anObject."

    ^self singleFloatAtOffset: 48 put: anObject!
  
destination
    "Returns the receiver's destination position."

    ^self x2 @ self y2!
  
destination: aPoint
    "Sets the receiver's destination position."

    self
        x2: aPoint x asFloat;
        y2: aPoint y asFloat!
  
distance
    " Generated - Returns the distance property."

    ^self singleFloatAtOffset: 60!
   
distance: anObject
    " Generated - Sets the distance property with anObject."

    ^self singleFloatAtOffset: 60 put: anObject!

doTag
    " Generated - Returns the doTag property."

    ^self longAtOffset: 84!

doTag: anObject
    " Generated - Sets the doTag property with anObject."

    ^self longAtOffset: 84 put: anObject!
 
doType
    " Generated - Returns the doType property."

    ^self longAtOffset: 80!
  
doType: anObject
    " Generated - Sets the doType property with anObject."

    ^self longAtOffset: 80 put: anObject!
   
dx
    " Generated - Returns the dx property."

    ^self singleFloatAtOffset: 24!
   
dx: anObject
    " Generated - Sets the dx property with anObject."

    ^self singleFloatAtOffset: 24 put: anObject!

dy
    " Generated - Returns the dy property."

    ^self singleFloatAtOffset: 28!
   
dy: anObject
    " Generated - Sets the dy property with anObject."

    ^self singleFloatAtOffset: 28 put: anObject!

facing
    " Generated - Returns the facing property."

    ^self longAtOffset: 92!
  
facing: anObject
    " Generated - Sets the facing property with anObject."

    ^self longAtOffset: 92 put: anObject!
   
flags
    " Generated - Returns the flags property."

    ^self longAtOffset: 100!
   
flags: anObject
    " Generated - Sets the flags property with anObject."

    ^self longAtOffset: 100 put: anObject!

fromVert
    " Generated - Returns the fromVert property."

    ^self longAtOffset: 0!
   
fromVert: anObject
    " Generated - Sets the fromVert property with anObject."

    ^self longAtOffset: 0 put: anObject!

isInternal: aSymbol
    " Private - Answer true if aSymbol determines a field mantained by engine and must not be stored when downloading."

    ^(super isInternal: aSymbol)
    or: [
        #(    x1 y1 x2 y2 dx dy
            rx1 ry1 rx2 ry2
            cos sine length
            distance temp1 temp2 temp3 temp4
            startCollumn stopCollumn
        ) includes: aSymbol
    ]!
 
length
    " Generated - Returns the length property."

    ^self singleFloatAtOffset: 56!
   
length: anObject
    " Generated - Sets the length property with anObject."

    ^self singleFloatAtOffset: 56 put: anObject!

lineNumber
    " Generated - Returns the lineNumber property."

    ^self longAtOffset: 104!
 
lineNumber: anObject
    " Generated - Sets the lineNumber property with anObject."

    ^self longAtOffset: 104 put: anObject!
  
ltype
    " Generated - Returns the ltype property."

    ^self longAtOffset: 140!
   
ltype: anObject
    " Generated - Sets the ltype property with anObject."

    ^self longAtOffset: 140 put: anObject!

nextLine
    " Generated - Returns the nextLine property (as a ByteArray)."

    ^self structurePointedAtOffset: 152 type: #ExternalRenderAXLineDef!
 
nextLine: aPointer
    " Generated - Sets the nextLine property with aPointer."

    ^self structurePointedAtOffset: 152 put: aPointer!
  
origin
    "Returns the receiver's origin position."

    ^self x1 @ self y1!

origin: aPoint
    "Sets the receiver's origin position."

    self
        x1: aPoint x asFloat;
        y1: aPoint y asFloat!

rx1
    " Generated - Returns the rx1 property."

    ^self singleFloatAtOffset: 32!
 
rx1: anObject
    " Generated - Sets the rx1 property with anObject."

    ^self singleFloatAtOffset: 32 put: anObject!
  
rx2
    " Generated - Returns the rx2 property."

    ^self singleFloatAtOffset: 40!
 
rx2: anObject
    " Generated - Sets the rx2 property with anObject."

    ^self singleFloatAtOffset: 40 put: anObject!
  
ry1
    " Generated - Returns the ry1 property."

    ^self singleFloatAtOffset: 36!
 
ry1: anObject
    " Generated - Sets the ry1 property with anObject."

    ^self singleFloatAtOffset: 36 put: anObject!
  
ry2
    " Generated - Returns the ry2 property."

    ^self singleFloatAtOffset: 44!
 
ry2: anObject
    " Generated - Sets the ry2 property with anObject."

    ^self singleFloatAtOffset: 44 put: anObject!
  
sector
    " Generated - Returns the sector property."

    ^self longAtOffset: 88!
  
sector: anObject
    " Generated - Sets the sector property with anObject."

    ^self longAtOffset: 88 put: anObject!
   
sine
    " Generated - Returns the sine property."

    ^self singleFloatAtOffset: 52!
   
sine: anObject
    " Generated - Sets the sine property with anObject."

    ^self singleFloatAtOffset: 52 put: anObject!

startCollumn
    " Generated - Returns the startCollumn property."

    ^self longAtOffset: 144!
 
startCollumn: anObject
    " Generated - Sets the startCollumn property with anObject."

    ^self longAtOffset: 144 put: anObject!
  
stopCollumn
    " Generated - Returns the stopCollumn property."

    ^self longAtOffset: 148!
   
stopCollumn: anObject
    " Generated - Sets the stopCollumn property with anObject."

    ^self longAtOffset: 148 put: anObject!

temp1
    " Generated - Returns the temp1 property."

    ^self singleFloatAtOffset: 64!
 
temp1: anObject
    " Generated - Sets the temp1 property with anObject."

    ^self singleFloatAtOffset: 64 put: anObject!
  
temp2
    " Generated - Returns the temp2 property."

    ^self singleFloatAtOffset: 68!
 
temp2: anObject
    " Generated - Sets the temp2 property with anObject."

    ^self singleFloatAtOffset: 68 put: anObject!
  
temp3
    " Generated - Returns the temp3 property."

    ^self singleFloatAtOffset: 72!
 
temp3: anObject
    " Generated - Sets the temp3 property with anObject."

    ^self singleFloatAtOffset: 72 put: anObject!
  
temp4
    " Generated - Returns the temp4 property."

    ^self singleFloatAtOffset: 76!
 
temp4: anObject
    " Generated - Sets the temp4 property with anObject."

    ^self singleFloatAtOffset: 76 put: anObject!
  
texture
    " Generated - Returns the texture property."

    ^self longAtOffset: 96!

texture: anObject
    " Generated - Sets the texture property with anObject."

    ^self longAtOffset: 96 put: anObject!
 
texture2
    " Generated - Returns the texture2 property."

    ^self longAtOffset: 128!
 
texture2: anObject
    " Generated - Sets the texture2 property with anObject."

    ^self longAtOffset: 128 put: anObject!
  
topTexture
    " Generated - Returns the topTexture property."

    ^self longAtOffset: 132!
 
topTexture: anObject
    " Generated - Sets the topTexture property with anObject."

    ^self longAtOffset: 132 put: anObject!
  
topTexture2
    " Generated - Returns the topTexture2 property."

    ^self longAtOffset: 136!
   
topTexture2: anObject
    " Generated - Sets the topTexture2 property with anObject."

    ^self longAtOffset: 136 put: anObject!

toVert
    " Generated - Returns the toVert property."

    ^self longAtOffset: 4!
   
toVert: anObject
    " Generated - Sets the toVert property with anObject."

    ^self longAtOffset: 4 put: anObject!

trip1
    " Generated - Returns the trip1 property."

    ^self longAtOffset: 112!
   
trip1: anObject
    " Generated - Sets the trip1 property with anObject."

    ^self longAtOffset: 112 put: anObject!

trip2
    " Generated - Returns the trip2 property."

    ^self longAtOffset: 116!
   
trip2: anObject
    " Generated - Sets the trip2 property with anObject."

    ^self longAtOffset: 116 put: anObject!

trip3
    " Generated - Returns the trip3 property."

    ^self longAtOffset: 120!
   
trip3: anObject
    " Generated - Sets the trip3 property with anObject."

    ^self longAtOffset: 120 put: anObject!

trip4
    " Generated - Returns the trip4 property."

    ^self longAtOffset: 124!
   
trip4: anObject
    " Generated - Sets the trip4 property with anObject."

    ^self longAtOffset: 124 put: anObject!

tripFlags
    " Generated - Returns the tripFlags property."

    ^self longAtOffset: 108!
   
tripFlags: anObject
    " Generated - Sets the tripFlags property with anObject."

    ^self longAtOffset: 108 put: anObject!

unused
    " Generated - Returns the unused property."

    ^self longAtOffset: 156!
 
unused: anObject
    " Generated - Sets the unused property with anObject."

    ^self longAtOffset: 156 put: anObject!
  
x1
    " Generated - Returns the x1 property."

    ^self singleFloatAtOffset: 8!

x1: anObject
    " Generated - Sets the x1 property with anObject."

    ^self singleFloatAtOffset: 8 put: anObject!
 
x2
    " Generated - Returns the x2 property."

    ^self singleFloatAtOffset: 16!
   
x2: anObject
    " Generated - Sets the x2 property with anObject."

    ^self singleFloatAtOffset: 16 put: anObject!

y1
    " Generated - Returns the y1 property."

    ^self singleFloatAtOffset: 12!
   
y1: anObject
    " Generated - Sets the y1 property with anObject."

    ^self singleFloatAtOffset: 12 put: anObject!

y2
    " Generated - Returns the y2 property."

    ^self singleFloatAtOffset: 20!
   
y2: anObject
    " Generated - Sets the y2 property with anObject."

    ^self singleFloatAtOffset: 20 put: anObject! !



!ExternalRenderAXMetaTexture class methods !
  
recordSpecification
    " Private - Returns the record specification. "

    ^#(
        (( height width numPatches hMask wMask number ) long)
        (( hf wf ) singleFloat)
        (( patchArray ) (64 (RenderAXPatch)))
    )!
  
sizeInBytes
    " Private - Answer the size in bytes of the receiver's instances. "
    ^288! !



!ExternalRenderAXMetaTexture methods !
 
height
    " Generated - Returns the height property."

    ^self longAtOffset: 0!
   
height: anObject
    " Generated - Sets the height property with anObject."

    ^self longAtOffset: 0 put: anObject!

hf
    " Generated - Returns the hf property."

    ^self singleFloatAtOffset: 24!
   
hf: anObject
    " Generated - Sets the hf property with anObject."

    ^self singleFloatAtOffset: 24 put: anObject!

hMask
    " Generated - Returns the hMask property."

    ^self longAtOffset: 12!

hMask: anObject
    " Generated - Sets the hMask property with anObject."

    ^self longAtOffset: 12 put: anObject!
 
number
    " Generated - Returns the number property."

    ^self longAtOffset: 20!
  
number: anObject
    " Generated - Sets the number property with anObject."

    ^self longAtOffset: 20 put: anObject!
   
numPatches
    " Generated - Returns the numPatches property."

    ^self longAtOffset: 8!
   
numPatches: anObject
    " Generated - Sets the numPatches property with anObject."

    ^self longAtOffset: 8 put: anObject!

patchAt: index
    "Returns the patch array at index."

    (index between: 1 and: MaxPatches) ifFalse: [ self error: 'Invalid Patch Index' ].
    ^self
        structurePointedAtOffset: index - 1 * 4 + 32
        type: #ExternalRenderAXPatch!
   
wf
    " Generated - Returns the wf property."

    ^self singleFloatAtOffset: 28!
   
wf: anObject
    " Generated - Sets the wf property with anObject."

    ^self singleFloatAtOffset: 28 put: anObject!

width
    " Generated - Returns the width property."

    ^self longAtOffset: 4!
 
width: anObject
    " Generated - Sets the width property with anObject."

    ^self longAtOffset: 4 put: anObject!
  
wMask
    " Generated - Returns the wMask property."

    ^self longAtOffset: 16!

wMask: anObject
    " Generated - Sets the wMask property with anObject."

    ^self longAtOffset: 16 put: anObject! !



!ExternalRenderAXPatch class methods !
 
recordSpecification
    " Private - Returns the record specification. "

    ^#(
        (( x y w h ) long)
        (( buffer ) address)
        (( bitmapNo ) long)
    )!
  
sizeInBytes
    " Private - Answer the size in bytes of the receiver's instances. "
    ^24! !



!ExternalRenderAXPatch methods !

bitmapNo
    " Generated - Returns the bitmapNo property."

    ^self longAtOffset: 20!
  
bitmapNo: anObject
    " Generated - Sets the bitmapNo property with anObject."

    ^self longAtOffset: 20 put: anObject!
   
buffer
    " Generated - Returns the buffer property."

    ^self addressAtOffset: 16!
   
buffer: anObject
    " Generated - Sets the buffer property with anObject."

    ^self addressAtOffset: 16 put: anObject!

h
    " Generated - Returns the h property."

    ^self longAtOffset: 12!

h: anObject
    " Generated - Sets the h property with anObject."

    ^self longAtOffset: 12 put: anObject!
 
w
    " Generated - Returns the w property."

    ^self longAtOffset: 8!
 
w: anObject
    " Generated - Sets the w property with anObject."

    ^self longAtOffset: 8 put: anObject!
  
x
    " Generated - Returns the x property."

    ^self longAtOffset: 0!
 
x: anObject
    " Generated - Sets the x property with anObject."

    ^self longAtOffset: 0 put: anObject!
  
y
    " Generated - Returns the y property."

    ^self longAtOffset: 4!
 
y: anObject
    " Generated - Sets the y property with anObject."

    ^self longAtOffset: 4 put: anObject! !



!ExternalRenderAXSector class methods !
 
recordSpecification
    " Private - Returns the record specification. "

    ^#(
        (( number
            floorTX ceilTX
            underTX ) long)
        (( floorht ceilht underht htOffset ) singleFloat)
        (( flags
            xaFloor yaFloor
            xaCeil yaCeil
            tx ty bx by
            lightlevel tag
            tripFlags
            swing ) long)
        (( firstl lastl ) (ExternalRenderAXLineDef))
        (( unused ) long)
    )!

sizeInBytes
    " Private - Answer the size in bytes of the receiver's instances. "
    ^96! !



!ExternalRenderAXSector methods !
   
bx
    " Generated - Returns the bx property."

    ^self longAtOffset: 60!
  
bx: anObject
    " Generated - Sets the bx property with anObject."

    ^self longAtOffset: 60 put: anObject!
   
by
    " Generated - Returns the by property."

    ^self longAtOffset: 64!
  
by: anObject
    " Generated - Sets the by property with anObject."

    ^self longAtOffset: 64 put: anObject!
   
ceilht
    " Generated - Returns the ceilht property."

    ^self singleFloatAtOffset: 20!
   
ceilht: anObject
    " Generated - Sets the ceilht property with anObject."

    ^self singleFloatAtOffset: 20 put: anObject!

ceilTX
    " Generated - Returns the ceilTX property."

    ^self longAtOffset: 8!
   
ceilTX: anObject
    " Generated - Sets the ceilTX property with anObject."

    ^self longAtOffset: 8 put: anObject!

firstl
    " Generated - Returns the firstl property (as a ByteArray)."

    ^self structurePointedAtOffset: 84 type: #ExternalRenderAXLineDef!
  
firstl: aPointer
    " Generated - Sets the firstl property with aPointer."

    ^self structurePointedAtOffset: 84 put: aPointer!
   
flags
    " Generated - Returns the flags property."

    ^self longAtOffset: 32!

flags: anObject
    " Generated - Sets the flags property with anObject."

    ^self longAtOffset: 32 put: anObject!
 
floorht
    " Generated - Returns the floorht property."

    ^self singleFloatAtOffset: 16!
 
floorht: anObject
    " Generated - Sets the floorht property with anObject."

    ^self singleFloatAtOffset: 16 put: anObject!
  
floorTX
    " Generated - Returns the floorTX property."

    ^self longAtOffset: 4!
 
floorTX: anObject
    " Generated - Sets the floorTX property with anObject."

    ^self longAtOffset: 4 put: anObject!
  
htOffset
    " Generated - Returns the htOffset property."

    ^self singleFloatAtOffset: 28!
   
htOffset: anObject
    " Generated - Sets the htOffset property with anObject."

    ^self singleFloatAtOffset: 28 put: anObject!

lastl
    " Generated - Returns the lastl property (as a ByteArray)."

    ^self structurePointedAtOffset: 88 type: #ExternalRenderAXLineDef!

lastl: aPointer
    " Generated - Sets the lastl property with aPointer."

    ^self structurePointedAtOffset: 88 put: aPointer!
 
lightlevel
    " Generated - Returns the lightlevel property."

    ^self longAtOffset: 68!
  
lightlevel: anObject
    " Generated - Sets the lightlevel property with anObject."

    ^self longAtOffset: 68 put: anObject!
   
number
    " Generated - Returns the number property."

    ^self longAtOffset: 0!
   
number: anObject
    " Generated - Sets the number property with anObject."

    ^self longAtOffset: 0 put: anObject!

swing
    " Generated - Returns the swing property."

    ^self longAtOffset: 80!

swing: anObject
    " Generated - Sets the swing property with anObject."

    ^self longAtOffset: 80 put: anObject!
 
tag
    " Generated - Returns the tag property."

    ^self longAtOffset: 72!

tag: anObject
    " Generated - Sets the tag property with anObject."

    ^self longAtOffset: 72 put: anObject!
 
tripFlags
    " Generated - Returns the tripFlags property."

    ^self longAtOffset: 76!

tripFlags: anObject
    " Generated - Sets the tripFlags property with anObject."

    ^self longAtOffset: 76 put: anObject!
 
tx
    " Generated - Returns the tx property."

    ^self longAtOffset: 52!
  
tx: anObject
    " Generated - Sets the tx property with anObject."

    ^self longAtOffset: 52 put: anObject!
   
ty
    " Generated - Returns the ty property."

    ^self longAtOffset: 56!
  
ty: anObject
    " Generated - Sets the ty property with anObject."

    ^self longAtOffset: 56 put: anObject!
   
underht
    " Generated - Returns the underht property."

    ^self singleFloatAtOffset: 24!
 
underht: anObject
    " Generated - Sets the underht property with anObject."

    ^self singleFloatAtOffset: 24 put: anObject!
  
underTX
    " Generated - Returns the underTX property."

    ^self longAtOffset: 12!

underTX: anObject
    " Generated - Sets the underTX property with anObject."

    ^self longAtOffset: 12 put: anObject!
 
unused
    " Generated - Returns the unused property."

    ^self longAtOffset: 92!
  
unused: anObject
    " Generated - Sets the unused property with anObject."

    ^self longAtOffset: 92 put: anObject!
   
xaCeil
    " Generated - Returns the xaCeil property."

    ^self longAtOffset: 44!
  
xaCeil: anObject
    " Generated - Sets the xaCeil property with anObject."

    ^self longAtOffset: 44 put: anObject!
   
xaFloor
    " Generated - Returns the xaFloor property."

    ^self longAtOffset: 36!

xaFloor: anObject
    " Generated - Sets the xaFloor property with anObject."

    ^self longAtOffset: 36 put: anObject!
 
yaCeil
    " Generated - Returns the yaCeil property."

    ^self longAtOffset: 48!
  
yaCeil: anObject
    " Generated - Sets the yaCeil property with anObject."

    ^self longAtOffset: 48 put: anObject!
   
yaFloor
    " Generated - Returns the yaFloor property."

    ^self longAtOffset: 40!

yaFloor: anObject
    " Generated - Sets the yaFloor property with anObject."

    ^self longAtOffset: 40 put: anObject! !



!ExternalRenderAXVertex class methods !

recordSpecification
    " Private - Returns the record specification. "

    ^#(
        (( x y ) singleFloat) "Notice: X & Y are actual integers."

        "Following are for system use only..."
        ((    nx ny    "normalized XY (xy - players xy)"
            rx ry     "after rotating into current view"
            startX startY    "Save xy - for use when unrotating."
            ) singleFloat)
    )!

sizeInBytes
    " Private - Answer the size in bytes of the receiver's instances. "
    ^32! !



!ExternalRenderAXVertex methods !
   
isInternal: aSymbol
    " Private - Answer true if aSymbol determines a field mantained by engine and must not be stored when downloading."

    ^(super isInternal: aSymbol)
    or: [
        #(    nx ny rx ry
            startX startY 
        ) includes: aSymbol
    ]!
 
nx
    " Generated - Returns the nx property."

    ^self singleFloatAtOffset: 8!

nx: anObject
    " Generated - Sets the nx property with anObject."

    ^self singleFloatAtOffset: 8 put: anObject!
 
ny
    " Generated - Returns the ny property."

    ^self singleFloatAtOffset: 12!
   
ny: anObject
    " Generated - Sets the ny property with anObject."

    ^self singleFloatAtOffset: 12 put: anObject!

rx
    " Generated - Returns the rx property."

    ^self singleFloatAtOffset: 16!
   
rx: anObject
    " Generated - Sets the rx property with anObject."

    ^self singleFloatAtOffset: 16 put: anObject!

ry
    " Generated - Returns the ry property."

    ^self singleFloatAtOffset: 20!
   
ry: anObject
    " Generated - Sets the ry property with anObject."

    ^self singleFloatAtOffset: 20 put: anObject!

startX
    " Generated - Returns the startX property."

    ^self singleFloatAtOffset: 24!
   
startX: anObject
    " Generated - Sets the startX property with anObject."

    ^self singleFloatAtOffset: 24 put: anObject!

startY
    " Generated - Returns the startY property."

    ^self singleFloatAtOffset: 28!
   
startY: anObject
    " Generated - Sets the startY property with anObject."

    ^self singleFloatAtOffset: 28 put: anObject!

x
    " Generated - Returns the x property."

    ^self singleFloatAtOffset: 0!
  
x: anObject
    " Generated - Sets the x property with anObject."

    ^self singleFloatAtOffset: 0 put: anObject!
   
y
    " Generated - Returns the y property."

    ^self singleFloatAtOffset: 4!
  
y: anObject
    " Generated - Sets the y property with anObject."

    ^self singleFloatAtOffset: 4 put: anObject! !



!RenderAXSingle class methods !
  
recordSpecification
    " Private - Returns the record specification. "

    ^#(
        (( value ) singleFloat)
    )!

sizeInBytes
    " Private - Answer the size in bytes of the receiver's instances. "
    ^4! !



!RenderAXSingle methods !

value
    " Generated - Returns the value property."

    ^self singleFloatAtOffset: 0!
  
value: anObject
    " Generated - Sets the value property with anObject."

    ^self singleFloatAtOffset: 0 put: anObject! !


! GraphicInspector methods !
createView
        "Private - create the panes for the receiver window.
    Touched by Ale for mouse location report..."
    | pane |
    #modifiedByOStyle.
    self addSubpane:
        ( ( pane := GraphPane new )
            setName: #graphicInstance: ;
            when: #display send: #graphicInstance: to: self with: pane;
            when: #button1Down send: #setFocus to: pane;
            when: #button1Moved send: #mouseMoved: to: self with: pane;
            when: #button2Moved send: #mouseZoom: to: self with: pane;
            framingRatio:
                ( ( Rectangle leftTopUnit rightAndDown: ( 1/3 @ 0 ) )
                    extentFromLeftTop: 2/3 @ 1 ) ).
	self mainView when: #activated send: #update to: pane.
    super createView!
mouseMoved: aPane
    "Private - Display the mouse coordinates in the label."

    #addedByOStyle.
    self label: 'Inspecting: ', object class printString,' [',aPane mouseLocation asString,']'!
mouseZoom: aGraphPane
    "Private - Zoom the receiver to current mouse location."

    | i pen var location destination |
    instIndex isNil ifTrue: [ ^nil ].
	destination := 0@0 extent: aGraphPane mouseLocation.
	(destination width > 0 and: [destination height > 0]) ifFalse: [ ^self ].
	
    pen := aGraphPane pen.
    (pen boundingBox nonIntersections: destination)
	do: [:box| pen blank: box ].

    instIndex = 1
        ifTrue: [ var := object ]
        ifFalse: [
            ( i := self getInstVarIndex ) ~= 0
            ifTrue: [ var := object instVarAt: i ]
		].
    ( self isGraphicObject: var ) ifFalse: [^self ].

	(var respondsTo: #pen)
	ifTrue: [
		pen
			copy: var pen
			from: var boundingBox
			to: destination
	]
	ifFalse: [
		(var respondsTo: #displayWith:from:to:)
		ifTrue: [ var displayWith: pen from: var boundingBox to: destination ].
	].! !

! GDIDLL methods !
stretchDIBits: hDC
    xDest: anInt1 yDest: anInt2
    cxDest: anInt3 cyDest: anInt4
    xSrc: anInt5 ySrc: anInt6
    cxSrc: anInt7 cySrc: anInt8
    bitsPtr: bits bmi: bmi
    colorUse: anInt9 rop:rop
    <api: StretchDIBits ulong long long long long long long long long ulong struct ulong ulong long>
    ^self invalidArgument! !